var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "../../_generated/BladeReferences", "Fx/Composition/Pdl/MenuBlade"], function (require, exports, BladeReferences, FxMenuBlade) {
    "use strict";
    var FxImages = MsPortalFx.Base.Images;
    "use strict";
    var AdminBillingMenuBladeViewModel = (function (_super) {
        __extends(AdminBillingMenuBladeViewModel, _super);
        function AdminBillingMenuBladeViewModel(container, initialState, dataContext) {
            _super.call(this, container);
            this.subscriptionId = ko.observable();
            this.rpAssetId = ko.observable();
            this.location = ko.observable("unknown");
            this.isAzSQuotaCollectorEnabled = ko.observable(false);
            this.showOnlyAzureStackQuotaBlades = ko.observable(false);
            this.title("...");
            this.icon(MsPortalFx.Base.Images.Polychromatic.VirtualMachine());
            this._dataContext = dataContext;
            this._enabledFeaturesEntityView = this._dataContext.sharedContext.licenseDataManager.enabledFeaturesEntity.createView(container, {
                interceptNotFound: false
            });
            this.menu.groups([]);
            this.menu.groupSortOrder = 0;
            this.menu.groupSortFunction = FxMenuBlade.SortFunction.SupportFirst;
        }
        AdminBillingMenuBladeViewModel.prototype.onInputsSet = function (inputs) {
            var _this = this;
            this.title("Usage & Billing");
            return this._dataContext.subscriptionsManager.adminSubscriptionsPromise.then(function (adminSubs) {
                var adminSubscription = adminSubs[0];
                var subscriptionId = adminSubscription.subscriptionId;
                _this.subscriptionId(subscriptionId);
                var args = {
                    subscriptionId: subscriptionId,
                    location: _this.location(),
                };
                var rpNamespace = 'CloudAssert.Billing.Admin';
                return _this._dataContext.subscriptionsManager.getRpManifestForNamespace(subscriptionId, rpNamespace).then(function (rpManifestDef) {
                    var props = rpManifestDef.properties;
                    _this.location(props.providerLocation);
                    _this.subtitle(_this.location());
                    _this.rpAssetId({
                        id: rpManifestDef.id,
                        location: props.providerLocation,
                        namespace: rpNamespace,
                        subscriptionId: subscriptionId,
                        displayName: props.displayName,
                        resourceGroupName: 'unknown'
                    });
                    _this._enabledFeaturesEntityView.fetch(args).then(function () {
                        var dataEntity = _this._enabledFeaturesEntityView.item();
                        if (dataEntity.Settings()["IsAzureStackQuotaCollectorAvailable"] != undefined
                            && dataEntity.Settings()["IsAzureStackQuotaCollectorAvailable"]() == "True") {
                            _this.isAzSQuotaCollectorEnabled(true);
                        }
                        else {
                            _this.isAzSQuotaCollectorEnabled(false);
                        }
                        if (dataEntity.Settings()["ShowOnlyAzureStackQuotaBlades"] != undefined
                            && dataEntity.Settings()["ShowOnlyAzureStackQuotaBlades"]() == "True") {
                            _this.showOnlyAzureStackQuotaBlades(true);
                        }
                        else {
                            _this.showOnlyAzureStackQuotaBlades(false);
                        }
                        _this._initMenuGroups();
                    });
                });
            });
        };
        AdminBillingMenuBladeViewModel.prototype._initMenuGroups = function () {
            var _this = this;
            var menuGroups = [
                {
                    id: "general",
                    displayText: "General",
                    items: [
                        {
                            id: "Settings",
                            displayText: "Settings",
                            icon: FxImages.Polychromatic.Gear(),
                            supplyBladeReference: function () {
                                return new BladeReferences.SettingsBladeReference({
                                    parameters: {
                                        subscriptionId: _this.subscriptionId(),
                                        location: _this.location()
                                    }
                                });
                            }
                        },
                        {
                            id: "PricingProfiles",
                            displayText: "Pricing Profiles",
                            icon: FxImages.Polychromatic.Advisor(),
                            supplyBladeReference: function () {
                                return new BladeReferences.PricingProfileBladeReference({
                                    parameters: {
                                        subscriptionId: _this.subscriptionId(),
                                        location: _this.location()
                                    }
                                });
                            }
                        },
                        {
                            id: "UsageHistory",
                            displayText: "Usage History",
                            icon: FxImages.Polychromatic.Clock(),
                            supplyBladeReference: function () {
                                return new BladeReferences.UsageHistoryGridBladeReference({
                                    subscriptionId: _this.subscriptionId(),
                                    location: _this.location(),
                                });
                            }
                        },
                        {
                            id: "Invoices",
                            displayText: "Invoices",
                            icon: FxImages.Polychromatic.OperationalInsights(),
                            supplyBladeReference: function () {
                                return new BladeReferences.InvoicesCollectionBladeReference({
                                    adminSubscriptionId: _this.subscriptionId(),
                                    location: _this.location(),
                                });
                            }
                        },
                        {
                            id: "UserCredits",
                            displayText: "User Credits",
                            icon: MsPortalFx.Base.Images.Person(),
                            supplyBladeReference: function () {
                                return new BladeReferences.UserCreditsCollectionBladeReference({
                                    adminSubscriptionId: _this.subscriptionId(),
                                    location: _this.location(),
                                });
                            }
                        },
                        {
                            id: "Quotas",
                            displayText: "Quotas",
                            icon: FxImages.Polychromatic.Scale(),
                            supplyBladeReference: function () {
                                return new BladeReferences.QuotaCollectionBladeReference({
                                    adminSubscriptionId: _this.subscriptionId(),
                                    location: _this.location(),
                                });
                            }
                        },
                    ]
                },
                {
                    id: "UsageAndQuota",
                    displayText: "Usage + Quota",
                    items: [
                        {
                            id: "QuotaStatus",
                            displayText: "Overview",
                            icon: FxImages.Polychromatic.OperationalInsights(),
                            supplyBladeReference: function () {
                                return new BladeReferences.UsageAndQuotaStatusBladeReference({
                                    subscriptionId: _this.subscriptionId(),
                                    location: _this.location(),
                                });
                            }
                        },
                        {
                            id: "MonthlySummary",
                            displayText: "Monthly Summary",
                            icon: FxImages.Polychromatic.ControlsHorizontal(),
                            supplyBladeReference: function () {
                                return new BladeReferences.UsageAndQuotaSnapInBladeReference({
                                    subscriptionId: _this.subscriptionId(),
                                    location: _this.location(),
                                });
                            }
                        },
                        {
                            id: "TrendReport",
                            displayText: "Trend Report",
                            icon: FxImages.Polychromatic.Chart(),
                            supplyBladeReference: function () {
                                return new BladeReferences.UsageAndQuotaTrendBladeReference({
                                    subscriptionId: _this.subscriptionId(),
                                    location: _this.location(),
                                });
                            }
                        },
                    ]
                },
                {
                    id: "Csp",
                    displayText: "CSP",
                    items: [
                        {
                            id: "CustomerProfileRequests",
                            displayText: "Customer Profile Requests",
                            icon: FxImages.Polychromatic.CloudService(),
                            supplyBladeReference: function () {
                                return new BladeReferences.CspCustomerProfileRequestGridViewModelReference({
                                    subscriptionId: _this.subscriptionId(),
                                    location: _this.location(),
                                });
                            }
                        },
                    ]
                },
                {
                    id: "Notifications",
                    displayText: "Notifications",
                    items: [
                        {
                            id: "Messages",
                            displayText: "Messages",
                            icon: FxImages.Message(),
                            supplyBladeReference: function () {
                                return new BladeReferences.NotificationMessagesBladeReference({
                                    subscriptionId: _this.subscriptionId(),
                                    location: _this.location(),
                                });
                            }
                        },
                        {
                            id: "Rules",
                            displayText: "Rules",
                            icon: FxImages.Tasks(),
                            supplyBladeReference: function () {
                                return new BladeReferences.NotificationRulesBladeReference({
                                    subscriptionId: _this.subscriptionId(),
                                    location: _this.location(),
                                });
                            }
                        },
                    ]
                },
                {
                    id: "Status",
                    displayText: "Status",
                    items: [
                        {
                            id: "UsageStatus",
                            displayText: "Usage Status",
                            icon: FxImages.Polychromatic.Monitoring(),
                            supplyBladeReference: function () {
                                return new BladeReferences.UsageProcessingStatusReference({
                                    subscriptionId: _this.subscriptionId(),
                                    location: _this.location(),
                                });
                            }
                        },
                        {
                            id: "AgentLogs",
                            displayText: "Agent Logs",
                            icon: FxImages.Polychromatic.Log(),
                            supplyBladeReference: function () {
                                return new BladeReferences.AgentLogsReference({
                                    subscriptionId: _this.subscriptionId(),
                                    location: _this.location(),
                                });
                            }
                        },
                    ]
                },
                {
                    id: "License",
                    displayText: "License",
                    items: [
                        {
                            id: "License",
                            displayText: "License",
                            icon: FxImages.Polychromatic.Versions(),
                            supplyBladeReference: function () {
                                return new BladeReferences.LicenseOverviewBladeReference({
                                    subscriptionId: _this.subscriptionId(),
                                    location: _this.location(),
                                });
                            }
                        },
                    ]
                }
            ];
            if (this.isAzSQuotaCollectorEnabled()) {
                if (this.showOnlyAzureStackQuotaBlades()) {
                    var quotaBlades;
                    quotaBlades = ["general", "UsageAndQuota", "Status", "License"];
                    var mGroups = [];
                    menuGroups.forEach(function (menuGroupItem) {
                        if (quotaBlades.first(function (i) { return i == menuGroupItem.id; })) {
                            if (menuGroupItem.id == "general") {
                                var item = menuGroupItem.items.first(function (i) { return i.id == "Settings"; });
                                menuGroupItem.items.splice(0);
                                menuGroupItem.items.push(item);
                            }
                            mGroups.push(menuGroupItem);
                        }
                    });
                    this.menu.groups(mGroups);
                    this.menu.setOptions({
                        defaultId: "QuotaStatus",
                    });
                }
                else {
                    this.showAllBlades(menuGroups);
                }
            }
            else {
                var usageQuotaSecIndex = menuGroups.firstIndex(function (i) { return i.id == "UsageAndQuota"; });
                menuGroups.splice(usageQuotaSecIndex, 1);
                this.showAllBlades(menuGroups);
            }
        };
        AdminBillingMenuBladeViewModel.prototype.showAllBlades = function (menuGroups) {
            var _this = this;
            this.menu.groups(menuGroups);
            this.menu.setOptions({
                defaultId: "overview",
                overview: {
                    id: "overview",
                    displayText: "Overview",
                    icon: FxImages.Polychromatic.BillingHub(),
                    supplyBladeReference: function () {
                        return new BladeReferences.ResourceProviderOverviewBladeReference({
                            resourceProviderAssetId: _this.rpAssetId()
                        });
                    }
                }
            });
        };
        return AdminBillingMenuBladeViewModel;
    }(FxMenuBlade.ViewModel));
    exports.AdminBillingMenuBladeViewModel = AdminBillingMenuBladeViewModel;
});
