var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "ClientResources", "../../Models/InvoiceModel"], function (require, exports, ClientResources, invoiceDataModel) {
    "use strict";
    var FxForms = MsPortalFx.ViewModels.Forms;
    var FxGrid = MsPortalFx.ViewModels.Controls.Lists.Grid;
    var FxGridExtensions = FxGrid.Extensions;
    var ArmHelpers = Common.Helpers;
    var InvoiceEditBladeViewModel = (function (_super) {
        __extends(InvoiceEditBladeViewModel, _super);
        function InvoiceEditBladeViewModel(container, initialState, dataContext) {
            _super.call(this);
            this.formFieldAndLineItemMapArray = ko.observableArray();
            this.adminSubscriptionId = ko.observable();
            this.location = ko.observable("local");
            this.invoiceId = ko.observable();
            this.invoiceData = ko.observable();
            this.invoiceStartTime = ko.observable();
            this.title("Edit Invoice");
            this._container = container;
            this._dataContext = dataContext;
            this._initializeFormFields(container);
            this._setupCommandBar();
            this._dataEntityView = dataContext.sharedContext.invoicesDataManager.invoiceEntity.createView(container, {
                interceptNotFound: false
            });
        }
        InvoiceEditBladeViewModel.prototype._initializeFormFields = function (container) {
            var idOptions = {
                label: ko.observable("Id"),
                readonly: true,
                validations: ko.observableArray([]),
            };
            this.idTxField = new MsPortalFx.ViewModels.Forms.NumericTextBox.ViewModel(container, idOptions);
            this.idTxField.disabled(true);
            var subscriptionIdTxFieldOptions = {
                label: ko.observable("Subscription Id"),
                readonly: true,
                validations: ko.observableArray([]),
            };
            this.subscriptionIdTxField = new MsPortalFx.ViewModels.Forms.TextBox.ViewModel(container, subscriptionIdTxFieldOptions);
            this.subscriptionIdTxField.disabled(true);
            var userIdTxFieldOptions = {
                label: ko.observable("User Id"),
                readonly: true,
                validations: ko.observableArray([]),
            };
            this.userIdTxField = new MsPortalFx.ViewModels.Forms.TextBox.ViewModel(container, userIdTxFieldOptions);
            this.userIdTxField.disabled(true);
            var periodTxFieldOptions = {
                label: ko.observable("Period"),
                readonly: true,
                validations: ko.observableArray([]),
            };
            this.periodTxField = new MsPortalFx.ViewModels.Forms.TextBox.ViewModel(container, periodTxFieldOptions);
            this.periodTxField.disabled(true);
            var isoCurrencySymbolTxFieldOptions = {
                label: ko.observable("ISO Currency Symbol"),
                readonly: true,
                validations: ko.observableArray([]),
            };
            this.isoCurrencySymbolTxField = new MsPortalFx.ViewModels.Forms.TextBox.ViewModel(container, isoCurrencySymbolTxFieldOptions);
            this.isoCurrencySymbolTxField.disabled(true);
            var totalAmountTxFieldOptions = {
                label: ko.observable("Amount"),
                readonly: true,
                validations: ko.observableArray([]),
                decimalPoint: ko.observable(10),
            };
            this.totalAmountTxField = new MsPortalFx.ViewModels.Forms.NumericTextBox.ViewModel(container, totalAmountTxFieldOptions);
            this.totalAmountTxField.disabled(true);
            this.formSection = new FxForms.Section.ViewModel(container, {
                children: ko.observableArray([
                    this.idTxField,
                    this.subscriptionIdTxField,
                    this.userIdTxField,
                    this.periodTxField,
                    this.isoCurrencySymbolTxField,
                    this.totalAmountTxField,
                ])
            });
            var gridExtensions = FxGridExtensions.SelectableRow;
            var gridExtensionOptions = {
                selectableRow: {
                    selectionMode: 1
                },
            };
            this.lineItemsGrid = new FxGrid.ViewModel(container, ko.observableArray([]), gridExtensions, gridExtensionOptions);
            var basicColumns = [
                {
                    name: ko.observable("Id"),
                    itemKey: "idField",
                    width: ko.observable("80px"),
                    format: MsPortalFx.ViewModels.Controls.Lists.Grid.Format.HtmlBindings,
                    formatOptions: {
                        htmlBindingsTemplate: "<div data-bind='pcControl: value' style='width: 90%;margin-top: 20px;margin-bottom: 20px'></div>"
                    }
                },
                {
                    name: ko.observable("Description"),
                    itemKey: "descriptionField",
                    format: MsPortalFx.ViewModels.Controls.Lists.Grid.Format.HtmlBindings,
                    formatOptions: {
                        htmlBindingsTemplate: "<div data-bind='pcControl: value' style='width: 90%;margin-top: 20px;margin-bottom: 20px'></div>"
                    }
                },
                {
                    name: ko.observable("Unit Price"),
                    itemKey: "unitPriceField",
                    width: ko.observable("120px"),
                    format: MsPortalFx.ViewModels.Controls.Lists.Grid.Format.HtmlBindings,
                    formatOptions: {
                        htmlBindingsTemplate: "<div data-bind='pcControl: value' style='width: 90%;margin-top: 20px;margin-bottom: 20px'></div>"
                    }
                },
                {
                    name: ko.observable("Quantity"),
                    itemKey: "quantityField",
                    width: ko.observable("120px"),
                    format: MsPortalFx.ViewModels.Controls.Lists.Grid.Format.HtmlBindings,
                    formatOptions: {
                        htmlBindingsTemplate: "<div data-bind='pcControl: value' style='width: 90%;margin-top: 20px;margin-bottom: 20px'></div>"
                    }
                },
                {
                    name: ko.observable("Amount"),
                    itemKey: "amountField",
                    width: ko.observable("120px"),
                    format: MsPortalFx.ViewModels.Controls.Lists.Grid.Format.HtmlBindings,
                    formatOptions: {
                        htmlBindingsTemplate: "<div data-bind='pcControl: value' style='width: 90%;margin-top: 20px;margin-bottom: 20px'></div>"
                    }
                },
            ];
            this.lineItemsGrid.columns = ko.observableArray(basicColumns);
            this.lineItemsGrid.showHeader = true;
            this.lineItemsGrid.summary = ko.observable("Summary");
            this.lineItemsGrid.noRowsMessage("No Line Items found");
            this.lineItemsGrid.selectableData.selectedItems.subscribe(container, function (selectedItems) {
                if (!selectedItems || selectedItems.length === 0) {
                    return;
                }
            });
            this.addLineItemButton = new MsPortalFx.ViewModels.Controls.SimpleButton.ViewModel(container, {
                onClick: this._onaddLineItemButtonClicked.bind(this),
                text: "Add Line Item",
                primary: true,
                disabled: false,
            });
            this.deleteLineItemButton = new MsPortalFx.ViewModels.Controls.SimpleButton.ViewModel(container, {
                onClick: this._ondeleteLineItemButtonClicked.bind(this),
                text: "Delete Line Item",
                primary: true,
                disabled: false,
            });
        };
        InvoiceEditBladeViewModel.prototype._setupCommandBar = function () {
            var _this = this;
            var saveButton = new MsPortalFx.ViewModels.Toolbars.CommandButton({
                label: ClientResources.Commands.save,
                icon: MsPortalFx.Base.Images.Save(),
                command: {
                    canExecute: ko.observable(true),
                    execute: function (context) {
                        return _this._container.form.triggerValidation().then(function (validationPassed) {
                            if (validationPassed) {
                                return _this._onSaveChanges();
                            }
                            return null;
                        });
                    },
                }
            });
            this.commandBar = new MsPortalFx.ViewModels.Toolbars.Toolbar(this._container);
            this.commandBar.setItems([saveButton]);
        };
        InvoiceEditBladeViewModel.prototype._onSaveChanges = function () {
            var _this = this;
            var invoiceData = {
                Id: this.idTxField.value(),
                SubscriptionId: this.subscriptionIdTxField.value(),
                InvoiceLineItems: this._getLineItemsFromGrid(),
                InvoiceStartTime: this.invoiceStartTime(),
            };
            var dataManager = this._dataContext.sharedContext.invoicesDataManager;
            var op = dataManager.updateInvoiceQuery(this.adminSubscriptionId(), this.location(), invoiceData);
            this._container.operations.add(op, { blockUi: true });
            return op.then(function () {
                return {
                    action: MsPortalFx.Data.AcceptEditScopeChangesAction.AcceptClientChanges
                };
            }).finally(function () {
                dataManager.invoicesQuery.refreshAll();
                dataManager.invoiceEntity.refreshAll();
                _this._container.closeCurrentBlade();
            });
        };
        InvoiceEditBladeViewModel.prototype._getLineItemsFromGrid = function () {
            var invoiceLineItems = [];
            var gridItems = this.lineItemsGrid.items();
            for (var _i = 0, gridItems_1 = gridItems; _i < gridItems_1.length; _i++) {
                var item = gridItems_1[_i];
                var lineItem = {
                    Id: item.idField().value(),
                    Description: item.descriptionField().value(),
                    UnitPrice: item.unitPriceField().value(),
                    Quantity: item.quantityField().value(),
                    Amount: item.amountField().value(),
                };
                invoiceLineItems.push(lineItem);
            }
            return invoiceLineItems;
        };
        InvoiceEditBladeViewModel.prototype._onaddLineItemButtonClicked = function () {
            var gridItems = this.lineItemsGrid.items();
            var newLineItem;
            var newItem = this._getFormField(newLineItem);
            gridItems.push(newItem);
            this.lineItemsGrid.items(gridItems);
        };
        InvoiceEditBladeViewModel.prototype._ondeleteLineItemButtonClicked = function () {
            var selectedItem = this.lineItemsGrid.selectableData.selectedItems()[0];
            if (selectedItem) {
                var gridItems = this.lineItemsGrid.items();
                var index = gridItems.indexOf(selectedItem);
                gridItems.splice(index, 1);
                this.lineItemsGrid.items(gridItems);
            }
        };
        InvoiceEditBladeViewModel.prototype._getFormField = function (invoiceLineItem) {
            var id = invoiceLineItem ? invoiceLineItem.Id() : 0;
            var description = invoiceLineItem ? invoiceLineItem.Description() : '';
            var unitPrice = invoiceLineItem ? invoiceLineItem.UnitPrice() : 0;
            var quantity = invoiceLineItem ? invoiceLineItem.Quantity() : 0;
            var amount = invoiceLineItem ? invoiceLineItem.Amount() : 0;
            var idFieldOptions = {
                defaultValue: ko.observable(id),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
                emptyValueText: ko.observable("0"),
                readonly: true,
            };
            var idField = new FxForms.NumericTextBox.ViewModel(this._container, idFieldOptions);
            idField.disabled(true);
            var descriptionFieldOptions = {
                defaultValue: ko.observable(description),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required"),
                ]),
                emptyValueText: ko.observable("Enter Descripiton"),
            };
            var descriptionField = new FxForms.MultiLineTextBox.ViewModel(this._container, descriptionFieldOptions);
            var unitPriceFieldOptions = {
                defaultValue: ko.observable(unitPrice),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
                emptyValueText: ko.observable("Enter Unit Price"),
                decimalPoint: ko.observable(4),
            };
            var unitPriceField = new FxForms.NumericTextBox.ViewModel(this._container, unitPriceFieldOptions);
            var quantityFieldOptions = {
                defaultValue: ko.observable(quantity),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
                emptyValueText: ko.observable("Enter Quantity"),
                decimalPoint: ko.observable(4),
            };
            var quantityField = new FxForms.NumericTextBox.ViewModel(this._container, quantityFieldOptions);
            var amountFieldOptions = {
                defaultValue: ko.observable(amount),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
                emptyValueText: ko.observable("Enter Amount"),
                decimalPoint: ko.observable(4),
            };
            var amountField = new FxForms.NumericTextBox.ViewModel(this._container, amountFieldOptions);
            return {
                idField: ko.observable(idField),
                descriptionField: ko.observable(descriptionField),
                unitPriceField: ko.observable(unitPriceField),
                quantityField: ko.observable(quantityField),
                amountField: ko.observable(amountField),
            };
        };
        InvoiceEditBladeViewModel.prototype._setFormFields = function (invoiceData) {
            this.idTxField.value(invoiceData.Id());
            this.subscriptionIdTxField.value(invoiceData.SubscriptionId());
            this.userIdTxField.value(invoiceData.UserId());
            ;
            this.periodTxField.value(invoiceData.BillingPeriodString());
            this.isoCurrencySymbolTxField.value(invoiceData.ISOCurrencySymbol());
            this.totalAmountTxField.value(invoiceData.FinalBillableAmount());
            this._updateLineItemsGrid(invoiceData.LineItems());
        };
        InvoiceEditBladeViewModel.prototype._updateLineItemsGrid = function (invoiceLineItems) {
            this.formFieldAndLineItemMapArray([]);
            for (var _i = 0, invoiceLineItems_1 = invoiceLineItems; _i < invoiceLineItems_1.length; _i++) {
                var lineItem = invoiceLineItems_1[_i];
                var formField = this._getFormField(lineItem);
                this.formFieldAndLineItemMapArray.push(formField);
            }
            this.lineItemsGrid.items(this.formFieldAndLineItemMapArray());
        };
        InvoiceEditBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            var _this = this;
            this.adminSubscriptionId(inputs.adminSubscriptionId);
            this.location(inputs.location);
            this.invoiceId(inputs.invoiceId);
            var args = {
                subscriptionId: this.adminSubscriptionId(),
                location: this.location(),
                invoiceId: this.invoiceId(),
            };
            return this._dataEntityView.fetch(args).then(function () {
                var dataEntity = _this._dataEntityView.item();
                var data = invoiceDataModel.InvoiceModel.getInvoiceData(dataEntity);
                _this.invoiceStartTime(data.InvoiceStartTime());
                _this._setFormFields(data);
            });
        };
        return InvoiceEditBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.InvoiceEditBladeViewModel = InvoiceEditBladeViewModel;
});
