declare module "ClientResources" {
    export = ClientResources;

    var ClientResources: {
        BillingOverview: {
            Create: {
                bladeTitle: string;
                bladeSubtitle: string;
                subscriptionValidation: string;
                location: string;
                name: string;
                nameEmptyText: string;
                resourceGroupValidation: string;
                description: string;
                descriptionEmptyText: string;
                locationValidation: string;
                nameValidation: string;
                resourceGroup: string;
                subscription: string;
                billingSize: string;
                billingSizeValidation: string;
            };
        };
        Assets: {
            BillingOverview: {
                singular: string;
                lowerPlural: string;
                lowerSingular: string;
                plural: string;
            };
            Billing: {
                lowerPlural: string;
                lowerSingular: string;
                plural: string;
                singular: string;
            };
        };
        BillingOverviewItem: {
            Create: {
                title: string;
                completion: string;
                description: string;
                dueDate: string;
                priority: string;
                completionInfoBalloon: string;
                descriptionInfoBalloon: string;
                dueDateInfoBalloon: string;
                priorityInfoBalloon: string;
                titleInfoBalloon: string;
            };
            Blades: {
                addBillingOverview: string;
                manageBillingOverview: string;
            };
            Priority: {
                high: string;
                low: string;
                normal: string;
            };
            Status: {
                completed: string;
                inProgress: string;
                notStarted: string;
            };
        };
        extensionName: string;
        Commands: {
            execute: string;
            commands: string;
            connect: string;
            create: string;
            configure: string;
            snapshots: string;
            delete: string;
            powerOn: string;
            powerOff: string;
            discard: string;
            addBillingOverview: string;
            save: string;
            disable: string;
            enable: string;
            BillingTemplates: {
                publishToGallery: string;
            };
        };
        Notifications: {
            BillingOverview: {
                Configure: {
                    Failed: {
                        message: string;
                        title: string;
                    };
                    Progress: {
                        message: string;
                        title: string;
                    };
                    Success: {
                        message: string;
                        title: string;
                    };
                };
                PowerOperation: {
                    Failed: {
                        message: string;
                        title: string;
                    };
                    Progress: {
                        message: string;
                        title: string;
                    };
                    Success: {
                        message: string;
                        title: string;
                    };
                };
                Delete: {
                    Failed: {
                        message: string;
                        title: string;
                    };
                    Progress: {
                        message: string;
                        title: string;
                    };
                    Success: {
                        message: string;
                        title: string;
                    };
                };
                Update: {
                    Failed: {
                        message: string;
                        title: string;
                    };
                    Progress: {
                        message: string;
                        title: string;
                    };
                    Success: {
                        message: string;
                        title: string;
                    };
                };
            };
            BillingCloud: {
                Update: {
                    Failed: {
                        message: string;
                        title: string;
                    };
                    Progress: {
                        message: string;
                        title: string;
                    };
                    Success: {
                        message: string;
                        title: string;
                    };
                };
            };
        };
        BillingCloud: {
            tenantResources: string;
            Status: {
                disabled: string;
                enabled: string;
            };
        };
        Quota: {
            title: string;
            maxNumberBillingOverviews: string;
            unlimited: string;
            validationGreaterThanZero: string;
            validationMustBeANumber: string;
        };
        ResourceSummary: {
            location: string;
            serviceName: string;
            subscriptionId: string;
            subscriptionName: string;
            status: string;
        };
        no: string;
        LocationPicker: {
            title: string;
        };
        Properties: {
            Name: {
                label: string;
            };
            title: string;
        };
        SettingsList: {
            Properties: {
                title: string;
            };
            title: string;
        };
        ok: string;
        BillingSizePicker: {
            title: string;
        };
        ResourceProvider: {
            Status: {
                disabled: string;
                enabled: string;
            };
        };
    };
}
