var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports"], function (require, exports) {
    "use strict";
    var CspCustomerProfileRequestDetailsPartViewModel = (function (_super) {
        __extends(CspCustomerProfileRequestDetailsPartViewModel, _super);
        function CspCustomerProfileRequestDetailsPartViewModel(container, initialState, dataContext) {
            var _this = this;
            _super.call(this);
            this.detailsSection = ko.observableArray();
            this.userProfileId = ko.observable();
            this.selectedCustomerProfileRequest = ko.observable();
            this.container = container;
            ko.reactor(container, function () {
                if (_this.selectedCustomerProfileRequest()) {
                    _this.detailsSection([]);
                    var items = [];
                    items.push({ label: "First Name", value: _this.selectedCustomerProfileRequest().FirstName });
                    items.push({ label: "Last Name", value: _this.selectedCustomerProfileRequest().LastName });
                    items.push({ label: "Domain", value: _this.selectedCustomerProfileRequest().Domain });
                    items.push({ label: "Microsoft ID", value: _this.selectedCustomerProfileRequest().TenantId });
                    items.push({ label: "Email ID", value: _this.selectedCustomerProfileRequest().Email });
                    items.push({ label: "Company", value: _this.selectedCustomerProfileRequest().CompanyName });
                    items.push({ label: "City / Zip", value: _this.selectedCustomerProfileRequest().City + ", " + _this.selectedCustomerProfileRequest().PostalCode });
                    items.push({ label: "Country", value: _this.selectedCustomerProfileRequest().State + ", " + _this.selectedCustomerProfileRequest().Country });
                    items.push({ label: "Contact", value: _this.selectedCustomerProfileRequest().PhoneNumber });
                    var section = {
                        title: ko.observable(_this.selectedCustomerProfileRequest().FirstName + " " + _this.selectedCustomerProfileRequest().LastName),
                        items: ko.observableArray(items)
                    };
                    _this.detailsSection.push(section);
                }
            });
        }
        CspCustomerProfileRequestDetailsPartViewModel.prototype.onInputsSet = function (inputs) {
            this.userProfileId(inputs.userProfileId);
            this.selectedCustomerProfileRequest(inputs.selectedCustomerProfile);
            return Q();
        };
        return CspCustomerProfileRequestDetailsPartViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.CspCustomerProfileRequestDetailsPartViewModel = CspCustomerProfileRequestDetailsPartViewModel;
});
