var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports"], function (require, exports) {
    "use strict";
    var FxForms = MsPortalFx.ViewModels.Forms;
    var Images = MsPortalFx.Base.Images;
    var ActivateLicenseFormBladeViewModel = (function (_super) {
        __extends(ActivateLicenseFormBladeViewModel, _super);
        function ActivateLicenseFormBladeViewModel(container, initialState, dataContext) {
            var _this = this;
            _super.call(this);
            this.subscriptionId = ko.observable();
            this.location = ko.observable();
            this.isExtendLicense = ko.observable();
            this.icon(Images.Key());
            this._container = container;
            this._dataContext = dataContext;
            this._initializeFormFields(container);
            this.actionBar = new MsPortalFx.ViewModels.ActionBars.GenericActionBar.ViewModel(container);
            this.actionBar.actionButtonClick = function () {
                var licenseInfo = {
                    LicenseKey: _this.licenseKeyField.value(),
                    EmailId: _this.mailField.value()
                };
                if (_this.isExtendLicense()) {
                    _this._dataContext.licenseDataManager.extendLicense(_this.subscriptionId(), _this.location(), licenseInfo);
                }
                else {
                }
                _this._container.closeCurrentBlade();
            };
        }
        ActivateLicenseFormBladeViewModel.prototype._initializeFormFields = function (container) {
            var licenseKeyOptions = {
                label: ko.observable("License Key"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required"),
                    new MsPortalFx.ViewModels.RegExMatchValidation("^([a-zA-Z0-9_\-]){1,100}$", "From 1 to 100 Characters only")
                ]),
                emptyValueText: ko.observable("License Key"),
                readonly: false,
            };
            this.licenseKeyField = new FxForms.TextBox.ViewModel(container, licenseKeyOptions);
            var mailOptions = {
                label: ko.observable("Email Id"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required"),
                    new MsPortalFx.ViewModels.RegExMatchValidation("^(([\\w-\\.]+)@((\\[[0-9]{1,3}\\.[0-9]{1,3}\\.[0-9]{1,3}\\.)|(([\\w-]+\\.)+))([a-zA-Z]{2,4}|[0-9]{1,3})(\\]?))$", "Invalid Email Id"),
                ]),
                emptyValueText: ko.observable("Email Id"),
                readonly: false,
            };
            this.mailField = new FxForms.TextBox.ViewModel(container, mailOptions);
        };
        ActivateLicenseFormBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            this.subscriptionId(inputs.subscriptionId);
            this.location(inputs.location);
            this.isExtendLicense(inputs.isExtendLicense);
            if (this.isExtendLicense()) {
                this.title("Extend License");
                this.actionBar.actionButtonLabel("Submit");
            }
            else {
                this.title("Activate License Online");
                this.actionBar.actionButtonLabel("Activate");
            }
            return null;
        };
        return ActivateLicenseFormBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.ActivateLicenseFormBladeViewModel = ActivateLicenseFormBladeViewModel;
});
