var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "../../Shared/Helpers"], function (require, exports, Helpers) {
    "use strict";
    var FxForms = MsPortalFx.ViewModels.Forms;
    var FxGrid = MsPortalFx.ViewModels.Controls.Lists.Grid;
    var FxGridExtensions = FxGrid.Extensions;
    var ArmHelpers = Common.Helpers;
    var AvailablePricingProfileBladeViewModel = (function (_super) {
        __extends(AvailablePricingProfileBladeViewModel, _super);
        function AvailablePricingProfileBladeViewModel(container, initialState, dataContext) {
            var _this = this;
            _super.call(this);
            this.meteredResourcesList = new Array();
            this.adminSubscriptionId = ko.observable();
            this.pricingProfileId = ko.observable();
            this.location = ko.observable("local");
            this.meteredResourcesListJson = ko.observable("");
            this.selectedPricingProfile = ko.pureComputed(function () {
                var q = _this.availablePricingProfilesGrid.selectableData.selectedItems().first();
                if (q) {
                    var key = q.ProfileName + " _ " + q.UpdatedTime;
                    _this.meteredResourcesList = _this.availablePricingProfilesDict[key];
                    _this.meteredResourcesListJson(ko.toJSON(_this.meteredResourcesList));
                }
                return q;
            });
            this.title("Available Pricing Profiles");
            this._container = container;
            this._dataContext = dataContext;
            this.formSection = new FxForms.Section.ViewModel(container, {
                style: ko.observable(3),
                children: ko.observableArray([])
            });
            var gridExtensions = FxGridExtensions.Filterable | FxGridExtensions.SortableColumn | FxGridExtensions.SelectableRow;
            var gridExtensionOptions = {
                filterable: {
                    searchBoxCloseButtonVisible: ko.observable(false),
                    searchBoxPlaceholder: ko.observable("Search to filter items..."),
                    searchBoxVisible: ko.observable(true),
                },
                selectableRow: {
                    selectionMode: 1,
                    activateOnSelected: ko.observable(false)
                }
            };
            this.availablePricingProfilesGrid = new FxGrid.ViewModel(container, ko.observableArray([]), gridExtensions, gridExtensionOptions);
            var basicColumns = [
                {
                    itemKey: "ProfileName",
                    name: ko.observable("Pricing Profile"),
                    width: ko.observable("50px"),
                    activatable: ko.observable(true),
                    format: FxGrid.Format.HtmlBindings,
                    formatOptions: {
                        htmlBindingsTemplate: Helpers.getGridNameActivatableTemplate(),
                        htmlBindingsType: FxGrid.HtmlBindingsType.Default
                    }
                },
                {
                    itemKey: "UpdatedTime",
                    name: ko.observable("Updated Time"),
                    width: ko.observable("50px"),
                    activatable: ko.observable(true),
                },
            ];
            this.availablePricingProfilesGrid.columns = ko.observableArray(basicColumns);
            this.availablePricingProfilesGrid.showHeader = true;
            this.availablePricingProfilesGrid.summary = ko.observable("Summary");
            this.availablePricingProfilesGrid.noRowsMessage("No items found");
        }
        AvailablePricingProfileBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            var _this = this;
            this.adminSubscriptionId(inputs.adminSubscriptionId);
            this.location(inputs.location);
            this.pricingProfileId(inputs.pricingProfileId);
            return this._dataContext.sharedContext.pricingProfilesDataManager.getAvailablePricingProfilesDict(this.adminSubscriptionId(), this.location())
                .then(function (dict) {
                _this.availablePricingProfilesDict = dict;
                var pricingprofiles = Object.keys(dict);
                var result = new Array();
                for (var i in pricingprofiles) {
                    var obj = {};
                    var pp = pricingprofiles[i].split(" _ ");
                    obj.ProfileName = pp[0];
                    obj.UpdatedTime = pp[1];
                    result.push(obj);
                }
                _this.availablePricingProfilesGrid.items(result);
            });
        };
        return AvailablePricingProfileBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.AvailablePricingProfileBladeViewModel = AvailablePricingProfileBladeViewModel;
});
