var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "ClientResources", "../../Models/MeteredResourceModel"], function (require, exports, ClientResources, MeteredResourceModel) {
    "use strict";
    var FxForms = MsPortalFx.ViewModels.Forms;
    var FxGrid = MsPortalFx.ViewModels.Controls.Lists.Grid;
    var FxGridExtensions = FxGrid.Extensions;
    var ArmHelpers = Common.Helpers;
    var MeteredResourceEditBladeViewModel = (function (_super) {
        __extends(MeteredResourceEditBladeViewModel, _super);
        function MeteredResourceEditBladeViewModel(container, initialState, dataContext) {
            _super.call(this);
            this.formFieldAndPropertyMapArray = ko.observableArray();
            this.adminSubscriptionId = ko.observable();
            this.location = ko.observable("local");
            this.meteredResourceId = ko.observable();
            this.meteredResource = ko.observable();
            this.title("Edit Metered Resource");
            this._container = container;
            this._dataContext = dataContext;
            this._initializeFormFields(container);
            this._setupCommandBar();
            this._dataEntityView = dataContext.meteredResourcePricingDataManager.getMeteredResourcesEntity.createView(container, {
                interceptNotFound: false
            });
        }
        MeteredResourceEditBladeViewModel.prototype._initializeFormFields = function (container) {
            var _this = this;
            var customValidationForHourlyUnitPrice = new MsPortalFx.ViewModels.CustomValidation("", (function (value) {
                var validResult = true;
                var errorMessage = "";
                if (value) {
                    var hourlyUnitPrice = Number((value / 720).toFixed(10));
                    _this.hourlyUnitPriceTxField.value(hourlyUnitPrice);
                }
                else {
                    _this.hourlyUnitPriceTxField.value(0);
                }
                return Q({
                    valid: validResult,
                    message: errorMessage,
                });
            }));
            var idOptions = {
                label: ko.observable("Id"),
                readonly: true,
                validations: ko.observableArray([]),
            };
            this.idTxField = new MsPortalFx.ViewModels.Forms.NumericTextBox.ViewModel(container, idOptions);
            this.idTxField.disabled(true);
            var providerNameOptions = {
                label: ko.observable("Provider Name"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.providerNameTxField = new MsPortalFx.ViewModels.Forms.TextBox.ViewModel(container, providerNameOptions);
            var serviceTypeOptions = {
                label: ko.observable("Service Type"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.serviceTypeTxField = new MsPortalFx.ViewModels.Forms.TextBox.ViewModel(container, serviceTypeOptions);
            var meterDisplayNameOptions = {
                label: ko.observable("Metere Display Name"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.meterDisplayNameTxField = new MsPortalFx.ViewModels.Forms.TextBox.ViewModel(container, meterDisplayNameOptions);
            var meterIdOptions = {
                label: ko.observable("Meter Id"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.meterIdField = new MsPortalFx.ViewModels.Forms.TextBox.ViewModel(container, meterIdOptions);
            var monthlyUnitPriceOptions = {
                label: ko.observable("Monthly Unit Price"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required"),
                    customValidationForHourlyUnitPrice
                ]),
                decimalPoint: ko.observable(10),
                max: ko.observable(999999999),
            };
            this.monthlyUnitPriceTxField = new MsPortalFx.ViewModels.Forms.NumericTextBox.ViewModel(container, monthlyUnitPriceOptions);
            var hourlyUnitPriceOptions = {
                label: ko.observable("Hourly Unit Price"),
                validations: ko.observableArray([]),
                decimalPoint: ko.observable(10),
            };
            this.hourlyUnitPriceTxField = new MsPortalFx.ViewModels.Forms.NumericTextBox.ViewModel(container, hourlyUnitPriceOptions);
            this.hourlyUnitPriceTxField.disabled(true);
            var minimumMonthlyFeeOptions = {
                label: ko.observable("Minimum Monthly Fee"),
                validations: ko.observableArray([]),
                infoBalloonContent: ko.observable("Minimum Monthly Fee:<br\>" +
                    "\� Minimum monthly fee for meter will be applied if the usage cost ( Monthly price ) for the month is less than the value specified in 'Minimum Monthly Fee'<br\>\
                  � If the usage per hour for the meter is 0, then only the minimum monthly fee value will be applied<br\>"),
                decimalPoint: ko.observable(10),
                max: ko.observable(999999999),
            };
            this.minimumMonthlyFeeTxField = new MsPortalFx.ViewModels.Forms.NumericTextBox.ViewModel(container, minimumMonthlyFeeOptions);
            var unitOptions = {
                label: ko.observable("Unit"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.unitTxField = new MsPortalFx.ViewModels.Forms.TextBox.ViewModel(container, unitOptions);
            var hourlyUnitCreditsOptions = {
                label: ko.observable("Hourly Unit Credits"),
                validations: ko.observableArray([]),
                infoBalloonContent: ko.observable("Hourly Unit Credits:<br\>" +
                    "\� The units specified in 'Hourly Unit Credits' will be deducted from the actual usage units before computing the cost<br\>\
                  � Example:<br\>\
                  �� If usage per hour in 1024 and the 'Hourly Unit Credits' specified is 24, the the usage cost will be computed only for 1000 units"),
                decimalPoint: ko.observable(10),
                max: ko.observable(999999999),
            };
            this.hourlyUnitCreditsTxField = new MsPortalFx.ViewModels.Forms.NumericTextBox.ViewModel(container, hourlyUnitCreditsOptions);
            var formulaTypeOptions = {
                label: ko.observable("Formula Type"),
                options: ko.observableArray([
                    { text: ko.observable("Unit"), value: true },
                    { text: ko.observable("Custom"), value: false }
                ]),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.formulaTypeOptionField = new FxForms.OptionsGroup.ViewModel(container, formulaTypeOptions);
            var formulaOptions = {
                label: ko.observable("Formula"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required"),
                    new MsPortalFx.ViewModels.CustomValidation("Request timed out", (function (value) {
                        var promise;
                        if (_this.formulaTypeOptionField.value() == true) {
                            promise = _this._dataContext.meteredResourcePricingDataManager.evaluateUnitFormulaQuery(_this.adminSubscriptionId(), _this.location(), value);
                            return promise.then(function (result) {
                                return {
                                    valid: result,
                                    message: result ? "" : "Invalid Unit Formula",
                                };
                            });
                        }
                        promise = _this._dataContext.meteredResourcePricingDataManager.evaluateCustomFormulaQuery(_this.adminSubscriptionId(), _this.location(), value);
                        return promise.then(function (result) {
                            return {
                                valid: result,
                                message: result ? "" : "Invalid Custom Formula",
                            };
                        });
                    }))
                ]),
                infoBalloonContent: ko.observable("Unit Formula:<br\>" +
                    "\� Formula supports simple math expressions<br\>\
                     � Operators supported: * / +<br\>\
                     � Operators should have a space around them<br\>\
                     � Brackets not supported<br\>\
                     � Operations are executed from Left to Right<br\>" +
                    "Custom Formula:<br\>" +
                    "\� Note: Unit Multiplier wont be considered when using this Formula<br\>\
                     � Formula supports math expressions<br\>\
                     � Operators supported: * / + -<br\>\
                     � Operators should have a space around them<br\>\
                     � Brackets are supported, but leave a space around them<br\>\
                     � Operations are executed as per Mathematical precedance<br\>"),
            };
            this.formulalTxField = new MsPortalFx.ViewModels.Forms.TextBox.ViewModel(container, formulaOptions);
            var isCollectionEnabledOption = {
                label: ko.observable("Enable Meter ?"),
                options: ko.observableArray([
                    { text: ko.observable("Yes"), value: true },
                    { text: ko.observable("No"), value: false }
                ]),
            };
            this.isCollectionEnabledOptionField = new FxForms.OptionsGroup.ViewModel(container, isCollectionEnabledOption);
            var resourceConditionsOptions = {
                label: ko.observable("Resource Condition"),
                validations: ko.observableArray([]),
                infoBalloonContent: ko.observable("Resource Condition:<br\>" +
                    "\� Different prices for the same meter can be set using 'Resource Conditions'<br\>\
                  � Example:<br\>\
                  �� B5C15376-6C94-4FDD-B655-1A69D138ACA3 > 100 && B5C15376-6C94-4FDD-B655-1A69D138ACA3 <= 150<br\>\
                  � The monlthy unit price for 'B5C15376-6C94-4FDD-B655-1A69D138ACA3' (Microsoft.Storage) will be applied only if the storage is inbetween 100-150 GB.<br\>\
                  � To set a different price for the same meter with different Resource Condition, the meter has to be cloned from the Meter resource collection grid and edited."),
            };
            this.resourceConditionMultiTxField = new MsPortalFx.ViewModels.Forms.MultiLineTextBox.ViewModel(container, resourceConditionsOptions);
            this.formSection = new FxForms.Section.ViewModel(container, {
                children: ko.observableArray([
                    this.idTxField,
                    this.providerNameTxField,
                    this.serviceTypeTxField,
                    this.meterDisplayNameTxField,
                    this.meterIdField,
                    this.monthlyUnitPriceTxField,
                    this.hourlyUnitPriceTxField,
                    this.minimumMonthlyFeeTxField,
                    this.unitTxField,
                    this.hourlyUnitCreditsTxField,
                    this.formulaTypeOptionField,
                    this.formulalTxField,
                    this.isCollectionEnabledOptionField,
                    this.resourceConditionMultiTxField,
                ])
            });
            var gridExtensions = FxGridExtensions.SelectableRow;
            var gridExtensionOptions = {
                selectableRow: {
                    selectionMode: 1
                },
            };
            this.propertiesGrid = new FxGrid.ViewModel(container, ko.observableArray([]), gridExtensions, gridExtensionOptions);
            var basicColumns = [
                {
                    name: ko.observable("Property Key"),
                    itemKey: "propertyKeyField",
                    format: MsPortalFx.ViewModels.Controls.Lists.Grid.Format.HtmlBindings,
                    formatOptions: {
                        htmlBindingsTemplate: "<div data-bind='pcControl: value' style='width: 90%;margin-top: 20px;margin-bottom: 20px'></div>"
                    }
                },
                {
                    name: ko.observable("Property Value"),
                    itemKey: "propertyValueField",
                    format: MsPortalFx.ViewModels.Controls.Lists.Grid.Format.HtmlBindings,
                    formatOptions: {
                        htmlBindingsTemplate: "<div data-bind='pcControl: value' style='width: 90%;margin-top: 20px;margin-bottom: 20px'></div>"
                    }
                },
            ];
            this.propertiesGrid.columns = ko.observableArray(basicColumns);
            this.propertiesGrid.showHeader = true;
            this.propertiesGrid.summary = ko.observable("Summary");
            this.propertiesGrid.noRowsMessage("No Properties found");
            this.propertiesGrid.selectableData.selectedItems.subscribe(container, function (selectedItems) {
                if (!selectedItems || selectedItems.length === 0) {
                    return;
                }
            });
            this.addPropertyButton = new MsPortalFx.ViewModels.Controls.SimpleButton.ViewModel(container, {
                onClick: this._onAddPropertyButtonClicked.bind(this),
                text: "Add new property",
                primary: true,
                disabled: false,
            });
            this.deletePropertyButton = new MsPortalFx.ViewModels.Controls.SimpleButton.ViewModel(container, {
                onClick: this._onDeletePropertyButtonClicked.bind(this),
                text: "Delete property",
                primary: true,
                disabled: false,
            });
        };
        MeteredResourceEditBladeViewModel.prototype._setupCommandBar = function () {
            var _this = this;
            var saveButton = new MsPortalFx.ViewModels.Toolbars.CommandButton({
                label: ClientResources.Commands.save,
                icon: MsPortalFx.Base.Images.Save(),
                command: {
                    canExecute: ko.observable(true),
                    execute: function (context) {
                        return _this._container.form.triggerValidation().then(function (validationPassed) {
                            if (validationPassed) {
                                return _this._onSaveChanges();
                            }
                            return null;
                        });
                    },
                }
            });
            this.commandBar = new MsPortalFx.ViewModels.Toolbars.Toolbar(this._container);
            this.commandBar.setItems([saveButton]);
        };
        MeteredResourceEditBladeViewModel.prototype._onSaveChanges = function () {
            var _this = this;
            var meterResourceData = {
                Id: this.idTxField.value(),
                ProviderName: this.providerNameTxField.value(),
                ServiceType: this.serviceTypeTxField.value(),
                MeteredResourceDisplayName: this.meterDisplayNameTxField.value(),
                MeteredResourceName: this.meterIdField.value(),
                MonthlyUnitPrice: this.monthlyUnitPriceTxField.value(),
                MinimumMonthlyFee: this.minimumMonthlyFeeTxField.value(),
                UnitDisplayName: this.unitTxField.value(),
                MonthlyUnitCredits: this.hourlyUnitCreditsTxField.value(),
                IsUnitFormula: this.formulaTypeOptionField.value(),
                Formula: this.formulalTxField.value(),
                IsCollectionEnabled: this.isCollectionEnabledOptionField.value(),
                ConditionsExpression: this.resourceConditionMultiTxField.value(),
                FilterProperties: this._getPropertiesFromGrid(),
                CustomFormula: ko.observable(''),
                UnitMultiplierFormula: ko.observable(''),
            };
            if (this.formulaTypeOptionField.value() == true) {
                meterResourceData.CustomFormula(null);
                meterResourceData.UnitMultiplierFormula(this.formulalTxField.value());
            }
            else {
                meterResourceData.UnitMultiplierFormula("1");
                meterResourceData.CustomFormula(this.formulalTxField.value());
            }
            var dataManager = this._dataContext.meteredResourcePricingDataManager;
            var op = dataManager.updateMeteredResourceEntity(this.adminSubscriptionId(), this.location(), meterResourceData);
            this._container.operations.add(op, { blockUi: true });
            return op.then(function () {
                return {
                    action: MsPortalFx.Data.AcceptEditScopeChangesAction.AcceptClientChanges
                };
            }).finally(function () {
                dataManager.getMeteredResourcesEntity.refreshAll();
                _this._container.closeCurrentBlade();
                dataManager.listMeteredResourcesQuery.refreshAll();
            });
        };
        MeteredResourceEditBladeViewModel.prototype._getPropertiesFromGrid = function () {
            var filterProperties = {};
            var gridItems = this.propertiesGrid.items();
            for (var _i = 0, gridItems_1 = gridItems; _i < gridItems_1.length; _i++) {
                var item = gridItems_1[_i];
                var propertyKey = item.propertyKeyField().value();
                var propertyValue = item.propertyValueField().value();
                filterProperties[propertyKey] = propertyValue;
            }
            return filterProperties;
        };
        MeteredResourceEditBladeViewModel.prototype._onAddPropertyButtonClicked = function () {
            var gridItems = this.propertiesGrid.items();
            var newItem = this._getFormField('', '');
            gridItems.push(newItem);
            this.propertiesGrid.items(gridItems);
        };
        MeteredResourceEditBladeViewModel.prototype._onDeletePropertyButtonClicked = function () {
            var selectedItem = this.propertiesGrid.selectableData.selectedItems()[0];
            if (selectedItem) {
                var gridItems = this.propertiesGrid.items();
                var index = gridItems.indexOf(selectedItem);
                gridItems.splice(index, 1);
                this.propertiesGrid.items(gridItems);
            }
        };
        MeteredResourceEditBladeViewModel.prototype._getFormField = function (key, value) {
            var _this = this;
            var propertyValue = value ? value : '';
            var propertyKeyFieldOptions = {
                defaultValue: ko.observable(key),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required"),
                    new MsPortalFx.ViewModels.CustomValidation("This property key already exists", (function (value) {
                        var validResult = true;
                        var errorMessage = "";
                        var gridItems = _this.propertiesGrid.items();
                        var filteredItems = gridItems.filter(function (item) { return item.propertyKeyField().value() == value; });
                        if (filteredItems.length > 1) {
                            validResult = false;
                            errorMessage = "exists";
                        }
                        return Q({
                            valid: validResult,
                            message: errorMessage,
                        });
                    }))
                ]),
                emptyValueText: ko.observable("Propert Key"),
            };
            var propertyKeyField = new FxForms.TextBox.ViewModel(this._container, propertyKeyFieldOptions);
            var propertyValueFieldOptions = {
                defaultValue: ko.observable(propertyValue),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
                emptyValueText: ko.observable("Property Value"),
            };
            var propertyValueField = new FxForms.TextBox.ViewModel(this._container, propertyValueFieldOptions);
            return {
                propertyKeyField: ko.observable(propertyKeyField),
                propertyValueField: ko.observable(propertyValueField),
            };
        };
        MeteredResourceEditBladeViewModel.prototype._setFormFields = function (meterResource) {
            this.idTxField.value(meterResource.Id());
            this.providerNameTxField.value(meterResource.ProviderName());
            this.serviceTypeTxField.value(meterResource.ServiceType());
            ;
            this.meterDisplayNameTxField.value(meterResource.MeteredResourceDisplayName());
            this.meterIdField.value(meterResource.MeteredResourceName());
            this.monthlyUnitPriceTxField.value(meterResource.MonthlyUnitPrice());
            this.hourlyUnitPriceTxField.value(meterResource.HourlyUnitPrice());
            this.minimumMonthlyFeeTxField.value(meterResource.MinimumMonthlyFee());
            this.unitTxField.value(meterResource.UnitDisplayName());
            this.hourlyUnitCreditsTxField.value(meterResource.MonthlyUnitCredits());
            this.formulaTypeOptionField.value(meterResource.IsUnitFormula());
            this.formulalTxField.value(meterResource.Formula());
            this.isCollectionEnabledOptionField.value(meterResource.IsCollectionEnabled());
            this.resourceConditionMultiTxField.value(meterResource.ConditionsExpression());
            this._updateParametersGrid(meterResource.FilterProperties());
        };
        MeteredResourceEditBladeViewModel.prototype._updateParametersGrid = function (properties) {
            this.formFieldAndPropertyMapArray([]);
            for (var key in properties) {
                var value = properties[key];
                var formField = this._getFormField(key, value());
                this.formFieldAndPropertyMapArray.push(formField);
            }
            this.propertiesGrid.items(this.formFieldAndPropertyMapArray());
        };
        MeteredResourceEditBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            var _this = this;
            this.adminSubscriptionId(inputs.adminSubscriptionId);
            this.location(inputs.location);
            this.meteredResourceId(inputs.meteredResourceId);
            var args = {
                subscriptionId: this.adminSubscriptionId(),
                location: this.location(),
                meterId: this.meteredResourceId(),
            };
            return this._dataEntityView.fetch(args).then(function () {
                var dataEntity = _this._dataEntityView.item();
                var data = MeteredResourceModel.MeteredResourceModel.getMeteredResourceData(dataEntity);
                _this._setFormFields(data);
            });
        };
        return MeteredResourceEditBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.MeteredResourceEditBladeViewModel = MeteredResourceEditBladeViewModel;
});
