var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports"], function (require, exports) {
    "use strict";
    var FxForms = MsPortalFx.ViewModels.Forms;
    var FxGrid = MsPortalFx.ViewModels.Controls.Lists.Grid;
    var FxGridExtensions = FxGrid.Extensions;
    var FxToolbars = MsPortalFx.ViewModels.Toolbars;
    var Dialogs = MsPortalFx.ViewModels.Dialogs;
    var ArmHelpers = Common.Helpers;
    var UpdateMeteredPricingCatageoriesResourceBladeViewModel = (function (_super) {
        __extends(UpdateMeteredPricingCatageoriesResourceBladeViewModel, _super);
        function UpdateMeteredPricingCatageoriesResourceBladeViewModel(container, initialState, dataContext) {
            var _this = this;
            _super.call(this);
            this.adminSubscriptionId = ko.observable();
            this.pricingProfileId = ko.observable();
            this.location = ko.observable("local");
            this.meteredResourcesList = ko.observableArray();
            this.selectedMeters = ko.observableArray();
            this.title("Update Meters");
            this._container = container;
            this._dataContext = dataContext;
            this.formSection = new FxForms.Section.ViewModel(container, {
                style: ko.observable(3),
                children: ko.observableArray([])
            });
            var gridExtensions = FxGridExtensions.Filterable | FxGridExtensions.SortableColumn | FxGridExtensions.SelectableRow;
            var gridExtensionOptions = {
                filterable: {
                    searchBoxCloseButtonVisible: ko.observable(false),
                    searchBoxPlaceholder: ko.observable("Search to filter items..."),
                    searchBoxVisible: ko.observable(true),
                },
                selectableRow: {
                    selectionMode: 2,
                    activateOnSelected: ko.observable(false)
                }
            };
            this.meterdPricingCatagoryGrid = new FxGrid.ViewModel(container, ko.observableArray([]), gridExtensions, gridExtensionOptions);
            var basicColumns = [
                {
                    itemKey: "ProviderName",
                    name: ko.observable("Provider Name"),
                    width: ko.observable("50px"),
                },
                {
                    itemKey: "ServiceType",
                    name: ko.observable("Service Type"),
                    width: ko.observable("50px"),
                },
            ];
            this.meterdPricingCatagoryGrid.columns = ko.observableArray(basicColumns);
            this.meterdPricingCatagoryGrid.showHeader = true;
            this.meterdPricingCatagoryGrid.summary = ko.observable("Summary");
            this.meterdPricingCatagoryGrid.noRowsMessage("No items found");
            this.meterdPricingCatagoryGrid.selectableData.selectedItems.subscribe(container, function (selectedItems) {
                if (!selectedItems || selectedItems.length === 0) {
                    _this.selectedMeters([]);
                    return;
                }
                _this.selectedMeters(selectedItems);
            });
            this._setupCommandBar();
        }
        UpdateMeteredPricingCatageoriesResourceBladeViewModel.prototype._setupCommandBar = function () {
            this._updateButton = this._createUpdateButton();
            this.commandBar = new MsPortalFx.ViewModels.Toolbars.Toolbar(this._container);
            this.commandBar.setItems([
                this._updateButton,
            ]);
        };
        UpdateMeteredPricingCatageoriesResourceBladeViewModel.prototype._createUpdateButton = function () {
            var _this = this;
            var updateButton = new FxToolbars.DialogButton({
                label: "Update",
                icon: MsPortalFx.Base.Images.Upload(),
                dialogOptions: new Dialogs.MessageBox("", "Are you sure want to update the selected meters ?", 4),
                command: {
                    execute: function () {
                        var meters = new Array();
                        for (var i in _this.selectedMeters())
                            meters.push(_this.selectedMeters()[i].ProviderName + " _ " + _this.selectedMeters()[i].ServiceType);
                        return _this._dataContext.sharedContext.pricingProfilesDataManager.updateMeteredResources(_this.adminSubscriptionId(), _this.location(), _this.pricingProfileId(), meters)
                            .finally(function () {
                            _this._dataContext.meteredResourcePricingDataManager.listMeteredResourcesQuery.refreshAll();
                            _this._container.closeCurrentBlade();
                        });
                    },
                    canExecute: ko.computed(this._container, function () {
                        return _this.selectedMeters != null;
                    }),
                }
            });
            return updateButton;
        };
        UpdateMeteredPricingCatageoriesResourceBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            this.adminSubscriptionId(inputs.adminSubscriptionId);
            this.location(inputs.location);
            this.pricingProfileId(inputs.pricingProfileId);
            this.meteredResourcesList(JSON.parse(inputs.meteredResourcesListJson));
            var result = new Array();
            for (var i in this.meteredResourcesList()) {
                var obj = {};
                var mrp = this.meteredResourcesList()[i].split(" _ ");
                obj.ProviderName = mrp[0];
                obj.ServiceType = mrp[1];
                result.push(obj);
            }
            this.meterdPricingCatagoryGrid.items(result);
            return Q();
        };
        return UpdateMeteredPricingCatageoriesResourceBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.UpdateMeteredPricingCatageoriesResourceBladeViewModel = UpdateMeteredPricingCatageoriesResourceBladeViewModel;
});
