define(["require", "exports"], function (require, exports) {
    "use strict";
    var InvoiceModel = (function () {
        function InvoiceModel() {
            this.Id = ko.observable(0);
            this.SubscriptionId = ko.observable("");
            this.UserId = ko.observable("");
            this.BillingPeriodString = ko.observable("");
            this.InvoiceStartTime = ko.observable();
            this.InvoiceEndTime = ko.observable();
            this.InvoiceCreatedTime = ko.observable();
            this.LineItems = ko.observableArray([]);
            this.ISOCurrencySymbol = ko.observable("");
            this.CurrencySymbol = ko.observable("");
            this.FinalBillableAmount = ko.observable(0);
            this.FinalBillableAmountString = ko.observable("");
        }
        InvoiceModel.getInvoiceData = function (invoiceData) {
            return {
                Id: invoiceData.Id,
                SubscriptionId: invoiceData.SubscriptionId,
                UserId: invoiceData.UserId,
                BillingPeriodString: invoiceData.BillingPeriodString,
                InvoiceStartTime: invoiceData.InvoiceStartTime,
                InvoiceEndTime: invoiceData.InvoiceEndTime,
                InvoiceCreatedTime: invoiceData.InvoiceCreatedTime,
                LineItems: invoiceData.LineItems,
                ISOCurrencySymbol: invoiceData.ISOCurrencySymbol,
                CurrencySymbol: invoiceData.CurrencySymbol,
                FinalBillableAmount: invoiceData.FinalBillableAmount,
                FinalBillableAmountString: invoiceData.FinalBillableAmountString
            };
        };
        return InvoiceModel;
    }());
    exports.InvoiceModel = InvoiceModel;
});
