define(["require", "exports"], function (require, exports) {
    "use strict";
    var MeteredResourceModel = (function () {
        function MeteredResourceModel() {
            this.Id = ko.observable(0);
            this.PricingProfileId = ko.observable(0);
            this.ProviderName = ko.observable("");
            this.ServiceType = ko.observable("");
            this.MeteredResourceName = ko.observable("");
            this.MeteredResourceDisplayName = ko.observable("");
            this.MonthlyUnitPrice = ko.observable(0);
            this.HourlyUnitPrice = ko.observable(0);
            this.MinimumMonthlyFee = ko.observable(0);
            this.UnitDisplayName = ko.observable("");
            this.UnitMultiplier = ko.observable(0);
            this.UnitMultiplierFormula = ko.observable("");
            this.CustomFormula = ko.observable("");
            this.MonthlyUnitCredits = ko.observable(0);
            this.PromoUnitCredits = ko.observable(0);
            this.PromoPeriod = ko.observable(0);
            this.ConditionsExpression = ko.observable("");
            this.IsCollectionEnabled = ko.observable(false);
            this.IsUnitFormula = ko.observable(false);
            this.Formula = ko.observable("");
            this.DefaultRegion = ko.observable("");
            this.FilterProperties = ko.observable();
            this.FilterPropertyKey = ko.observable("");
            this.FilterPropertyValue = ko.observable("");
        }
        MeteredResourceModel.getMeteredResourceData = function (meteredResource) {
            var hourlyUnitPrice = ko.observable(meteredResource.MonthlyUnitPrice() / 720);
            return {
                Id: meteredResource.Id,
                PricingProfileId: meteredResource.PricingProfileId,
                ProviderName: meteredResource.ProviderName,
                ServiceType: meteredResource.ServiceType,
                MeteredResourceName: meteredResource.MeteredResourceName,
                MeteredResourceDisplayName: meteredResource.MeteredResourceDisplayName,
                MonthlyUnitPrice: meteredResource.MonthlyUnitPrice,
                HourlyUnitPrice: hourlyUnitPrice,
                MinimumMonthlyFee: meteredResource.MinimumMonthlyFee,
                UnitDisplayName: meteredResource.UnitDisplayName,
                UnitMultiplier: meteredResource.UnitMultiplier,
                UnitMultiplierFormula: meteredResource.UnitMultiplierFormula,
                CustomFormula: meteredResource.CustomFormula,
                MonthlyUnitCredits: meteredResource.MonthlyUnitCredits,
                PromoUnitCredits: meteredResource.PromoUnitCredits,
                PromoPeriod: meteredResource.PromoPeriod,
                ConditionsExpression: meteredResource.ConditionsExpression,
                IsCollectionEnabled: meteredResource.IsCollectionEnabled,
                IsUnitFormula: meteredResource.IsUnitFormula,
                Formula: meteredResource.Formula,
                DefaultRegion: meteredResource.DefaultRegion,
                FilterProperties: meteredResource.FilterProperties,
                FilterPropertyKey: meteredResource.FilterPropertyKey,
                FilterPropertyValue: meteredResource.FilterPropertyValue,
            };
        };
        return MeteredResourceModel;
    }());
    exports.MeteredResourceModel = MeteredResourceModel;
});
