define(["require", "exports"], function (require, exports) {
    "use strict";
    var NotificationRulesOutModel = (function () {
        function NotificationRulesOutModel() {
            this.Id = ko.observable(0);
            this.DisplayName = ko.observable('');
            this.Applicability = ko.observable('');
            this.UserId = ko.observable('');
            this.SubscriptionId = ko.observable('');
            this.RuleProviderId = ko.observable('');
            this.NotificationEmails = ko.observable('');
            this.IsEnabled = ko.observable(true);
            this.RuleParams = ko.observable();
        }
        NotificationRulesOutModel.getNotificationRulesOutData = function (notificationRule) {
            return {
                Id: notificationRule.Id,
                DisplayName: notificationRule.DisplayName,
                Applicability: notificationRule.Applicability,
                UserId: notificationRule.UserId,
                SubscriptionId: notificationRule.SubscriptionId,
                RuleProviderId: notificationRule.RuleProviderId,
                NotificationEmails: notificationRule.NotificationEmails,
                IsEnabled: notificationRule.IsEnabled,
                RuleParams: notificationRule.RuleParams,
            };
        };
        return NotificationRulesOutModel;
    }());
    exports.NotificationRulesOutModel = NotificationRulesOutModel;
    var NotificationEventModel = (function () {
        function NotificationEventModel() {
            this.Id = ko.observable(0);
            this.UserId = ko.observable('');
            this.SubscriptionID = ko.observable('');
            this.TimestampString = ko.observable('');
            this.Title = ko.observable('');
            this.Description = ko.observable('');
            this.EmailBody = ko.observable('');
            this.SMSText = ko.observable('');
            this.Level = ko.observable(0);
            this.LevelString = ko.observable('');
            this.ReferenceId = ko.observable('');
            this.Trigger = ko.observable(0);
            this.TriggeredBy = ko.observable('');
            this.IsDismissed = ko.observable(true);
        }
        NotificationEventModel.getNotificationEventModelData = function (eventMessage) {
            return {
                Id: eventMessage.Id,
                UserId: eventMessage.UserId,
                SubscriptionID: eventMessage.SubscriptionID,
                TimestampString: eventMessage.TimestampString,
                Title: eventMessage.Title,
                Description: eventMessage.Description,
                EmailBody: eventMessage.EmailBody,
                SMSText: eventMessage.SMSText,
                Level: eventMessage.Level,
                LevelString: eventMessage.LevelString,
                ReferenceId: eventMessage.ReferenceId,
                Trigger: eventMessage.Trigger,
                TriggeredBy: eventMessage.TriggeredBy,
                IsDismissed: eventMessage.IsDismissed,
            };
        };
        return NotificationEventModel;
    }());
    exports.NotificationEventModel = NotificationEventModel;
});
