define(["require", "exports"], function (require, exports) {
    "use strict";
    var PricingProfileModel = (function () {
        function PricingProfileModel() {
            this.Id = ko.observable(0);
            this.name = ko.observable("");
            this.displayName = ko.observable("");
            this.ProfileName = ko.observable("");
            this.BasePricingProfileIds = ko.observableArray([]);
            this.CatalogName = ko.observable("");
            this.CatalogSequenceNumber = ko.observable(0);
            this.CatalogAmount = ko.observable("");
            this.Advertisement = ko.observable("");
            this.Type = ko.observable("");
            this.Region = ko.observable("");
            this.MonthlyFee = ko.observable(0);
            this.OneTimeFee = ko.observable(0);
            this.IncludedMonthlyCreditAmount = ko.observable(0);
            this.PromoCredit = ko.observable(0);
            this.PromoPercent = ko.observable(0);
            this.PromoPeriod = ko.observable(0);
            this.MinimumCommitmentDuration = ko.observable(0);
            this.IsMonthlyPromoPeriod = ko.observable(false);
            this.PromotionType = ko.observable(0);
            this.PromotionTypeString = ko.observable("");
            this.PaymentFrequency = ko.observable(0);
            this.PaymentFrequencyString = ko.observable("");
            this.ISOCurrencySymbol = ko.observable("");
            this.CurrencySymbol = ko.observable("");
            this.Terms = ko.observable("");
            this.IsShowOnlyTerms = ko.observable(false);
            this.IsDeleted = ko.observable(false);
            this.IsStandardTaxRateApplicable = ko.observable(false);
            this.IsMinimumMonthlyFeeApplicable = ko.observable(false);
            this.MarkupPercent = ko.observable(0);
            this.ApplyMarkupOnlyToBasePP = ko.observable(false);
            this.IsAggregateBaseMarkups = ko.observable(false);
            this.ProviderNames = ko.observableArray([]);
            this.PricingProfileType = ko.observable(0);
            this.PricingProfileTypeString = ko.observable("");
            this.PromoCreditInPercentage = ko.observable(false);
            this.UpdateExistingSubscriptions = ko.observable(false);
        }
        PricingProfileModel.getPricingProfileData = function (profile) {
            return {
                Id: profile.Id,
                name: profile.name,
                displayName: profile.displayName,
                ProfileName: profile.ProfileName,
                BasePricingProfileIds: profile.BasePricingProfileIds,
                CatalogName: profile.CatalogName,
                CatalogSequenceNumber: profile.CatalogSequenceNumber,
                CatalogAmount: profile.CatalogAmount,
                Advertisement: profile.Advertisement,
                Type: profile.Type,
                Region: profile.Region,
                MonthlyFee: profile.MonthlyFee,
                OneTimeFee: profile.OneTimeFee,
                IncludedMonthlyCreditAmount: profile.IncludedMonthlyCreditAmount,
                PromoCredit: profile.PromoCredit,
                PromoPercent: profile.PromoPercent,
                PromoPeriod: profile.PromoPeriod,
                MinimumCommitmentDuration: profile.MinimumCommitmentDuration,
                IsMonthlyPromoPeriod: profile.IsMonthlyPromoPeriod,
                PromotionType: profile.PromotionType,
                PromotionTypeString: profile.PromotionTypeString,
                PaymentFrequency: profile.PaymentFrequency,
                PaymentFrequencyString: profile.PaymentFrequencyString,
                ISOCurrencySymbol: profile.ISOCurrencySymbol,
                CurrencySymbol: profile.CurrencySymbol,
                Terms: profile.Terms,
                IsShowOnlyTerms: profile.IsShowOnlyTerms,
                IsDeleted: profile.IsDeleted,
                IsStandardTaxRateApplicable: profile.IsStandardTaxRateApplicable,
                IsMinimumMonthlyFeeApplicable: profile.IsMinimumMonthlyFeeApplicable,
                MarkupPercent: profile.MarkupPercent,
                ApplyMarkupOnlyToBasePP: profile.ApplyMarkupOnlyToBasePP,
                IsAggregateBaseMarkups: profile.IsAggregateBaseMarkups,
                ProviderNames: profile.ProviderNames,
                PricingProfileType: profile.PromotionType,
                PricingProfileTypeString: profile.PromotionTypeString,
                PromoCreditInPercentage: profile.PromoCreditInPercentage,
                UpdateExistingSubscriptions: profile.UpdateExistingSubscriptions,
            };
        };
        return PricingProfileModel;
    }());
    exports.PricingProfileModel = PricingProfileModel;
});
