define(["require", "exports"], function (require, exports) {
    "use strict";
    var ProductFeaturesSettingsModel = (function () {
        function ProductFeaturesSettingsModel() {
            this.IsPromotionsFeatureEnabled = ko.observable(false);
            this.IsNotificationsFeatureEnabledForTenant = ko.observable(false);
            this.IsInvoicesFeatureEnabledForTenant = ko.observable(false);
            this.CanTenantDownloadInvoicePDF = ko.observable(false);
            this.ShouldShowCoAdminSubscriptionsToTenants = ko.observable(false);
            this.IsPricingCatalogFeatureEnabled = ko.observable(false);
            this.IsInvokeSubscriptionCrudTemplates = ko.observable(false);
            this.IsPaymentGatewayFeatureEnabled = ko.observable(false);
            this.IsUserProfileFeatureEnabled = ko.observable(false);
            this.IsCSPFeatureEnabled = ko.observable(false);
            this.AllowTenantsToPayViaStripe = ko.observable(false);
            this.ShowOnlyAzureStackQuotaBlades = ko.observable(false);
        }
        ProductFeaturesSettingsModel.getProductFeaturesSettingsData = function (setting) {
            return {
                IsPromotionsFeatureEnabled: setting.IsPromotionsFeatureEnabled,
                IsNotificationsFeatureEnabledForTenant: setting.IsNotificationsFeatureEnabledForTenant,
                IsInvoicesFeatureEnabledForTenant: setting.IsInvoicesFeatureEnabledForTenant,
                CanTenantDownloadInvoicePDF: setting.CanTenantDownloadInvoicePDF,
                ShouldShowCoAdminSubscriptionsToTenants: setting.ShouldShowCoAdminSubscriptionsToTenants,
                IsPricingCatalogFeatureEnabled: setting.IsPricingCatalogFeatureEnabled,
                IsInvokeSubscriptionCrudTemplates: setting.IsInvokeSubscriptionCrudTemplates,
                IsPaymentGatewayFeatureEnabled: setting.IsPaymentGatewayFeatureEnabled,
                IsUserProfileFeatureEnabled: setting.IsUserProfileFeatureEnabled,
                IsCSPFeatureEnabled: setting.IsCSPFeatureEnabled,
                AllowTenantsToPayViaStripe: setting.AllowTenantsToPayViaStripe,
                ShowOnlyAzureStackQuotaBlades: setting.ShowOnlyAzureStackQuotaBlades,
            };
        };
        return ProductFeaturesSettingsModel;
    }());
    exports.ProductFeaturesSettingsModel = ProductFeaturesSettingsModel;
    var InvoicePdfSettingsModel = (function () {
        function InvoicePdfSettingsModel() {
            this.HeaderContent = ko.observable("");
            this.FooterContent = ko.observable("");
            this.InvoiceDueDate = ko.observable();
            this.NotificationEmailDate = ko.observable();
            this.CompanyLogoPath = ko.observable("");
            this.CompanyName = ko.observable("");
            this.CompanyLogoPosition = ko.observable("");
            this.InvoiceDisplayName = ko.observable("");
            this.InvoicePeriodDisplayName = ko.observable("");
            this.LineItemsTableDisplayName = ko.observable("");
            this.LineItemsTableDescriptionColumnName = ko.observable("");
            this.LineItemsTableQuantityColumnName = ko.observable("");
            this.LineitemsTableUnitPriceColumnName = ko.observable("");
            this.LineItemsTableAmountColumnName = ko.observable("");
            this.LineItemsSumDisplayName = ko.observable("");
            this.UserDisplayName = ko.observable("");
            this.SubscriptionDisplayName = ko.observable("");
            this.NotesDisplayName = ko.observable("");
            this.Notes = ko.observable("");
            this.ApplyTax = ko.observable(false);
            this.StandardTaxRate = ko.observable();
            this.DefaultCurrencyCode = ko.observable("");
            this.ApplyCurrencyCode = ko.observable(false);
            this.ProrateMonthlyFeeInPricingProfiles = ko.observable(true);
            this.ProrateFixedFeeAddOns = ko.observable(true);
            this.DefaultDateFormatInCsv = ko.observable("");
            this.DateTimeFormatCsv = ko.observable("");
            this.FixedFeeAddOnDisplayName = ko.observable("");
            this.ForSubscriptionDisplayName = ko.observable("");
            this.InstanceIdDisplayName = ko.observable("");
            this.MrpMinimumMonthlyFeeDisplayName = ko.observable("");
            this.MinimumMonthlyFeeDisplayName = ko.observable("");
            this.UnitsDisplayName = ko.observable("");
            this.PeriodDisplayName = ko.observable("");
            this.UnitCreditsDisplayName = ko.observable("");
            this.OneTimeFeeDisplayName = ko.observable("");
            this.StandardTaxDisplayName = ko.observable("");
            this.UserCreditsDisplayName = ko.observable("");
            this.PromotionCreditsDisplayName = ko.observable("");
            this.ExclusiveCreditsDisplayName = ko.observable("");
            this.ServiceCatalogDisplayName = ko.observable("");
        }
        InvoicePdfSettingsModel.getInvoicePdfSettingsData = function (setting) {
            return {
                HeaderContent: setting.HeaderContent,
                FooterContent: setting.FooterContent,
                InvoiceDueDate: setting.InvoiceDueDate,
                NotificationEmailDate: setting.NotificationEmailDate,
                CompanyLogoPath: setting.CompanyLogoPath,
                CompanyLogoPosition: setting.CompanyLogoPosition,
                CompanyName: setting.CompanyName,
                InvoiceDisplayName: setting.InvoiceDisplayName,
                InvoicePeriodDisplayName: setting.InvoicePeriodDisplayName,
                LineItemsTableDisplayName: setting.LineItemsTableDisplayName,
                LineItemsTableDescriptionColumnName: setting.LineItemsTableDescriptionColumnName,
                LineItemsTableQuantityColumnName: setting.LineItemsTableQuantityColumnName,
                LineitemsTableUnitPriceColumnName: setting.LineitemsTableUnitPriceColumnName,
                LineItemsTableAmountColumnName: setting.LineItemsTableAmountColumnName,
                LineItemsSumDisplayName: setting.LineItemsSumDisplayName,
                UserDisplayName: setting.UserDisplayName,
                SubscriptionDisplayName: setting.SubscriptionDisplayName,
                NotesDisplayName: setting.NotesDisplayName,
                Notes: setting.Notes,
                ApplyTax: setting.ApplyTax,
                StandardTaxRate: setting.StandardTaxRate,
                DefaultCurrencyCode: setting.DefaultCurrencyCode,
                ApplyCurrencyCode: setting.ApplyCurrencyCode,
                ProrateMonthlyFeeInPricingProfiles: setting.ProrateMonthlyFeeInPricingProfiles,
                ProrateFixedFeeAddOns: setting.ProrateFixedFeeAddOns,
                DefaultDateFormatInCsv: setting.DefaultDateFormatInCsv,
                DateTimeFormatCsv: setting.DateTimeFormatCsv,
                FixedFeeAddOnDisplayName: setting.FixedFeeAddOnDisplayName,
                ForSubscriptionDisplayName: setting.ForSubscriptionDisplayName,
                InstanceIdDisplayName: setting.InstanceIdDisplayName,
                MrpMinimumMonthlyFeeDisplayName: setting.MrpMinimumMonthlyFeeDisplayName,
                MinimumMonthlyFeeDisplayName: setting.MinimumMonthlyFeeDisplayName,
                UnitsDisplayName: setting.UnitsDisplayName,
                PeriodDisplayName: setting.PeriodDisplayName,
                UnitCreditsDisplayName: setting.UnitCreditsDisplayName,
                OneTimeFeeDisplayName: setting.OneTimeFeeDisplayName,
                StandardTaxDisplayName: setting.StandardTaxDisplayName,
                UserCreditsDisplayName: setting.UserCreditsDisplayName,
                PromotionCreditsDisplayName: setting.PromotionCreditsDisplayName,
                ExclusiveCreditsDisplayName: setting.ExclusiveCreditsDisplayName,
                ServiceCatalogDisplayName: setting.ServiceCatalogDisplayName,
            };
        };
        return InvoicePdfSettingsModel;
    }());
    exports.InvoicePdfSettingsModel = InvoicePdfSettingsModel;
    var CspSettingsModel = (function () {
        function CspSettingsModel() {
            this.AuthenticationType = ko.observable("");
            this.DefaultAuthenticationType = ko.observable("");
            this.PartnerServiceApiEndpoint = ko.observable("");
            this.AuthenticationAuthorityEndpoint = ko.observable("");
            this.AzureActiveDirectoryGraphApiEndpoint = ko.observable("");
            this.AuthenticationApplicationId = ko.observable("");
            this.Domain = ko.observable("");
            this.ResourceUrl = ko.observable("");
            this.RedirectUrl = ko.observable("");
            this.UserName = ko.observable("");
            this.Password = ko.observable("");
            this.ApplicationSecret = ko.observable("");
            this.Market = ko.observable("");
            this.Language = ko.observable("");
            this.Culture = ko.observable("");
        }
        CspSettingsModel.getCspSettingsData = function (setting) {
            return {
                AuthenticationType: setting.AuthenticationType,
                DefaultAuthenticationType: setting.DefaultAuthenticationType,
                PartnerServiceApiEndpoint: setting.PartnerServiceApiEndpoint,
                AuthenticationAuthorityEndpoint: setting.AuthenticationAuthorityEndpoint,
                AzureActiveDirectoryGraphApiEndpoint: setting.AzureActiveDirectoryGraphApiEndpoint,
                AuthenticationApplicationId: setting.AuthenticationApplicationId,
                Domain: setting.Domain,
                ResourceUrl: setting.ResourceUrl,
                RedirectUrl: setting.RedirectUrl,
                UserName: setting.UserName,
                Password: setting.Password,
                ApplicationSecret: setting.ApplicationSecret,
                Market: setting.Market,
                Language: setting.Language,
                Culture: setting.Culture,
            };
        };
        return CspSettingsModel;
    }());
    exports.CspSettingsModel = CspSettingsModel;
    var EmailNotificationSettingsModel = (function () {
        function EmailNotificationSettingsModel() {
            this.SMTPHost = ko.observable("");
            this.SMTPPort = ko.observable("");
            this.SMTPIsSSL = ko.observable("");
            this.SMTPUser = ko.observable("");
            this.SMTPPassword = ko.observable("");
            this.AdminEmailIds = ko.observable("");
            this.SMTPIsAuthenticate = ko.observable("");
            this.TenantPortalUrl = ko.observable("");
        }
        EmailNotificationSettingsModel.getEmailSettingsData = function (setting) {
            return {
                SMTPHost: setting.SMTPHost,
                SMTPPort: setting.SMTPPort,
                SMTPIsSSL: setting.SMTPIsSSL,
                SMTPUser: setting.SMTPUser,
                SMTPPassword: setting.SMTPPassword,
                AdminEmailIds: setting.AdminEmailIds,
                SMTPIsAuthenticate: setting.SMTPIsAuthenticate,
                TenantPortalUrl: setting.TenantPortalUrl,
            };
        };
        return EmailNotificationSettingsModel;
    }());
    exports.EmailNotificationSettingsModel = EmailNotificationSettingsModel;
    var StripeSettingsModel = (function () {
        function StripeSettingsModel() {
            this.StripePublishableKey = ko.observable("");
            this.StripeSecretKey = ko.observable("");
            this.StripeZeroDecimalCurrencies = ko.observable("");
            this.BillingTenantExtUrl = ko.observable("");
        }
        StripeSettingsModel.getStripeSettingsData = function (setting) {
            return {
                StripePublishableKey: setting.StripePublishableKey,
                StripeSecretKey: setting.StripeSecretKey,
                StripeZeroDecimalCurrencies: setting.StripeZeroDecimalCurrencies,
                BillingTenantExtUrl: setting.BillingTenantExtUrl
            };
        };
        return StripeSettingsModel;
    }());
    exports.StripeSettingsModel = StripeSettingsModel;
    var AzureStackUsageCollectorSettingsModel = (function () {
        function AzureStackUsageCollectorSettingsModel() {
            this.AdminSubscriptionId = ko.observable("");
            this.TenantId = ko.observable("");
            this.ApplicationId = ko.observable("");
            this.CertificateThumbprint = ko.observable("");
            this.AzureStackAdminArmEndpointUrl = ko.observable("");
            this.AzureStackAuthorityEndpointUrl = ko.observable("");
            this.NumberOfDaysOfUsage = ko.observable("");
            this.NumberOfHoursOfNoUsage = ko.observable("");
            this.AzureStackTokenRequestResourceUrl = ko.observable("");
        }
        AzureStackUsageCollectorSettingsModel.getAzureStackUsageCollectorSettingsData = function (setting) {
            return {
                AdminSubscriptionId: setting.AdminSubscriptionId,
                TenantId: setting.TenantId,
                ApplicationId: setting.ApplicationId,
                CertificateThumbprint: setting.CertificateThumbprint,
                AzureStackAdminArmEndpointUrl: setting.AzureStackAdminArmEndpointUrl,
                AzureStackAuthorityEndpointUrl: setting.AzureStackAuthorityEndpointUrl,
                NumberOfDaysOfUsage: setting.NumberOfDaysOfUsage,
                NumberOfHoursOfNoUsage: setting.NumberOfHoursOfNoUsage,
                AzureStackTokenRequestResourceUrl: setting.AzureStackTokenRequestResourceUrl,
            };
        };
        return AzureStackUsageCollectorSettingsModel;
    }());
    exports.AzureStackUsageCollectorSettingsModel = AzureStackUsageCollectorSettingsModel;
    var DomainUserSettingsModel = (function () {
        function DomainUserSettingsModel() {
            this.DomainName = ko.observable("");
            this.DomainUserName = ko.observable("");
            this.DomainUserPassword = ko.observable("");
        }
        DomainUserSettingsModel.getDomainUserSettingsData = function (setting) {
            return {
                DomainName: setting.DomainName,
                DomainUserName: setting.DomainUserName,
                DomainUserPassword: setting.DomainUserPassword,
            };
        };
        return DomainUserSettingsModel;
    }());
    exports.DomainUserSettingsModel = DomainUserSettingsModel;
    var MiscSettingsModel = (function () {
        function MiscSettingsModel() {
            this.IsEmailNotificationEnabledForInvoices = ko.observable(false);
            this.ShouldSendEmailAlertForAgentServiceHealthStatus = ko.observable(false);
            this.ShouldSendEmailAlertForJobProcessorHealthStatus = ko.observable(false);
        }
        ;
        ;
        ;
        MiscSettingsModel.getMiscSettingsData = function (setting) {
            return {
                IsEmailNotificationEnabledForInvoices: setting.IsEmailNotificationEnabledForInvoices,
                ShouldSendEmailAlertForAgentServiceHealthStatus: setting.ShouldSendEmailAlertForAgentServiceHealthStatus,
                ShouldSendEmailAlertForJobProcessorHealthStatus: setting.ShouldSendEmailAlertForJobProcessorHealthStatus,
            };
        };
        return MiscSettingsModel;
    }());
    exports.MiscSettingsModel = MiscSettingsModel;
});
