var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "../../Shared/Helpers", "../../_generated/BladeReferences"], function (require, exports, Helpers, BladeReferences) {
    "use strict";
    var FxToolbars = MsPortalFx.ViewModels.Toolbars;
    var Dialogs = MsPortalFx.ViewModels.Dialogs;
    var FxGrid = MsPortalFx.ViewModels.Controls.Lists.Grid;
    var FxGridExtensions = FxGrid.Extensions;
    "use strict";
    var NotificationRulesBladeViewModel = (function (_super) {
        __extends(NotificationRulesBladeViewModel, _super);
        function NotificationRulesBladeViewModel(container, initialState, dataContext) {
            var _this = this;
            _super.call(this);
            this.subscriptionId = ko.observable();
            this.location = ko.observable();
            this._userOverview = ko.observable();
            this.selectedRule = ko.pureComputed(function () {
                return _this.notificationRulesGrid.selectableData.selectedItems().first();
            });
            this.title("Messages");
            this._container = container;
            this._dataContext = dataContext;
            this._dataEntityView = dataContext.notificationsDataManager.listNotificationRulesEntity.createView(container, {
                interceptNotFound: false
            });
            ko.reactor(container, function () {
            });
            var gridExtensions = FxGridExtensions.SelectableRow;
            var gridExtensionOptions = {
                selectableRow: {
                    selectionMode: 1,
                    activateOnSelected: ko.observable(false)
                }
            };
            this.notificationRulesGrid = new FxGrid.ViewModel(container, ko.observableArray([]), gridExtensions, gridExtensionOptions);
            var dateTimeFormat = Helpers.getTimeFormat(false, true);
            var basicColumns = [
                {
                    itemKey: "Id",
                    name: ko.observable("Id"),
                    width: ko.observable("50px"),
                },
                {
                    itemKey: "DisplayName",
                    name: ko.observable("Name"),
                    width: ko.observable("120px"),
                },
                {
                    itemKey: "RuleProviderId",
                    name: ko.observable("Event"),
                    width: ko.observable("50px"),
                },
                {
                    itemKey: "Status",
                    name: ko.observable("Status"),
                    width: ko.observable("50px"),
                },
                {
                    itemKey: "NextCheck",
                    name: ko.observable("Next Check"),
                    width: ko.observable("50px"),
                    format: MsPortalFx.ViewModels.Controls.Lists.Grid.Format.CustomDate,
                    formatOptions: {
                        dateFormat: dateTimeFormat
                    }
                },
                {
                    itemKey: "LastTriggerAt",
                    name: ko.observable("Last Trigger At"),
                    width: ko.observable("50px"),
                    format: MsPortalFx.ViewModels.Controls.Lists.Grid.Format.CustomDate,
                    formatOptions: {
                        dateFormat: dateTimeFormat
                    }
                },
            ];
            this.notificationRulesGrid.columns = ko.observableArray(basicColumns);
            this.notificationRulesGrid.showHeader = true;
            this.notificationRulesGrid.summary = ko.observable("Summary");
            this.notificationRulesGrid.noRowsMessage("No items found");
            this._dataEntityView.item.subscribe(container, function (notificationRules) {
                _this.notificationRulesGrid.items(notificationRules);
            });
            this._dataEntityView.loading.subscribe(container, function (isLoading) {
                _this.notificationRulesGrid.loading(isLoading);
            });
            this._setupCommandBar();
        }
        NotificationRulesBladeViewModel.prototype._setupCommandBar = function () {
            this._addNotificationRuleButton = this._createAddRuleButton();
            this._editNotificationRuleButton = this._createEditRuleButton();
            this._deleteNotificationRuleButton = this._createDeleteNotificationRuleButton();
            this._clearAllNotificationRuleButton = this._createClearAllNotificationRuleButton();
            this.commandBar = new MsPortalFx.ViewModels.Toolbars.Toolbar(this._container);
            this.commandBar.setItems([
                this._addNotificationRuleButton,
                this._editNotificationRuleButton,
                this._deleteNotificationRuleButton,
                this._clearAllNotificationRuleButton,
            ]);
        };
        NotificationRulesBladeViewModel.prototype._getNewNotificationRule = function () {
            var ruleParams = {};
            ruleParams['CreditBalanceGreaterThan'] = '0';
            ruleParams['CreditBalanceLessThan'] = '0';
            return {
                SubscriptionId: '',
                Id: 0,
                RuleProviderId: '',
                DisplayName: '',
                NotificationEmails: '',
                IsEnabled: true,
                RuleParams: ruleParams
            };
        };
        NotificationRulesBladeViewModel.prototype._getSelectedNotificationRule = function () {
            var ruleParams = {};
            ruleParams['CreditBalanceGreaterThan'] = this.selectedRule().RuleParams().CreditBalanceGreaterThan();
            ruleParams['CreditBalanceLessThan'] = this.selectedRule().RuleParams().CreditBalanceLessThan();
            return {
                SubscriptionId: '',
                Id: this.selectedRule().Id(),
                RuleProviderId: this.selectedRule().RuleProviderId(),
                DisplayName: this.selectedRule().DisplayName(),
                NotificationEmails: this.selectedRule().NotificationEmails(),
                IsEnabled: this.selectedRule().IsEnabled(),
                RuleParams: ruleParams
            };
        };
        NotificationRulesBladeViewModel.prototype._createAddRuleButton = function () {
            var _this = this;
            var addButton = new FxToolbars.CommandButton({
                label: "Add",
                icon: MsPortalFx.Base.Images.Add(),
                command: {
                    execute: function () {
                        return _this._container.openBlade(new BladeReferences.NotificationAddEditBladeReference({
                            isAdd: true,
                            subscriptionId: _this.subscriptionId(),
                            location: _this.location(),
                            selectedRule: _this._getNewNotificationRule(),
                        }));
                    },
                    canExecute: ko.observable(true),
                }
            });
            return addButton;
        };
        NotificationRulesBladeViewModel.prototype._createEditRuleButton = function () {
            var _this = this;
            var editButton = new FxToolbars.CommandButton({
                label: "Edit",
                icon: MsPortalFx.Base.Images.Edit(),
                command: {
                    execute: function () {
                        return _this._container.openBlade(new BladeReferences.NotificationAddEditBladeReference({
                            isAdd: false,
                            subscriptionId: _this.subscriptionId(),
                            location: _this.location(),
                            selectedRule: _this._getSelectedNotificationRule(),
                        }));
                    },
                    canExecute: ko.computed(this._container, function () {
                        return _this.selectedRule() != null;
                    }),
                }
            });
            return editButton;
        };
        NotificationRulesBladeViewModel.prototype._createDeleteNotificationRuleButton = function () {
            var _this = this;
            var deleteButton = new FxToolbars.DialogButton({
                label: "Delete",
                icon: MsPortalFx.Base.Images.Delete(),
                dialogOptions: new Dialogs.MessageBox("", "Are you sure you want to delete the selected notification rule ?", 4),
            });
            deleteButton.command = {
                canExecute: ko.computed(this._container, function () {
                    return _this.selectedRule() != null;
                }),
                execute: function (result) {
                    if (result === 6) {
                        _this._dataContext.notificationsDataManager.deleteNotificationRuleQuery(_this.subscriptionId(), _this.location(), _this.selectedRule().Id());
                    }
                    return null;
                }
            };
            return deleteButton;
        };
        NotificationRulesBladeViewModel.prototype._createClearAllNotificationRuleButton = function () {
            var _this = this;
            var clearButton = new FxToolbars.DialogButton({
                label: "Clear All",
                icon: MsPortalFx.Base.Images.Clock(),
                dialogOptions: new Dialogs.MessageBox("", "Are you sure you want to clear all notification rules ?", 4),
            });
            clearButton.command = {
                canExecute: ko.observable(true),
                execute: function (result) {
                    if (result === 6) {
                        _this._dataContext.notificationsDataManager.clearAllNotificationRuleQuery(_this.subscriptionId(), _this.location());
                    }
                    return null;
                }
            };
            return clearButton;
        };
        NotificationRulesBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            this.subscriptionId(inputs.subscriptionId);
            this.location(inputs.location);
            return this._dataEntityView.fetch({
                subscriptionId: this.subscriptionId(),
                location: this.location(),
            });
        };
        return NotificationRulesBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.NotificationRulesBladeViewModel = NotificationRulesBladeViewModel;
});
