var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "ClientResources", "../../_generated/ExtensionDefinition"], function (require, exports, ClientResources, ExtensionDefinition) {
    "use strict";
    var ArmHelpers = Common.Helpers;
    "use strict";
    var PricingProfileBladeViewModel = (function (_super) {
        __extends(PricingProfileBladeViewModel, _super);
        function PricingProfileBladeViewModel(container, initialState, dataContext) {
            _super.call(this);
            this.subscriptionId = ko.observable("");
            this.location = ko.observable("");
            this.title(ClientResources.Assets.Billing.lowerPlural);
        }
        PricingProfileBladeViewModel.prototype.onInputsSet = function (inputs) {
            this.subtitle("");
            this.subscriptionId(inputs.parameters.subscriptionId);
            this.location(inputs.parameters.location);
            return null;
        };
        return PricingProfileBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.PricingProfileBladeViewModel = PricingProfileBladeViewModel;
    var PricingProfilePartViewModel = (function (_super) {
        __extends(PricingProfilePartViewModel, _super);
        function PricingProfilePartViewModel(container, initialState, dataContext) {
            var pricingProfileBladeInputs = ko.observable();
            var mappingProfileBladeInputs = ko.observable();
            _super.call(this, container, initialState, PricingProfilePartViewModel._getPricingProfileBlades(container, pricingProfileBladeInputs, mappingProfileBladeInputs));
            this.subscriptionId = ko.observable("");
            this.location = ko.observable("");
            this._dataContext = dataContext;
            this._pricingProfileBladeInputs = pricingProfileBladeInputs;
            this._mappingProfileBladeInputs = mappingProfileBladeInputs;
        }
        PricingProfilePartViewModel._getPricingProfileBlades = function (lifetimeManager, pricingProfileBladeInputs, mappingProfileBladeInputs) {
            var pricingProfile = new MsPortalFx.ViewModels.Parts.SettingList.Setting("pricingProfile", ExtensionDefinition.BladeNames.pricingProfilesCollectionBlade, pricingProfileBladeInputs);
            pricingProfile.displayText("Base Profiles");
            pricingProfile.icon(MsPortalFx.Base.Images.Polychromatic.FolderCube());
            pricingProfile.group("");
            var mappingProfile = new MsPortalFx.ViewModels.Parts.SettingList.Setting("mapBaseProfiles", ExtensionDefinition.BladeNames.pricingProfileMappingBlade, mappingProfileBladeInputs);
            mappingProfile.displayText("Linked Profiles");
            mappingProfile.icon(MsPortalFx.Base.Images.Polychromatic.Branch());
            mappingProfile.group("");
            return [pricingProfile, mappingProfile];
        };
        PricingProfilePartViewModel.prototype.onInputsSet = function (inputs) {
            this._pricingProfileBladeInputs({ adminSubscriptionId: inputs.parameters.subscriptionId, location: inputs.parameters.location });
            this._mappingProfileBladeInputs({ subscriptionId: inputs.parameters.subscriptionId, location: inputs.parameters.location });
            this.subscriptionId(inputs.parameters.subscriptionId);
            this.location(inputs.parameters.location);
            return Q();
        };
        return PricingProfilePartViewModel;
    }(MsPortalFx.ViewModels.Parts.SettingList.ViewModelV2));
    exports.PricingProfilePartViewModel = PricingProfilePartViewModel;
});
