var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "ClientResources", "../../Models/PricingProfileModel"], function (require, exports, ClientResources, PricingProfileModel) {
    "use strict";
    var FxForms = MsPortalFx.ViewModels.Forms;
    var ArmHelpers = Common.Helpers;
    var PricingProfileDetailsBladeViewModel = (function (_super) {
        __extends(PricingProfileDetailsBladeViewModel, _super);
        function PricingProfileDetailsBladeViewModel(container, initialState, dataContext) {
            var _this = this;
            _super.call(this);
            this.adminSubscriptionId = ko.observable();
            this.location = ko.observable("local");
            this.pricingProfileId = ko.observable();
            this.isPromotionFeatureEnabled = ko.observable(true);
            this.pricingProfile = ko.observable();
            this._selectedBaseProfileId = ko.observable();
            this.baseProfiles = ko.observableArray();
            this.isDisableBaseProfileSelectOption = ko.observable(false);
            this.title("Pricing Profile Details");
            this._container = container;
            this._dataContext = dataContext;
            this._dataEntityView = dataContext.pricingProfilesDataManager.pricingProfileEntity.createView(container, {
                interceptNotFound: false
            });
            this._enabledFeaturesEntityView = dataContext.sharedContext.licenseDataManager.enabledFeaturesEntity.createView(container, {
                interceptNotFound: false
            });
            this._dataEntityView.item.subscribe(container, function (pricingProfile) {
                if (pricingProfile.IsMinimumMonthlyFeeApplicable()) {
                    _this.monthlyFeeTxField.disabled(false);
                }
                else {
                    _this.monthlyFeeTxField.disabled(true);
                }
                if (pricingProfile.IsDisableBaseProfileSelectOption()) {
                    _this.baseProfilesDdownField.disabled(true);
                }
                else {
                    _this.baseProfilesDdownField.disabled(false);
                }
            });
            this._initializeFormFields(container);
            this._setupCommandBar();
            this.baseProfilesDdownField.value.subscribe(container, function (selectedBase) {
                if (selectedBase != null) {
                    _this._selectedBaseProfileId(selectedBase);
                }
            });
        }
        PricingProfileDetailsBladeViewModel.prototype._initializeFormFields = function (container) {
            var _this = this;
            var customValidation = new MsPortalFx.ViewModels.CustomValidation("", (function (value) {
                var validResult = true;
                var errorMessage = "";
                if (value.value()) {
                    _this.monthlyFeeTxField.disabled(false);
                }
                else {
                    _this.monthlyFeeTxField.disabled(true);
                    _this.monthlyFeeTxField.value(0);
                }
                return Q({
                    valid: validResult,
                    message: errorMessage,
                });
            }));
            var customValidationForPromotions = new MsPortalFx.ViewModels.CustomValidation("", (function (value) {
                var validResult = true;
                var errorMessage = "";
                if (value.value() == 0 || value.value() == 10) {
                    _this.promortionPeriodTxField.disabled(true);
                    _this.promortionPeriodTxField.value(0);
                }
                else {
                    _this.promortionPeriodTxField.disabled(false);
                }
                if (value.value() == 0) {
                    _this.updatePromoCreditToExistingSubsOptionField.disabled(true);
                    _this.updatePromoCreditToExistingSubsOptionField.value(false);
                }
                else {
                    _this.updatePromoCreditToExistingSubsOptionField.disabled(false);
                }
                return Q({
                    valid: validResult,
                    message: errorMessage,
                });
            }));
            var profileIdOptions = {
                label: ko.observable("Profile Id"),
                readonly: true,
                validations: ko.observableArray([]),
            };
            this.profileIdTxField = new MsPortalFx.ViewModels.Forms.NumericTextBox.ViewModel(container, profileIdOptions);
            this.profileIdTxField.disabled(true);
            var profileNameOptions = {
                label: ko.observable("Profile Name"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.profileNameTxField = new MsPortalFx.ViewModels.Forms.TextBox.ViewModel(container, profileNameOptions);
            var monthlyFeeOptions = {
                label: ko.observable("Monthly Fee"),
                validations: ko.observableArray([]),
                decimalPoint: ko.observable(10),
                max: ko.observable(999999999),
            };
            this.monthlyFeeTxField = new MsPortalFx.ViewModels.Forms.NumericTextBox.ViewModel(container, monthlyFeeOptions);
            var isMonthlyFeeOptions = {
                label: ko.observable("Set Monthly Fee ?"),
                options: ko.observableArray([
                    { text: ko.observable("Yes"), value: true },
                    { text: ko.observable("No"), value: false }
                ]),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required"),
                    customValidation
                ]),
            };
            this.isMonthlyFeeSetOptionField = new FxForms.OptionsGroup.ViewModel(container, isMonthlyFeeOptions);
            var oneTimeFeeOptions = {
                label: ko.observable("One-Time Fee"),
                validations: ko.observableArray([]),
                decimalPoint: ko.observable(10),
                max: ko.observable(999999999),
            };
            this.oneTimeFeeTxField = new MsPortalFx.ViewModels.Forms.NumericTextBox.ViewModel(container, oneTimeFeeOptions);
            var isTaxApplicableOptions = {
                label: ko.observable("Apply Standard Tax ?"),
                options: ko.observableArray([
                    { text: ko.observable("Yes"), value: true },
                    { text: ko.observable("No"), value: false }
                ]),
            };
            this.isTaxApplicableOptionField = new FxForms.OptionsGroup.ViewModel(container, isTaxApplicableOptions);
            var markupOptions = {
                label: ko.observable("Markup Percent"),
                validations: ko.observableArray([]),
                decimalPoint: ko.observable(10),
            };
            this.markupTxField = new MsPortalFx.ViewModels.Forms.NumericTextBox.ViewModel(container, markupOptions);
            var applyMarkupOnlyForBaseOptions = {
                label: ko.observable("Apply Markup only for Base Profiles ?"),
                infoBalloonContent: ko.observable("Opting 'Yes' will apply the markup value only if the resources matches in the base profile." +
                    "Opting 'NO' will apply the markup value for resource that matches in the child profile (Even if there is no base for this profile)."),
                options: ko.observableArray([
                    { text: ko.observable("Yes"), value: true },
                    { text: ko.observable("No"), value: false }
                ]),
            };
            this.applyMarkupOnlyForBaseOptionField = new FxForms.OptionsGroup.ViewModel(container, applyMarkupOnlyForBaseOptions);
            var baseProfilesDdownFieldOptions = {
                label: ko.observable('Base Profile'),
                validations: ko.observableArray([]),
            };
            this.baseProfilesDdownField = new MsPortalFx.ViewModels.Obsolete.Forms.DropDown.ViewModel(container, baseProfilesDdownFieldOptions);
            var isAggregateBaseMarkupOptions = {
                label: ko.observable("Should Aggregate All Markups of Base Profiles ?"),
                infoBalloonContent: ko.observable("Opting 'Yes' will aggregate all the markup values of the linked base profiles." +
                    "Opting 'NO' will only apply the markup value of the child profile alone."),
                options: ko.observableArray([
                    { text: ko.observable("Yes"), value: true },
                    { text: ko.observable("No"), value: false }
                ]),
            };
            this.isAggregateBaseMarkupsOptionField = new FxForms.OptionsGroup.ViewModel(container, isAggregateBaseMarkupOptions);
            var promotionTypeOptions = {
                label: ko.observable("Promotion Type"),
                options: ko.observableArray([
                    { text: ko.observable("None"), value: 0 },
                    { text: ko.observable("Recurring"), value: 10 },
                    { text: ko.observable("One-Time"), value: 20 }
                ]),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required"),
                    customValidationForPromotions
                ]),
            };
            this.promotionTypeOptionField = new FxForms.OptionsGroup.ViewModel(container, promotionTypeOptions);
            var isPromotionInPercentageOptions = {
                label: ko.observable("Specify Promotion In Percentage ?"),
                options: ko.observableArray([
                    { text: ko.observable("Yes"), value: true },
                    { text: ko.observable("No"), value: false }
                ]),
            };
            this.isPromotionInPercentageOptionField = new FxForms.OptionsGroup.ViewModel(container, isPromotionInPercentageOptions);
            var promortionTxFieldOptions = {
                label: ko.observable("Promotion Value"),
                validations: ko.observableArray([]),
                decimalPoint: ko.observable(10),
                max: ko.observable(999999999),
            };
            this.promortionTxField = new MsPortalFx.ViewModels.Forms.NumericTextBox.ViewModel(container, promortionTxFieldOptions);
            var promortionPeriodTxFieldOptions = {
                label: ko.observable("Promotion Period"),
                infoBalloonContent: ko.observable("Please specify the promotion period in days. (E.g.: 60)"),
                validations: ko.observableArray([]),
                decimalPoint: ko.observable(10),
                max: ko.observable(365),
            };
            this.promortionPeriodTxField = new MsPortalFx.ViewModels.Forms.NumericTextBox.ViewModel(container, promortionPeriodTxFieldOptions);
            var updatePromoCreditToExistingSubsOptions = {
                label: ko.observable("Update Promotion Credits for Existing Subscriptions ?"),
                options: ko.observableArray([
                    { text: ko.observable("Yes"), value: true },
                    { text: ko.observable("No"), value: false }
                ]),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required"),
                    customValidationForPromotions
                ]),
            };
            this.updatePromoCreditToExistingSubsOptionField = new FxForms.OptionsGroup.ViewModel(container, updatePromoCreditToExistingSubsOptions);
            var regionOptions = {
                label: ko.observable("Region"),
                validations: ko.observableArray([]),
            };
            this.regionTxField = new MsPortalFx.ViewModels.Forms.TextBox.ViewModel(container, regionOptions);
            var currencyTextOptions = {
                label: ko.observable("Currency Text"),
                validations: ko.observableArray([]),
            };
            this.currencyTextTxField = new MsPortalFx.ViewModels.Forms.TextBox.ViewModel(container, currencyTextOptions);
            var currencySymbolOptions = {
                label: ko.observable("Currency Symbol"),
                validations: ko.observableArray([]),
            };
            this.currencySymbolTxField = new MsPortalFx.ViewModels.Forms.TextBox.ViewModel(container, currencySymbolOptions);
            this.formSection = new FxForms.Section.ViewModel(container, {
                children: ko.observableArray([
                    this.profileIdTxField,
                    this.profileNameTxField,
                    this.isMonthlyFeeSetOptionField,
                    this.monthlyFeeTxField,
                    this.oneTimeFeeTxField,
                    this.isTaxApplicableOptionField,
                    this.markupTxField,
                    this.applyMarkupOnlyForBaseOptionField,
                    this.baseProfilesDdownField,
                    this.promotionTypeOptionField,
                    this.isPromotionInPercentageOptionField,
                    this.promortionTxField,
                    this.promortionPeriodTxField,
                    this.updatePromoCreditToExistingSubsOptionField,
                    this.regionTxField,
                    this.currencyTextTxField,
                    this.currencySymbolTxField,
                ])
            });
            var options = {
                children: this._formFields
            };
        };
        PricingProfileDetailsBladeViewModel.prototype._setupCommandBar = function () {
            var _this = this;
            var saveButton = new MsPortalFx.ViewModels.Toolbars.CommandButton({
                label: ClientResources.Commands.save,
                icon: MsPortalFx.Base.Images.Save(),
                command: {
                    canExecute: ko.observable(true),
                    execute: function (context) {
                        return _this._container.form.triggerValidation().then(function (validationPassed) {
                            if (validationPassed) {
                                return _this._onSaveChanges();
                            }
                            return null;
                        });
                    },
                }
            });
            this.commandBar = new MsPortalFx.ViewModels.Toolbars.Toolbar(this._container);
            this.commandBar.setItems([saveButton]);
        };
        PricingProfileDetailsBladeViewModel.prototype._onSaveChanges = function () {
            var _this = this;
            var pricingData = {
                Id: this.profileIdTxField.value(),
                ProfileName: this.profileNameTxField.value(),
                IsMinimumMonthlyFeeApplicable: this.isMonthlyFeeSetOptionField.value(),
                MonthlyFee: this.monthlyFeeTxField.value(),
                OneTimeFee: this.oneTimeFeeTxField.value(),
                IsStandardTaxRateApplicable: this.isTaxApplicableOptionField.value(),
                MarkupPercent: this.markupTxField.value(),
                ApplyMarkupOnlyToBasePP: this.applyMarkupOnlyForBaseOptionField.value(),
                BasePricingProfileIds: this.baseProfilesDdownField.value(),
                PromotionType: this.promotionTypeOptionField.value(),
                PromoCreditInPercentage: this.isPromotionInPercentageOptionField.value(),
                PromoCredit: this.promortionTxField.value(),
                PromoPeriod: this.promortionPeriodTxField.value(),
                UpdateExistingSubscriptions: this.updatePromoCreditToExistingSubsOptionField.value(),
                Region: this.regionTxField.value(),
                ISOCurrencySymbol: this.currencyTextTxField.value(),
                CurrencySymbol: this.currencySymbolTxField.value(),
            };
            var dataManager = this._dataContext.pricingProfilesDataManager;
            var op = dataManager.updateProfileDetailsQuery(this.adminSubscriptionId(), this.location(), this.pricingProfileId(), pricingData);
            this._container.operations.add(op, { blockUi: true });
            return op.then(function () {
                if (_this._selectedBaseProfileId() != "" && _this._selectedBaseProfileId() != "None" && !_this.isDisableBaseProfileSelectOption()) {
                    var dataManager_1 = _this._dataContext.pricingProfilesDataManager;
                    dataManager_1.linkBaseProfileQuery(_this.adminSubscriptionId(), _this.location(), _this.pricingProfileId(), _this._selectedBaseProfileId().toString())
                        .then(function () {
                        return {
                            action: MsPortalFx.Data.AcceptEditScopeChangesAction.AcceptClientChanges
                        };
                    });
                }
                else {
                    return {
                        action: MsPortalFx.Data.AcceptEditScopeChangesAction.AcceptClientChanges
                    };
                }
            }).finally(function () {
                dataManager.pricingProfileEntity.refreshAll();
                dataManager.pricingProfilesQuery.refreshAll();
            });
        };
        PricingProfileDetailsBladeViewModel.prototype._setPromotionFeatureSetting = function (productFeatures) {
            if (this._isPromotionSettingsEnabled(productFeatures.Settings()['IsPromotionsFeatureEnabled'])) {
                this.isPromotionFeatureEnabled(true);
            }
            else {
                this.isPromotionFeatureEnabled(false);
            }
        };
        PricingProfileDetailsBladeViewModel.prototype._isPromotionSettingsEnabled = function (setting) {
            if (setting() === "True") {
                return true;
            }
            return false;
        };
        PricingProfileDetailsBladeViewModel.prototype._getPromotionSettings = function () {
            var _this = this;
            var args = {
                subscriptionId: this.adminSubscriptionId(),
                location: this.location(),
            };
            this._enabledFeaturesEntityView.fetch(args).then(function () {
                var dataEntity = _this._enabledFeaturesEntityView.item();
                _this._setPromotionFeatureSetting(dataEntity);
                return dataEntity;
            }).finally(function () {
                if (!_this.isPromotionFeatureEnabled()) {
                    _this.formSection.children.removeAll([
                        _this.promotionTypeOptionField,
                        _this.isPromotionInPercentageOptionField,
                        _this.promortionTxField,
                        _this.promortionPeriodTxField,
                        _this.updatePromoCreditToExistingSubsOptionField,
                    ]);
                }
            });
        };
        PricingProfileDetailsBladeViewModel.prototype._setFormFields = function (pricingProfile) {
            this.profileIdTxField.value(pricingProfile.Id());
            this.profileNameTxField.value(pricingProfile.ProfileName());
            this.isMonthlyFeeSetOptionField.value(pricingProfile.IsMinimumMonthlyFeeApplicable());
            this.monthlyFeeTxField.value(pricingProfile.MonthlyFee());
            this.oneTimeFeeTxField.value(pricingProfile.OneTimeFee());
            this.isTaxApplicableOptionField.value(pricingProfile.IsStandardTaxRateApplicable());
            this.markupTxField.value(pricingProfile.MarkupPercent());
            this.applyMarkupOnlyForBaseOptionField.value(pricingProfile.ApplyMarkupOnlyToBasePP());
            this.baseProfilesDdownField.value(pricingProfile.BasePricingProfileIds().join(','));
            this.promotionTypeOptionField.value(pricingProfile.PromotionType());
            this.isPromotionInPercentageOptionField.value(pricingProfile.PromoCreditInPercentage());
            this.promortionTxField.value(pricingProfile.PromoCredit());
            this.promortionPeriodTxField.value(pricingProfile.PromoPeriod());
            this.updatePromoCreditToExistingSubsOptionField.value(false);
            this.regionTxField.value(pricingProfile.Region());
            this.currencyTextTxField.value(pricingProfile.ISOCurrencySymbol());
            this.currencySymbolTxField.value(pricingProfile.CurrencySymbol());
        };
        PricingProfileDetailsBladeViewModel.prototype._updateBaseProfilesDdown = function () {
            var dropdownValues = [
                {
                    text: ko.observable("-None-"),
                    value: "None"
                }
            ];
            for (var _i = 0, _a = this.baseProfiles(); _i < _a.length; _i++) {
                var profile = _a[_i];
                dropdownValues.push({
                    text: ko.observable(profile.BaseProfileId() + " - " + profile.BaseProfileName()),
                    value: profile.BaseProfileId().toString(),
                });
            }
            this.baseProfilesDdownField.options(dropdownValues.reverse());
        };
        PricingProfileDetailsBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            var _this = this;
            this.adminSubscriptionId(inputs.adminSubscriptionId);
            this.location(inputs.location);
            this.pricingProfileId(inputs.pricingProfileId);
            this._getPromotionSettings();
            var args = {
                subscriptionId: this.adminSubscriptionId(),
                pricingProfileId: this.pricingProfileId(),
                location: this.location(),
            };
            return this._dataEntityView.fetch(args).then(function () {
                var dataEntity = _this._dataEntityView.item();
                var data = PricingProfileModel.PricingProfileModel.getPricingProfileData(dataEntity);
                _this._setFormFields(data);
                _this.isDisableBaseProfileSelectOption(dataEntity.IsDisableBaseProfileSelectOption());
                _this.baseProfiles(dataEntity.EligibleBasePricingProfiles());
                _this._updateBaseProfilesDdown();
            });
        };
        return PricingProfileDetailsBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.PricingProfileDetailsBladeViewModel = PricingProfileDetailsBladeViewModel;
});
