var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "../../_generated/ExtensionDefinition", "../../Shared/StreamUploader"], function (require, exports, ExtensionDefinition, StreamUploaderMod) {
    "use strict";
    var FxSimpleButton = MsPortalFx.ViewModels.Controls.SimpleButton;
    var FxForms = MsPortalFx.ViewModels.Forms;
    var FxAsyncFileUpload = MsPortalFx.ViewModels.Forms.AsyncFileUpload;
    var FxFileUpload = MsPortalFx.ViewModels.FileUpload;
    var ArmHelpers = Common.Helpers;
    var PricingProfileImportBladeViewModel = (function (_super) {
        __extends(PricingProfileImportBladeViewModel, _super);
        function PricingProfileImportBladeViewModel(container, initialState, dataContext) {
            var _this = this;
            _super.call(this);
            this.adminSubscriptionId = ko.observable();
            this.location = ko.observable("local");
            this._isButtonDisabled = ko.observable(true);
            this.title("Import Pricing Profile");
            this._container = container;
            this._dataContext = dataContext;
            this._uploadTasks = ko.observableArray([]);
            var textBoxOptions = {
                label: ko.observable("Profile Name"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.LengthRangeValidation(4, 100, "Should have 4 to 100 characters")
                ])
            };
            this.txProfileName = new MsPortalFx.ViewModels.Forms.TextBox.ViewModel(container, textBoxOptions);
            this.asyncFileUploadViewModel = this._getAsyncFileUploadWidget();
            this.uploadButtonViewModel = new FxSimpleButton.ViewModel(this._container, {
                onClick: this._onUploadButtonClicked.bind(this),
                text: "Upload",
                primary: true,
                disabled: this._isButtonDisabled
            });
            this.formSection = new FxForms.Section.ViewModel(container, {
                children: ko.observableArray([
                    this.txProfileName,
                    this.asyncFileUploadViewModel,
                ])
            });
            ko.reactor(this._container, function () {
                _this._isButtonDisabled(_this.asyncFileUploadViewModel.empty());
            });
        }
        PricingProfileImportBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            this.adminSubscriptionId(inputs.adminSubscriptionId);
            this.location(inputs.location);
            return Q();
        };
        PricingProfileImportBladeViewModel.prototype._getAsyncFileUploadWidget = function () {
            var streamingContext = new FxFileUpload.StreamFileUploadContext();
            streamingContext.uploadTarget = "Cloud Assert Billing - Pricing Profile";
            streamingContext.category = ExtensionDefinition.definitionName;
            streamingContext.type = 0;
            return new FxAsyncFileUpload.ViewModel(this._container, {
                label: ko.observable("Pricing Profile File"),
                labelPosition: ko.observable(FxForms.LabelPosition.Top),
                maxFiles: 1,
                uploadContext: ko.observable(streamingContext),
            });
        };
        PricingProfileImportBladeViewModel.prototype._onUploadButtonClicked = function () {
            var _this = this;
            if (this._childLifetime) {
                this._childLifetime.dispose();
                this._childLifetime = null;
            }
            this._childLifetime = this._container.createChildLifetime();
            this.asyncFileUploadViewModel.uploadTasks().forEach(function (uploadTask) {
                if (uploadTask.uploadInfo.status() === 1) {
                    uploadTask.resume().then(function () {
                        var uploadKey = { id: uploadTask.uploadInfo.id(), name: uploadTask.uploadInfo.name };
                        var size = uploadTask.uploadInfo.size;
                        var profileName = _this.txProfileName.value();
                        var streamUploader = new StreamUploaderMod.StreamUploader(_this._childLifetime, uploadTask, ko.observable(false), null, function (fileData) {
                            _this._dataContext.pricingProfilesDataManager.uploadPricingProfile(_this.adminSubscriptionId(), _this.location(), profileName, fileData)
                                .then(function () {
                                _this._dataContext.pricingProfilesDataManager.pricingProfilesQuery.refreshAll();
                                _this._container.closeCurrentBlade();
                            });
                        });
                        streamUploader.upload();
                    }, function () {
                    });
                }
            });
            return Q.resolve(true);
        };
        return PricingProfileImportBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.PricingProfileImportBladeViewModel = PricingProfileImportBladeViewModel;
});
