var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports"], function (require, exports) {
    "use strict";
    var FxToolbars = MsPortalFx.ViewModels.Toolbars;
    var Dialogs = MsPortalFx.ViewModels.Dialogs;
    var Images = MsPortalFx.Base.Images;
    var FxForms = MsPortalFx.ViewModels.Forms;
    var PricingProfileLinkUnlinkBladeViewModel = (function (_super) {
        __extends(PricingProfileLinkUnlinkBladeViewModel, _super);
        function PricingProfileLinkUnlinkBladeViewModel(container, initialState, dataContext) {
            var _this = this;
            _super.call(this);
            this._selectedBaseProfileId = ko.observable();
            this.isLink = ko.observable(true);
            this.subscriptionId = ko.observable("");
            this.selectedPricingProfile = ko.observable("");
            this.selectedPricingProfileId = ko.observable("");
            this.linkedBaseProfiles = ko.observableArray();
            this.location = ko.observable("");
            this.icon(Images.Customize());
            this._container = container;
            this._dataContext = dataContext;
            this._linkProfileEntityView = dataContext.pricingProfilesDataManager.eligibleBaseProfileEntity.createView(container);
            this._initializeFormFields(container);
            this.baseProfilesDdownField.value.subscribe(container, function (selectedBase) {
                if (selectedBase != null) {
                    _this._selectedBaseProfileId(selectedBase);
                }
            });
            this.commandBar = new MsPortalFx.ViewModels.Toolbars.Toolbar(container);
            this._setupCommandBar();
        }
        PricingProfileLinkUnlinkBladeViewModel.prototype._setupCommandBar = function () {
            this._saveButton = this._createSaveButton();
            this.commandBar = new MsPortalFx.ViewModels.Toolbars.Toolbar(this._container);
            this.commandBar.setItems([
                this._saveButton,
            ]);
        };
        PricingProfileLinkUnlinkBladeViewModel.prototype._createSaveButton = function () {
            var _this = this;
            var saveButton = new FxToolbars.DialogButton({
                label: "Save",
                icon: MsPortalFx.Base.Images.Commit(),
                dialogOptions: new Dialogs.MessageBox("", "Are you sure you want to save ?", 4),
            });
            saveButton.command = {
                canExecute: ko.computed(this._container, function () {
                    return _this._selectedBaseProfileId() != null;
                }),
                execute: function (result) {
                    if (result === 6) {
                        if (_this.isLink()) {
                            _this._dataContext.pricingProfilesDataManager.linkBaseProfileQuery(_this.subscriptionId(), _this.location(), _this.selectedPricingProfileId(), _this._selectedBaseProfileId().toString())
                                .finally(function () {
                                _this._container.closeCurrentBlade();
                            });
                        }
                        else {
                            _this._dataContext.pricingProfilesDataManager.unlinkBaseProfileQuery(_this.subscriptionId(), _this.location(), _this.selectedPricingProfileId(), _this._selectedBaseProfileId().toString())
                                .finally(function () {
                                _this._container.closeCurrentBlade();
                            });
                        }
                    }
                    return null;
                }
            };
            return saveButton;
        };
        PricingProfileLinkUnlinkBladeViewModel.prototype._initializeFormFields = function (container) {
            var childProfileNameTxFieldOptions = {
                label: ko.observable("Child Profile"),
                readonly: true,
                validations: ko.observableArray([]),
            };
            this.childProfileNameTxField = new MsPortalFx.ViewModels.Forms.TextBox.ViewModel(container, childProfileNameTxFieldOptions);
            var baseProfilesDdownFieldOptions = {
                label: ko.observable('Base Profile'),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.baseProfilesDdownField = new MsPortalFx.ViewModels.Obsolete.Forms.DropDown.ViewModel(container, baseProfilesDdownFieldOptions);
            this.formSection = new FxForms.Section.ViewModel(container, {
                children: ko.observableArray([
                    this.childProfileNameTxField,
                    this.baseProfilesDdownField,
                ])
            });
        };
        PricingProfileLinkUnlinkBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            var _this = this;
            this.isLink(inputs.isLink);
            this.subscriptionId(inputs.subscriptionId);
            this.location(inputs.location);
            this.selectedPricingProfile(inputs.selectedPricingProfile);
            this.selectedPricingProfileId(inputs.selectedPricingProfileId);
            this.linkedBaseProfiles(inputs.linkedBaseProfiles);
            var title = this.isLink() ? "Link Base Profile" : "Unlink Base Profile";
            this.title(title);
            this.description(title);
            this.childProfileNameTxField.value(this.selectedPricingProfileId() + ' - ' + this.selectedPricingProfile().toString());
            var args = {
                subscriptionId: this.subscriptionId(),
                pricingProfileId: this.selectedPricingProfileId(),
                location: this.location(),
            };
            if (this.isLink()) {
                return this._linkProfileEntityView.fetch(args).then(function () {
                    var dataEntity = _this._linkProfileEntityView.item();
                    _this._updateBaseProfilesDdown(dataEntity);
                });
            }
            else {
                this._updateBaseProfilesDdown(this.linkedBaseProfiles());
            }
        };
        PricingProfileLinkUnlinkBladeViewModel.prototype._updateBaseProfilesDdown = function (baseProfiles) {
            var _this = this;
            var dropdownValues = baseProfiles.map(function (s) {
                if (_this.isLink()) {
                    return {
                        text: ko.observable(s.BaseProfileId() + " - " + s.BaseProfileName()),
                        value: s.BaseProfileId().toString(),
                    };
                }
                return {
                    text: ko.observable(s.BaseProfileId + " - " + s.BaseProfileName),
                    value: s.BaseProfileId.toString(),
                };
            });
            this.baseProfilesDdownField.options(dropdownValues);
        };
        return PricingProfileLinkUnlinkBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.PricingProfileLinkUnlinkBladeViewModel = PricingProfileLinkUnlinkBladeViewModel;
});
