var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "../../_generated/ExtensionDefinition", "../../Shared/StreamUploader"], function (require, exports, ExtensionDefinition, StreamUploaderMod) {
    "use strict";
    var FxSimpleButton = MsPortalFx.ViewModels.Controls.SimpleButton;
    var FxForms = MsPortalFx.ViewModels.Forms;
    var FxAsyncFileUpload = MsPortalFx.ViewModels.Forms.AsyncFileUpload;
    var FxFileUpload = MsPortalFx.ViewModels.FileUpload;
    var ArmHelpers = Common.Helpers;
    var PricingProfileUpdateMetersBladeViewModel = (function (_super) {
        __extends(PricingProfileUpdateMetersBladeViewModel, _super);
        function PricingProfileUpdateMetersBladeViewModel(container, initialState, dataContext) {
            var _this = this;
            _super.call(this);
            this.adminSubscriptionId = ko.observable();
            this.location = ko.observable("local");
            this.pricingProfileId = ko.observable();
            this.pricingProfile = ko.observable();
            this._isButtonDisabled = ko.observable(true);
            this.title("Update Meters in Pricing Profile");
            this._container = container;
            this._dataContext = dataContext;
            this._uploadTasks = ko.observableArray([]);
            this._dataEntityView = dataContext.pricingProfilesDataManager.pricingProfileEntity.createView(container, {
                interceptNotFound: false
            });
            this._dataEntityView.item.subscribe(container, function (pricingProfile) {
                _this.pricingProfile(pricingProfile);
                _this.txProfileName.value(pricingProfile.ProfileName() + ' (' + pricingProfile.Id() + ')');
            });
            var textBoxOptions = {
                label: ko.observable("Pricing Profile"),
                readonly: true,
                validations: ko.observableArray([])
            };
            this.txProfileName = new MsPortalFx.ViewModels.Forms.TextBox.ViewModel(container, textBoxOptions);
            this.asyncFileUploadViewModel = this._getAsyncFileUploadWidget();
            this.uploadButtonViewModel = new FxSimpleButton.ViewModel(this._container, {
                onClick: this._onUploadButtonClicked.bind(this),
                text: "Upload",
                primary: true,
                disabled: this._isButtonDisabled
            });
            this.formSection = new FxForms.Section.ViewModel(container, {
                children: ko.observableArray([
                    this.txProfileName,
                    this.asyncFileUploadViewModel,
                ])
            });
            ko.reactor(this._container, function () {
                _this._isButtonDisabled(_this.asyncFileUploadViewModel.empty());
            });
        }
        PricingProfileUpdateMetersBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            this.adminSubscriptionId(inputs.adminSubscriptionId);
            this.location(inputs.location);
            this.pricingProfileId(inputs.pricingProfileId);
            return this._dataEntityView.fetch({
                subscriptionId: inputs.adminSubscriptionId,
                location: inputs.location,
                pricingProfileId: inputs.pricingProfileId,
            });
        };
        PricingProfileUpdateMetersBladeViewModel.prototype._getAsyncFileUploadWidget = function () {
            var streamingContext = new FxFileUpload.StreamFileUploadContext();
            streamingContext.uploadTarget = "Cloud Assert Billing - Pricing Profile";
            streamingContext.category = ExtensionDefinition.definitionName;
            streamingContext.type = 0;
            return new FxAsyncFileUpload.ViewModel(this._container, {
                label: ko.observable("Pricing Profile File"),
                labelPosition: ko.observable(FxForms.LabelPosition.Top),
                maxFiles: 1,
                uploadContext: ko.observable(streamingContext),
            });
        };
        PricingProfileUpdateMetersBladeViewModel.prototype._onUploadButtonClicked = function () {
            var _this = this;
            if (this._childLifetime) {
                this._childLifetime.dispose();
                this._childLifetime = null;
            }
            this._childLifetime = this._container.createChildLifetime();
            this.asyncFileUploadViewModel.uploadTasks().forEach(function (uploadTask) {
                if (uploadTask.uploadInfo.status() === 1) {
                    uploadTask.resume().then(function () {
                        var uploadKey = { id: uploadTask.uploadInfo.id(), name: uploadTask.uploadInfo.name };
                        var size = uploadTask.uploadInfo.size;
                        var profileId = _this.pricingProfileId();
                        var existingProfileName = _this.pricingProfile().ProfileName();
                        var streamUploader = new StreamUploaderMod.StreamUploader(_this._childLifetime, uploadTask, ko.observable(false), null, function (fileData) {
                            _this._dataContext.pricingProfilesDataManager.editPricingProfile(_this.adminSubscriptionId(), _this.location(), profileId, existingProfileName, fileData);
                        });
                        streamUploader.upload();
                    }, function () {
                    });
                }
            });
            return Q.resolve(true);
        };
        return PricingProfileUpdateMetersBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.PricingProfileUpdateMetersBladeViewModel = PricingProfileUpdateMetersBladeViewModel;
});
