var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "./_generated/ExtensionDefinition", "./_generated/ViewModelFactories", "./Shared/SharedArea", "./ResourceProvider/ResourceProviderArea", "./AdminBilling/AdminBillingArea", "./Quota/QuotaArea", "./PricingProfile/PricingProfileArea", "./MeteredResourcePricing/MeteredResourcePricingArea", "./UsageHistory/UsageHistoryArea", "./UserCredits/UserCreditsArea", "./Csp/CspArea", "./Settings/SettingsArea", "./UserProfile/UserProfileArea", "./License/LicenseArea", "./UsageProcessingStatus/UsageProcessingStatusArea", "./Notifications/NotificationsArea", "./UsageAndQuota/UsageAndQuotaArea"], function (require, exports, ExtensionDefinition, ViewModelFactories, SharedArea, ResourceProviderArea, AdminBillingArea, QuotaArea, PricingProfileArea, MeteredResourcePricingArea, UsageHistoryArea, UserCreditsArea, CspArea, SettingsArea, UserProfileArea, LicenseArea, UsageProcessingStatusArea, NotificationsArea, UsageAndQuotaArea) {
    "use strict";
    var ArmHelpers = Common.Helpers;
    "use strict";
    var EntryPoint = (function (_super) {
        __extends(EntryPoint, _super);
        function EntryPoint() {
            _super.apply(this, arguments);
        }
        EntryPoint.prototype.initialize = function () {
            this.viewModelFactories = new ViewModelFactories.ViewModelFactoriesBase();
            ArmHelpers.apiVersion = window.fx.environment.armApiVersion;
            this._initializeDataContexts();
        };
        EntryPoint.prototype.getDefinition = function () {
            return ExtensionDefinition.getDefinition();
        };
        EntryPoint.prototype._initializeDataContexts = function () {
            var sharedContext = new SharedArea.DataContext();
            var resourceProviderContext = new ResourceProviderArea.DataContext(sharedContext);
            var adminBillingContext = new AdminBillingArea.DataContext(sharedContext);
            var quotaContext = new QuotaArea.DataContext(sharedContext);
            var pricingProfileContext = new PricingProfileArea.DataContext(sharedContext);
            var meteredResourcePricingContext = new MeteredResourcePricingArea.DataContext(sharedContext);
            var usageHistoryContext = new UsageHistoryArea.DataContext(sharedContext);
            var userCreditsContext = new UserCreditsArea.DataContext(sharedContext);
            var cspContext = new CspArea.DataContext(sharedContext);
            var settingsContext = new SettingsArea.DataContext(sharedContext);
            var userProfileContext = new UserProfileArea.DataContext(sharedContext);
            var licenseContext = new LicenseArea.DataContext(sharedContext);
            var usageProcessingStatusContext = new UsageProcessingStatusArea.DataContext(sharedContext);
            var notificationsContext = new NotificationsArea.DataContext(sharedContext);
            var usageAndQuotaContext = new UsageAndQuotaArea.DataContext(sharedContext);
            this.viewModelFactories.ResourceProvider().setDataContext(resourceProviderContext);
            this.viewModelFactories.AdminBilling().setDataContext(adminBillingContext);
            this.viewModelFactories.Quota().setDataContext(quotaContext);
            this.viewModelFactories.PricingProfile().setDataContext(pricingProfileContext);
            this.viewModelFactories.MeteredResourcePricing().setDataContext(meteredResourcePricingContext);
            this.viewModelFactories.UsageHistory().setDataContext(usageHistoryContext);
            this.viewModelFactories.UserCredits().setDataContext(userCreditsContext);
            this.viewModelFactories.Csp().setDataContext(cspContext);
            this.viewModelFactories.Settings().setDataContext(settingsContext);
            this.viewModelFactories.UserProfile().setDataContext(userProfileContext);
            this.viewModelFactories.License().setDataContext(licenseContext);
            this.viewModelFactories.UsageProcessingStatus().setDataContext(usageProcessingStatusContext);
            this.viewModelFactories.Notifications().setDataContext(notificationsContext);
            this.viewModelFactories.UsageAndQuota().setDataContext(usageAndQuotaContext);
        };
        return EntryPoint;
    }(MsPortalFx.Extension.EntryPointBase));
    function create() {
        return new EntryPoint();
    }
    exports.create = create;
});
