define(["require", "exports", "ClientResources", "../../_generated/ExtensionDefinition"], function (require, exports, ClientResources, ExtensionDefinition) {
    "use strict";
    var Diagnostics = MsPortalFx.Base.Diagnostics;
    "use strict";
    (function (ServiceStatus) {
        ServiceStatus[ServiceStatus["enabled"] = 1] = "enabled";
        ServiceStatus[ServiceStatus["disabled"] = 2] = "disabled";
    })(exports.ServiceStatus || (exports.ServiceStatus = {}));
    var ServiceStatus = exports.ServiceStatus;
    function serviceStatusGetName(enumValue) {
        var displayName = "";
        switch (enumValue) {
            case ServiceStatus.enabled:
                displayName = ClientResources.ResourceProvider.Status.enabled;
                break;
            case ServiceStatus.disabled:
                displayName = ClientResources.ResourceProvider.Status.disabled;
                break;
            default:
                Diagnostics.Log.writeEntry(2, ExtensionDefinition.definitionName, "Unknown ServiceStatus: {0}.".format(enumValue));
                break;
        }
        return displayName;
    }
    exports.serviceStatusGetName = serviceStatusGetName;
});
