var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports"], function (require, exports) {
    "use strict";
    var CostPerServiceTypeDonutPartViewModel = (function (_super) {
        __extends(CostPerServiceTypeDonutPartViewModel, _super);
        function CostPerServiceTypeDonutPartViewModel(container, initialState, dataContext) {
            var _this = this;
            _super.call(this, container);
            this.location = ko.observable("local");
            this.isoCurrencySymbol = ko.observable();
            this._data = ko.observableArray([]);
            container.partTitle("Service Type Wise Usage Charges");
            this._container = container;
            this._dataContext = dataContext;
            var itemSettings = {
                valueKey: "amount",
                labelKey: "label",
                selectedKey: "selected",
                hoveredIndex: ko.observable(),
            };
            this.itemSetting(itemSettings);
            this.total(0);
            this.unitFormat("USD");
            this.infoFormat("Itemized Bill");
            this.hoveredUnit("USD");
            this.showLegend();
            var projectedItems = this._data.map(container, function (itemLifetime, lineItem) {
                return {
                    label: lineItem.ServiceType,
                    amount: lineItem.BillableCost,
                    selected: ko.observable(false),
                };
            });
            projectedItems.subscribe(container, this.itemsDataArray);
            ko.reactor(container, function () {
                var total = 0;
                projectedItems().forEach(function (value) {
                    total += value.amount;
                });
                _this.total(total);
                _this.render();
            });
        }
        CostPerServiceTypeDonutPartViewModel.prototype.onInputsSet = function (inputs) {
            var _this = this;
            this._dataContext.selectedIsoCurrencySymbol.subscribe(this._container, this._onIsoCurrencySymbolChanged.bind(this));
            var q = this._dataContext.subscriptionsManager.adminSubscriptionsPromise.then(function (subscriptions) {
                if (subscriptions.length === 0)
                    return Q();
                var firstSubscriptionId = subscriptions.first().subscriptionId;
                var isoCurrency = _this._dataContext.selectedIsoCurrencySymbol();
                _this._dataContext.sharedContext.pricingProfilesDataManager.getAvailableIsoCurrencyList(firstSubscriptionId, _this.location()).then(function (isoCurrencySymbols) {
                    if (!isoCurrency) {
                        isoCurrency = isoCurrencySymbols.first();
                    }
                    return _this._onIsoCurrencySymbolChanged(isoCurrency);
                });
            });
            return q;
        };
        CostPerServiceTypeDonutPartViewModel.prototype._onIsoCurrencySymbolChanged = function (selectedIsoCurrencySymbol) {
            var _this = this;
            this.isoCurrencySymbol(selectedIsoCurrencySymbol);
            this._dataContext.selectedIsoCurrencySymbol(selectedIsoCurrencySymbol);
            if (!selectedIsoCurrencySymbol)
                return Q();
            var q = this._dataContext.subscriptionsManager.adminSubscriptionsPromise.then(function (subscriptions) {
                var firstSubscriptionId = subscriptions.first().subscriptionId;
                return _this._dataContext.sharedContext.billingOverviewManager.getTotalCostPerServiceType(firstSubscriptionId, _this.location(), _this.isoCurrencySymbol())
                    .then(function (usageRecords) {
                    _this.unitFormat(usageRecords.first().ISOCurrencySymbol);
                    _this.hoveredUnit(usageRecords.first().ISOCurrencySymbol);
                    _this._data(usageRecords);
                });
            });
            return q;
        };
        return CostPerServiceTypeDonutPartViewModel;
    }(MsPortalFx.ViewModels.Parts.Donut.ViewModel));
    exports.CostPerServiceTypeDonutPartViewModel = CostPerServiceTypeDonutPartViewModel;
});
