var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "../../_generated/BladeReferences", "Fx/Composition/Pdl/MenuBlade"], function (require, exports, BladeReferences, FxMenuBlade) {
    "use strict";
    var FxImages = MsPortalFx.Base.Images;
    "use strict";
    var ResourceProviderMenuBladeViewModel = (function (_super) {
        __extends(ResourceProviderMenuBladeViewModel, _super);
        function ResourceProviderMenuBladeViewModel(container, initialState, dataContext) {
            _super.call(this, container);
            this.id = ko.observable();
            this.title("...");
            this.icon(MsPortalFx.Base.Images.Polychromatic.VirtualMachine());
            this.menu.groups([]);
            this.menu.groupSortOrder = 0;
            this.menu.groupSortFunction = FxMenuBlade.SortFunction.SupportFirst;
        }
        ResourceProviderMenuBladeViewModel.prototype.onInputsSet = function (inputs) {
            var _this = this;
            this.rpAssetId = inputs.resourceProviderAssetId;
            this.id(this.rpAssetId.id);
            this.title(this.rpAssetId.displayName);
            this.subtitle(this.rpAssetId.location);
            var menuGroups = [
                {
                    id: "general",
                    displayText: "General",
                    items: [
                        {
                            id: "CSPOffers",
                            displayText: "CSP Offers",
                            icon: FxImages.Polychromatic.CloudService(),
                            supplyBladeReference: function () {
                                return new BladeReferences.CspOffersGridBladeReference({
                                    subscriptionId: _this.rpAssetId.subscriptionId,
                                    location: _this.rpAssetId.location,
                                });
                            }
                        },
                    ]
                },
                {
                    id: "reports",
                    displayText: "Reports",
                    items: [
                        {
                            id: "reportOne",
                            displayText: "Report One",
                            icon: FxImages.Polychromatic.Globe(),
                            supplyBladeReference: function () {
                                return new BladeReferences.AdminReportOneBladeReference({
                                    subscriptionId: _this.rpAssetId.subscriptionId,
                                    title: 'Report One',
                                    subTitle: 'by CloudAssert'
                                });
                            }
                        },
                        {
                            id: "reportTwo",
                            displayText: "Report Two",
                            icon: FxImages.Polychromatic.Globe(),
                            supplyBladeReference: function () {
                                return new BladeReferences.AdminReportTwoBladeReference({
                                    subscriptionId: _this.rpAssetId.subscriptionId,
                                    title: 'Report Two',
                                    subTitle: 'by CloudAssert'
                                });
                            }
                        },
                        {
                            id: "reportThree",
                            displayText: "Report Three",
                            icon: FxImages.Polychromatic.Globe(),
                            supplyBladeReference: function () {
                                return new BladeReferences.AdminReportThreeBladeReference({
                                    subscriptionId: _this.rpAssetId.subscriptionId,
                                    title: 'Report Three',
                                    subTitle: 'by CloudAssert'
                                });
                            }
                        },
                    ]
                }
            ];
            this.menu.groups(menuGroups);
            this.menu.setOptions({
                defaultId: "overview",
                overview: {
                    id: "overview",
                    displayText: "Overview",
                    icon: FxImages.Polychromatic.BillingHub(),
                    supplyBladeReference: function () {
                        return new BladeReferences.ResourceProviderOverviewBladeReference({
                            resourceProviderAssetId: _this.rpAssetId
                        });
                    }
                }
            });
            return Q();
        };
        return ResourceProviderMenuBladeViewModel;
    }(FxMenuBlade.ViewModel));
    exports.ResourceProviderMenuBladeViewModel = ResourceProviderMenuBladeViewModel;
});
