var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "ClientResources"], function (require, exports, ClientResources) {
    "use strict";
    "use strict";
    var ResourceProviderResourceSummaryPartViewModel = (function (_super) {
        __extends(ResourceProviderResourceSummaryPartViewModel, _super);
        function ResourceProviderResourceSummaryPartViewModel(container, initialState, dataContext) {
            var isLoading = ko.observable(true);
            var isEnabled = ko.observable("Enabled");
            var status = {
                isLoading: isLoading,
                value: isEnabled
            };
            var location = ko.observable("local");
            var options = {
                noRbac: true,
                noResourceGroup: true,
                noTags: true,
                location: location,
                status: status,
                staticProperties: []
            };
            _super.call(this, initialState, options, container);
            this._isLoading = isLoading;
            this._dataContext = dataContext;
            this._sharedContext = dataContext.sharedContext;
        }
        ResourceProviderResourceSummaryPartViewModel.prototype.onInputsSet = function (inputs, settings) {
            var _this = this;
            return _super.prototype.onInputsSet.call(this, inputs, settings).then(function () {
                _this._updateProperties(inputs);
            });
        };
        ResourceProviderResourceSummaryPartViewModel.prototype._updateProperties = function (inputs) {
            var _this = this;
            var descriptor = MsPortalFx.ViewModels.Services.ResourceTypes.parseResourceDescriptor(inputs.resourceId);
            return Q.all([]).then(function () {
                _this._isLoading(false);
                var properties = [
                    new MsPortalFx.ViewModels.Parts.Properties.TextProperty(ClientResources.ResourceSummary.serviceName, "Usage & Billing Resource Provider (by Cloud Assert)")
                ];
                _this.setDynamicProperties(properties);
            });
        };
        return ResourceProviderResourceSummaryPartViewModel;
    }(MsPortalFx.ViewModels.Parts.ResourceSummary.ViewModel2));
    exports.ResourceProviderResourceSummaryPartViewModel = ResourceProviderResourceSummaryPartViewModel;
});
