define(["require", "exports"], function (require, exports) {
    "use strict";
    var FxForms = MsPortalFx.ViewModels.Forms;
    var FxDropDown = MsPortalFx.ViewModels.Obsolete.Forms.DropDown;
    var SelectedIsoCurrencySymbolPartViewModel = (function () {
        function SelectedIsoCurrencySymbolPartViewModel(container, initialState, dataContext) {
            var _this = this;
            this._view = ko.observableArray([]);
            this._container = container;
            this._dataContext = dataContext;
            var isoCurrencySymbolDropDownOptions = {
                label: ko.observable("ISO Currency Symbol"),
                labelPosition: ko.observable(FxForms.LabelPosition.Left),
                infoBalloonContent: ko.observable("Choose the ISO Currency Symbol"),
                options: ko.observableArray([{ text: ko.observable("Loading.."), value: "" }])
            };
            this.isoCurrencySymbolsDropDown = new FxDropDown.ViewModel(container, isoCurrencySymbolDropDownOptions);
            this.isoCurrencySymbolsDropDown.value.subscribe(container, function (newCurrency) {
                _this._dataContext.selectedIsoCurrencySymbol(newCurrency);
            });
            this.formSection = new FxForms.Section.ViewModel(container, {
                style: ko.observable(3),
                children: ko.observableArray([
                    this.isoCurrencySymbolsDropDown
                ])
            });
        }
        SelectedIsoCurrencySymbolPartViewModel.prototype.onInputsSet = function (inputs) {
            var _this = this;
            var q = this._dataContext.subscriptionsManager.adminSubscriptionsPromise.then(function (subscriptions) {
                if (subscriptions.length === 0)
                    return Q();
                var firstSubscriptionId = subscriptions.first().subscriptionId;
                return _this._dataContext.sharedContext.pricingProfilesDataManager.getAvailableIsoCurrencyList(firstSubscriptionId, "local").then(function (isoCurrencySymbols) {
                    var isoCurrencyDropdownValues = isoCurrencySymbols.map(function (bp) {
                        return {
                            text: ko.observable(bp),
                            value: bp,
                            disabled: ko.observable(false),
                        };
                    });
                    isoCurrencyDropdownValues.push({
                        text: ko.observable("Please select an ISO Currency Symbol"),
                        value: null,
                        disabled: ko.observable(false)
                    });
                    _this.isoCurrencySymbolsDropDown.options(isoCurrencyDropdownValues);
                    var currentIsoCurrency = isoCurrencySymbols.first();
                    _this.isoCurrencySymbolsDropDown.value(currentIsoCurrency);
                    _this.isoCurrencySymbolsDropDown.disabled(false);
                });
            });
            return Q();
        };
        return SelectedIsoCurrencySymbolPartViewModel;
    }());
    exports.SelectedIsoCurrencySymbolPartViewModel = SelectedIsoCurrencySymbolPartViewModel;
});
