var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "../../Models/SettingsModel"], function (require, exports, SettingsModel) {
    "use strict";
    var Images = MsPortalFx.Base.Images;
    var FxForms = MsPortalFx.ViewModels.Forms;
    var AzureStackUsageCollectorSettingsViewModel = (function (_super) {
        __extends(AzureStackUsageCollectorSettingsViewModel, _super);
        function AzureStackUsageCollectorSettingsViewModel(container, initialState, dataContext) {
            var _this = this;
            _super.call(this);
            this.subscriptionId = ko.observable("");
            this.location = ko.observable("");
            this.title("Azure Stack Usage Collector Settings");
            this.description("Azure Stack Usage Collector  Details");
            this.icon(Images.Customize());
            this._container = container;
            this._dataContext = dataContext;
            this._settingEntityView = dataContext.settingsGroupManager.settingsGroupQuery.createView(container);
            this._initializeEditScope();
            this._initializeActionBar(container);
            this._initializeFormFields(container);
            this.actionBar.saveButtonClick = function () {
                return _this._editScopeView.editScope().saveChanges().then(function () {
                    _this._container.closeCurrentBlade();
                });
            };
            this.actionBar.discardButtonClick = function () {
                if (_this._form.editScope()) {
                    _this._form.editScope().revertAll();
                }
            };
        }
        AzureStackUsageCollectorSettingsViewModel.prototype._initializeEditScope = function () {
            var _this = this;
            var editScopeCache = MsPortalFx.Data.EditScopeCache.createNew({
                supplyExistingData: function (key, lifetime) {
                    var args = {
                        subscriptionId: _this.subscriptionId(),
                    };
                    return _this._settingEntityView.fetch(args).then(function () {
                        var dataEntity = _this._settingEntityView.item();
                        var data = SettingsModel.AzureStackUsageCollectorSettingsModel.getAzureStackUsageCollectorSettingsData(dataEntity.AzureStackUsageCollectorSettings());
                        return data;
                    });
                },
                saveEditScopeChanges: function (commandId, editScope, edits, lifetime, dataToUpdate) {
                    var command = editScope.root;
                    var dataManager = _this._dataContext.settingsGroupManager;
                    var op = dataManager.updateAzureStackUsageCollectorSettingsQuery(_this.subscriptionId(), _this.location(), command);
                    _this._container.operations.add(op, { blockUi: true });
                    return op.then(function () {
                        return {
                            action: MsPortalFx.Data.AcceptEditScopeChangesAction.AcceptClientChanges
                        };
                    }).finally(function () {
                    });
                }
            });
            this._editScopeView = editScopeCache.createView(this._container);
            this._form = new FxForms.Form.ViewModel(this._container);
            this._form.editScope = this._editScopeView.editScope;
        };
        AzureStackUsageCollectorSettingsViewModel.prototype._initializeActionBar = function (container) {
            var _this = this;
            this.actionBar = new MsPortalFx.ViewModels.ActionBars.FormActionBar.ViewModel(container);
            ko.reactor(container, function () {
                var es1 = _this._form.editScope;
                var isClean1 = ko.observable(!(es1() && es1().dirty()));
                var mustDisable1 = ko.observable(!es1() || es1().saving());
                _this.actionBar.disabled((mustDisable1()) || (isClean1()));
            });
        };
        AzureStackUsageCollectorSettingsViewModel.prototype._initializeFormFields = function (container) {
            var AzureStackDefaultProviderSubscriptionIdFieldOptions = {
                label: ko.observable("Default Provider Subscription Id"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.AzureStackDefaultProviderSubscriptionIdTxField = new FxForms.TextBox.ViewModel(container, this._form, this._form.createEditScopeAccessor(function (data) { return data.AdminSubscriptionId; }), AzureStackDefaultProviderSubscriptionIdFieldOptions);
            var AzureStackTenantDirecoryIdTxFieldOptions = {
                label: ko.observable("Azure Tenant Directory Id"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.AzureStackTenantDirecoryIdTxField = new FxForms.TextBox.ViewModel(container, this._form, this._form.createEditScopeAccessor(function (data) { return data.TenantId; }), AzureStackTenantDirecoryIdTxFieldOptions);
            var AzureStackApplicationIdTxFieldOptions = {
                label: ko.observable("Azure Application Id"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.AzureStackApplicationIdTxField = new FxForms.TextBox.ViewModel(container, this._form, this._form.createEditScopeAccessor(function (data) { return data.ApplicationId; }), AzureStackApplicationIdTxFieldOptions);
            var AzureStackCertificateThumbprintTxFieldOptions = {
                label: ko.observable("Certificate Thumbprint Id"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.AzureStackCertificateThumbprintTxField = new FxForms.TextBox.ViewModel(container, this._form, this._form.createEditScopeAccessor(function (data) { return data.CertificateThumbprint; }), AzureStackCertificateThumbprintTxFieldOptions);
            var AzureStackAdminArmEndpointUrlTxFieldOptions = {
                label: ko.observable("Admin Arm Endpoint Url"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.AzureStackAdminArmEndpointUrlTxField = new FxForms.TextBox.ViewModel(container, this._form, this._form.createEditScopeAccessor(function (data) { return data.AzureStackAdminArmEndpointUrl; }), AzureStackAdminArmEndpointUrlTxFieldOptions);
            var AzureStackAuthorityEndpointUrlTxFieldOptions = {
                label: ko.observable("Authority Endpoint Url"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.AzureStackAuthorityEndpointUrlTxField = new FxForms.TextBox.ViewModel(container, this._form, this._form.createEditScopeAccessor(function (data) { return data.AzureStackAuthorityEndpointUrl; }), AzureStackAuthorityEndpointUrlTxFieldOptions);
            var AzureStackTokenRequestResourceUrlxFieldOptions = {
                label: ko.observable("Token Request Resource Url"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.AzureStackTokenRequestResourceUrlxField = new FxForms.TextBox.ViewModel(container, this._form, this._form.createEditScopeAccessor(function (data) { return data.AzureStackTokenRequestResourceUrl; }), AzureStackTokenRequestResourceUrlxFieldOptions);
            var AzureStackNumberOfDaysOfUsageTxFieldOptions = {
                label: ko.observable("Number of Days of Usage To Query"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.AzureStackNumberOfDaysOfUsageTxField = new FxForms.TextBox.ViewModel(container, this._form, this._form.createEditScopeAccessor(function (data) { return data.NumberOfDaysOfUsage; }), AzureStackNumberOfDaysOfUsageTxFieldOptions);
            var AzureStackNumberOfHoursOfNoUsageTxFieldOptions = {
                label: ko.observable("Usage Aggregation Catchup Delay (In Hours)"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required")
                ]),
            };
            this.AzureStackNumberOfHoursOfNoUsageTxField = new FxForms.TextBox.ViewModel(container, this._form, this._form.createEditScopeAccessor(function (data) { return data.NumberOfHoursOfNoUsage; }), AzureStackNumberOfHoursOfNoUsageTxFieldOptions);
            this.formSection = new FxForms.Section.ViewModel(container, {
                children: ko.observableArray([
                    this.AzureStackDefaultProviderSubscriptionIdTxField,
                    this.AzureStackTenantDirecoryIdTxField,
                    this.AzureStackApplicationIdTxField,
                    this.AzureStackCertificateThumbprintTxField,
                    this.AzureStackAdminArmEndpointUrlTxField,
                    this.AzureStackAuthorityEndpointUrlTxField,
                    this.AzureStackTokenRequestResourceUrlxField,
                    this.AzureStackNumberOfHoursOfNoUsageTxField,
                ])
            });
        };
        AzureStackUsageCollectorSettingsViewModel.prototype.onInputsSet = function (inputs, settings) {
            this.subscriptionId(inputs.subscriptionId);
            this.location(inputs.location);
            var args = {
                subscriptionId: this.subscriptionId(),
                location: this.location(),
            };
            return this._editScopeView.fetchForExistingData(inputs.editScopeId, null);
        };
        return AzureStackUsageCollectorSettingsViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.AzureStackUsageCollectorSettingsViewModel = AzureStackUsageCollectorSettingsViewModel;
});
