var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "ClientResources", "../../_generated/ExtensionDefinition"], function (require, exports, ClientResources, ExtensionDefinition) {
    "use strict";
    "use strict";
    var SettingsListBladeViewModel = (function (_super) {
        __extends(SettingsListBladeViewModel, _super);
        function SettingsListBladeViewModel(container, initialState, dataContext) {
            _super.call(this);
            this.subscriptionId = ko.observable("");
            this.location = ko.observable("");
            this.title(ClientResources.Assets.Billing.lowerPlural);
        }
        SettingsListBladeViewModel.prototype.onInputsSet = function (inputs) {
            this.subtitle("");
            this.subscriptionId(inputs.parameters.subscriptionId);
            this.location(inputs.parameters.location);
            return null;
        };
        return SettingsListBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.SettingsListBladeViewModel = SettingsListBladeViewModel;
    var SettingsListPartViewModel = (function (_super) {
        __extends(SettingsListPartViewModel, _super);
        function SettingsListPartViewModel(container, initialState, dataContext) {
            var productFeaturesSettingBladeInputs = ko.observable();
            var invoicePdfSettingBladeInputs = ko.observable();
            var cspSettingBladeInputs = ko.observable();
            var emailNotificationSettingBladeInputs = ko.observable();
            var stripeSettingBladeInputs = ko.observable();
            var azureStackUsageCollectorSettingsBladeInputs = ko.observable();
            var domainUserSettingsBladeInputs = ko.observable();
            var miscSettingsBladeInputs = ko.observable();
            _super.call(this, container, initialState, SettingsListPartViewModel._getSettings(container, productFeaturesSettingBladeInputs, invoicePdfSettingBladeInputs, cspSettingBladeInputs, emailNotificationSettingBladeInputs, stripeSettingBladeInputs, azureStackUsageCollectorSettingsBladeInputs, domainUserSettingsBladeInputs, miscSettingsBladeInputs));
            this.subscriptionId = ko.observable("");
            this.location = ko.observable("");
            this._dataContext = dataContext;
            this._productFeaturesSettingBladeInputs = productFeaturesSettingBladeInputs;
            this._invoicePdfSettingBladeInputs = invoicePdfSettingBladeInputs;
            this._cspSettingBladeInputs = cspSettingBladeInputs;
            this._emailNotificationSettingBladeInputs = emailNotificationSettingBladeInputs;
            this._stripeSettingBladeInputs = stripeSettingBladeInputs;
            this._azureStackUsageCollectorSettingsBladeInputs = azureStackUsageCollectorSettingsBladeInputs;
            this._domainUserSettingsBladeInputs = domainUserSettingsBladeInputs;
            this._miscSettingsBladeInputs = miscSettingsBladeInputs;
        }
        SettingsListPartViewModel._getSettings = function (lifetimeManager, productFeaturesSettingBladeInputs, invoicePdfSettingBladeInputs, cspSettingBladeInputs, emailNotificationSettingBladeInputs, stripeSettingBladeInputs, azureStackUsageCollectorSettingsBladeInputs, domainUserSettingsBladeInputs, miscSettingsBladeInputs) {
            var productFeaturesSetting = new MsPortalFx.ViewModels.Parts.SettingList.Setting("productFeatures", ExtensionDefinition.BladeNames.productFeaturesSettingBlade, productFeaturesSettingBladeInputs);
            productFeaturesSetting.displayText("Product Feature Settings");
            productFeaturesSetting.icon(MsPortalFx.Base.Images.Polychromatic.Cubes());
            productFeaturesSetting.group("");
            var invoicePdfSetting = new MsPortalFx.ViewModels.Parts.SettingList.Setting("invoicePdf", ExtensionDefinition.BladeNames.invoicePdfSettingBlade, invoicePdfSettingBladeInputs);
            invoicePdfSetting.displayText("Invoice PDF Settings");
            invoicePdfSetting.icon(MsPortalFx.Base.Images.Polychromatic.OperationalInsights());
            invoicePdfSetting.group("");
            var cspSetting = new MsPortalFx.ViewModels.Parts.SettingList.Setting("csp", ExtensionDefinition.BladeNames.cspSettingBlade, cspSettingBladeInputs);
            cspSetting.displayText("CSP Settings");
            cspSetting.icon(MsPortalFx.Base.Images.Polychromatic.CloudService());
            cspSetting.group("");
            var emailNotificationSetting = new MsPortalFx.ViewModels.Parts.SettingList.Setting("email", ExtensionDefinition.BladeNames.emailNotificationSettingBlade, emailNotificationSettingBladeInputs);
            emailNotificationSetting.displayText("Email Settings");
            emailNotificationSetting.icon(MsPortalFx.Base.Images.Polychromatic.WebEnvironment());
            emailNotificationSetting.group("");
            var stripeSettings = new MsPortalFx.ViewModels.Parts.SettingList.Setting("stripe", ExtensionDefinition.BladeNames.stripeSettingsBlade, stripeSettingBladeInputs);
            stripeSettings.displayText("Stripe Settings");
            stripeSettings.icon(MsPortalFx.Base.Images.Polychromatic.Chart());
            stripeSettings.group("");
            var azureStackUsageCollectorSettings = new MsPortalFx.ViewModels.Parts.SettingList.Setting("azureStackUsageCollector", ExtensionDefinition.BladeNames.azureStackUsageCollectorSettingsBlade, azureStackUsageCollectorSettingsBladeInputs);
            azureStackUsageCollectorSettings.displayText("Azure Stack Usage Collector Settings");
            azureStackUsageCollectorSettings.icon(MsPortalFx.Base.Images.Polychromatic.Module());
            azureStackUsageCollectorSettings.group("");
            var domainUserSettings = new MsPortalFx.ViewModels.Parts.SettingList.Setting("domainUser", ExtensionDefinition.BladeNames.domainUserSettingsBlade, domainUserSettingsBladeInputs);
            domainUserSettings.displayText("Domain User Settings");
            domainUserSettings.icon(MsPortalFx.Base.Images.Polychromatic.ResourceRole());
            domainUserSettings.group("");
            var miscSettings = new MsPortalFx.ViewModels.Parts.SettingList.Setting("misc", ExtensionDefinition.BladeNames.miscSettingsBlade, miscSettingsBladeInputs);
            miscSettings.displayText("Misc Settings");
            miscSettings.icon(MsPortalFx.Base.Images.Polychromatic.ManagementPortal());
            miscSettings.group("");
            return [productFeaturesSetting, invoicePdfSetting, cspSetting,
                emailNotificationSetting, stripeSettings, azureStackUsageCollectorSettings,
                domainUserSettings, miscSettings];
        };
        SettingsListPartViewModel.prototype.onInputsSet = function (inputs) {
            this._productFeaturesSettingBladeInputs({ subscriptionId: inputs.parameters.subscriptionId, location: inputs.parameters.location });
            this._invoicePdfSettingBladeInputs({ subscriptionId: inputs.parameters.subscriptionId, location: inputs.parameters.location });
            this._cspSettingBladeInputs({ subscriptionId: inputs.parameters.subscriptionId, location: inputs.parameters.location });
            this._emailNotificationSettingBladeInputs({ subscriptionId: inputs.parameters.subscriptionId, location: inputs.parameters.location });
            this._stripeSettingBladeInputs({ subscriptionId: inputs.parameters.subscriptionId, location: inputs.parameters.location });
            this._azureStackUsageCollectorSettingsBladeInputs({ subscriptionId: inputs.parameters.subscriptionId, location: inputs.parameters.location });
            this._domainUserSettingsBladeInputs({ subscriptionId: inputs.parameters.subscriptionId, location: inputs.parameters.location });
            this._miscSettingsBladeInputs({ subscriptionId: inputs.parameters.subscriptionId, location: inputs.parameters.location });
            this.subscriptionId(inputs.parameters.subscriptionId);
            this.location(inputs.parameters.location);
            return Q();
        };
        return SettingsListPartViewModel;
    }(MsPortalFx.ViewModels.Parts.SettingList.ViewModelV2));
    exports.SettingsListPartViewModel = SettingsListPartViewModel;
});
