define(["require", "exports"], function (require, exports) {
    "use strict";
    var ArmHelpers = Common.Helpers;
    var fxEnv = window.fx.environment;
    var rpApiVersion = window.fx.environment.billingRpApiVersion;
    "use strict";
    var BillingOverviewManager = (function () {
        function BillingOverviewManager() {
            this.Urls = {
                billingPeriods: "/subscriptions/{subscriptionId}/providers/CloudAssert.Billing.Admin/locations/{location}/billingPeriods",
                totalCostPerRescource: "/subscriptions/{subscriptionId}/providers/CloudAssert.Billing.Admin/locations/{location}/overview/{isoCurrencySymbol}",
                totalCostPerServiceType: "/subscriptions/{subscriptionId}/providers/CloudAssert.Billing.Admin/locations/{location}/overview/{isoCurrencySymbol}/GetTotalCostPerServiceType",
                topUsersByCost: "/subscriptions/{subscriptionId}/providers/CloudAssert.Billing.Admin/locations/{location}/overview/{isoCurrencySymbol}/GetTopUsersByCost",
                dailyCostList: "/subscriptions/{subscriptionId}/providers/CloudAssert.Billing.Admin/locations/{location}/overview/{isoCurrencySymbol}/GetDailyCostList",
                resourceCountForSubscriptions: "/subscriptions/{subscriptionId}/providers/CloudAssert.Billing.Admin/locations/{location}/overview/{isoCurrencySymbol}/GetResourceCountForSubscriptions",
            };
        }
        BillingOverviewManager.prototype.getBillingPeriods = function (subscriptionId, location) {
            var urlSegment = MsPortalFx.Data.uriFormatter(this.Urls.billingPeriods, false)({
                subscriptionId: subscriptionId,
                location: location
            });
            var urlSegmentWithApiVersion = urlSegment + "?api-version=" + rpApiVersion;
            var q = ArmHelpers.callArmUri(urlSegmentWithApiVersion, "GET");
            return q;
        };
        BillingOverviewManager.prototype.getTotalCostPerRescource = function (subscriptionId, location, isoCurrencySymbol) {
            var urlSegment = MsPortalFx.Data.uriFormatter(this.Urls.totalCostPerRescource, false)({
                subscriptionId: subscriptionId,
                location: location,
                isoCurrencySymbol: isoCurrencySymbol
            });
            var urlSegmentWithApiVersion = urlSegment + "?api-version=" + rpApiVersion;
            var q = ArmHelpers.callArmUri(urlSegmentWithApiVersion, "GET");
            return q;
        };
        BillingOverviewManager.prototype.getTotalCostPerServiceType = function (subscriptionId, location, isoCurrencySymbol) {
            var urlSegment = MsPortalFx.Data.uriFormatter(this.Urls.totalCostPerServiceType, false)({
                subscriptionId: subscriptionId,
                location: location,
                isoCurrencySymbol: isoCurrencySymbol
            });
            var urlSegmentWithApiVersion = urlSegment + "?api-version=" + rpApiVersion;
            var q = ArmHelpers.callArmUri(urlSegmentWithApiVersion, "GET");
            return q;
        };
        BillingOverviewManager.prototype.getTopUsersByCost = function (subscriptionId, location, isoCurrencySymbol) {
            var urlSegment = MsPortalFx.Data.uriFormatter(this.Urls.topUsersByCost, false)({
                subscriptionId: subscriptionId,
                location: location,
                isoCurrencySymbol: isoCurrencySymbol
            });
            var urlSegmentWithApiVersion = urlSegment + "?api-version=" + rpApiVersion;
            var q = ArmHelpers.callArmUri(urlSegmentWithApiVersion, "GET");
            return q;
        };
        BillingOverviewManager.prototype.getDailyCostList = function (subscriptionId, location, isoCurrencySymbol) {
            var urlSegment = MsPortalFx.Data.uriFormatter(this.Urls.dailyCostList, false)({
                subscriptionId: subscriptionId,
                location: location,
                isoCurrencySymbol: isoCurrencySymbol
            });
            var urlSegmentWithApiVersion = urlSegment + "?api-version=" + rpApiVersion;
            var q = ArmHelpers.callArmUri(urlSegmentWithApiVersion, "GET");
            return q;
        };
        BillingOverviewManager.prototype.getResourceCountForSubscriptions = function (subscriptionId, location, isoCurrencySymbol) {
            var urlSegment = MsPortalFx.Data.uriFormatter(this.Urls.resourceCountForSubscriptions, false)({
                subscriptionId: subscriptionId,
                location: location,
                isoCurrencySymbol: isoCurrencySymbol
            });
            var urlSegmentWithApiVersion = urlSegment + "?api-version=" + rpApiVersion;
            var q = ArmHelpers.callArmUri(urlSegmentWithApiVersion, "GET");
            return q;
        };
        return BillingOverviewManager;
    }());
    exports.BillingOverviewManager = BillingOverviewManager;
});
