define(["require", "exports"], function (require, exports) {
    "use strict";
    var DataModels = BillingExtension.DataModels;
    var ArmHelpers = Common.Helpers;
    var fxEnv = window.fx.environment;
    var rpApiVersion = fxEnv.billingRpApiVersion;
    "use strict";
    var UsageAggregationStatusDataManager = (function () {
        function UsageAggregationStatusDataManager() {
            this.usageAggregationStatusEntityUriFormat = ArmHelpers.getArmUriFormatter("/subscriptions/{subscriptionId}/providers/CloudAssert.Billing.Admin/locations/{location}/usageAggregationStatus", rpApiVersion);
            this.agentLogsEntityUriFormat = ArmHelpers.getArmUriFormatter("/subscriptions/{subscriptionId}/providers/CloudAssert.Billing.Admin/locations/{location}/usageAggregationStatus/getAgentLogs", rpApiVersion);
            this.getUsageAggregationStatusEntity = new MsPortalFx.Data.EntityCache({
                entityTypeName: DataModels.UsageAggregationStatusModelType,
                sourceUri: this.usageAggregationStatusEntityUriFormat,
                supplyData: ArmHelpers.getArmDataSupplier(),
                poll: false
            });
            this.getAgentLogsEntityUriFormat = new MsPortalFx.Data.EntityCache({
                entityTypeName: DataModels.AgentLogInfoModelType,
                sourceUri: this.agentLogsEntityUriFormat,
                supplyData: ArmHelpers.getArmDataSupplier(),
                poll: false
            });
        }
        return UsageAggregationStatusDataManager;
    }());
    exports.UsageAggregationStatusDataManager = UsageAggregationStatusDataManager;
});
