define(["require", "exports", "../Helpers"], function (require, exports, Helpers) {
    "use strict";
    var ArmHelpers = Common.Helpers;
    var fxEnv = window.fx.environment;
    var rpApiVersion = fxEnv.billingRpApiVersion;
    "use strict";
    var UsageAndQuotaDataManager = (function () {
        function UsageAndQuotaDataManager() {
            this.Urls = {
                getAzSQuotaFilters: "/subscriptions/{subscriptionId}/providers/CloudAssert.Billing.Admin/locations/{location}/adminUsageAndQuota/getAdminFiltersForAzureStackQuota",
                getAzSSnapInView: "/subscriptions/{subscriptionId}/providers/CloudAssert.Billing.Admin/locations/{location}/adminUsageAndQuota/getAzureStackQuotaSnapInForSubscriptions",
                getAzSTrendView: "/subscriptions/{subscriptionId}/providers/CloudAssert.Billing.Admin/locations/{location}/adminUsageAndQuota/getAzureStackQuotaTrendForSubscriptions",
                getSubscriptionsForUser: "/subscriptions/{subscriptionId}/providers/CloudAssert.Billing.Admin/locations/{location}/adminUsageAndQuota/getSubscriptionIdFilterForUser/{userId}",
                downloadAzSQuotaSummary: "/subscriptions/{subscriptionId}/providers/CloudAssert.Billing.Admin/locations/{location}/adminUsageAndQuota/downloadAzureStackQuotaSummary"
            };
            this.downloadAzSQuotaSummaryUri = ArmHelpers.getArmUriFormatter(this.Urls.downloadAzSQuotaSummary, rpApiVersion);
        }
        UsageAndQuotaDataManager.prototype.getAzSQuotaFilters = function (subscriptionId) {
            var argsToUri = {
                subscriptionId: subscriptionId,
                location: "local"
            };
            var uriSegment = MsPortalFx.Data.uriFormatter(this.Urls.getAzSQuotaFilters, false)(argsToUri);
            var promise = Helpers.callArm(uriSegment, "POST", rpApiVersion);
            return promise;
        };
        UsageAndQuotaDataManager.prototype.getAzSSnapInView = function (subscriptionId, azureStackQuotaOverviewIn) {
            var argsToUri = {
                subscriptionId: subscriptionId,
                location: "local"
            };
            var uriSegment = MsPortalFx.Data.uriFormatter(this.Urls.getAzSSnapInView, false)(argsToUri);
            var postData = ko.toJSON(azureStackQuotaOverviewIn);
            var promise = Helpers.callArm(uriSegment, "POST", rpApiVersion, postData);
            return promise;
        };
        UsageAndQuotaDataManager.prototype.getAzsTrendView = function (subscriptionId, azureStackQuotaOverviewIn) {
            var argsToUri = {
                subscriptionId: subscriptionId,
                location: "local"
            };
            var uriSegment = MsPortalFx.Data.uriFormatter(this.Urls.getAzSTrendView, false)(argsToUri);
            var postData = ko.toJSON(azureStackQuotaOverviewIn);
            var promise = Helpers.callArm(uriSegment, "POST", rpApiVersion, postData);
            return promise;
        };
        UsageAndQuotaDataManager.prototype.getSubscriptionsForUser = function (subscriptionId, userId) {
            var uri = MsPortalFx.Data.uriFormatter(this.Urls.getSubscriptionsForUser, false)({
                subscriptionId: subscriptionId,
                location: 'local',
                userId: userId
            });
            var urlSegmentWithApiVersion = uri + "?api-version=" + rpApiVersion;
            var promise = ArmHelpers.callArmUri(urlSegmentWithApiVersion, "GET");
            return promise;
        };
        return UsageAndQuotaDataManager;
    }());
    exports.UsageAndQuotaDataManager = UsageAndQuotaDataManager;
});
