define(["require", "exports"], function (require, exports) {
    "use strict";
    var ArmHelpers = Common.Helpers;
    var fxEnv = window.fx.environment;
    var rpApiVersion = window.fx.environment.billingRpApiVersion;
    "use strict";
    var UsageHistoryDataManager = (function () {
        function UsageHistoryDataManager() {
            this.Urls = {
                UsageHistoryFormat: "/subscriptions/{subscriptionId}/providers/CloudAssert.Billing.Admin/locations/{location}/UsageHistory?startDate={startDate}",
                DownloadUsageFormat: "/subscriptions/{subscriptionId}/providers/CloudAssert.Billing.Admin/locations/{location}/DownloadUsage?selectedSubscriptionId={selectedSubscriptionId}&startDate={startDate}&isOverallUsage={isOverallUsage}&isOverallDetailedUsage={isOverallDetailedUsage}",
            };
            this.usageHistoryQueryUriFormat = ArmHelpers.getArmUriFormatter(this.Urls.UsageHistoryFormat, fxEnv.billingRpApiVersion);
            this.downloadUsageQueryUriFormat = ArmHelpers.getArmUriFormatter(this.Urls.DownloadUsageFormat, fxEnv.billingRpApiVersion);
            this.usageHistoryQuery = new MsPortalFx.Data.QueryCache({
                sourceUri: this.usageHistoryQueryUriFormat,
                supplyData: ArmHelpers.getArmDataSupplier(),
                processServerResponse: function (data) { return { data: data }; },
                poll: false
            });
        }
        return UsageHistoryDataManager;
    }());
    exports.UsageHistoryDataManager = UsageHistoryDataManager;
});
