var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports"], function (require, exports) {
    "use strict";
    var FxDropDown = MsPortalFx.ViewModels.Obsolete.Forms.DropDown;
    var FxForms = MsPortalFx.ViewModels.Forms;
    var DatePicker = FxForms.DatePicker;
    var Chart = MsPortalFx.ViewModels.Controls.Visualization.Chart;
    var SimpleChart = MsPortalFx.ViewModels.Controls.Visualization.SimpleChart;
    var FxControls = MsPortalFx.ViewModels.Controls;
    "use strict";
    var UsageAndQuotaTrendBladeViewModel = (function (_super) {
        __extends(UsageAndQuotaTrendBladeViewModel, _super);
        function UsageAndQuotaTrendBladeViewModel(container, initialState, dataContext) {
            _super.call(this);
            this.subscriptionId = ko.observable();
            this.selectedProvider = ko.observable();
            this.selectedResource = ko.observable();
            this.selectedSubscriptionId = ko.observable();
            this.selectedUser = ko.observable();
            this.allProviderList = ko.observableArray([]);
            this.allResourceList = ko.observableArray([]);
            this.location = ko.observable("local");
            this.subscriptionIdIn = ko.observable();
            this.subscriptionIdList = ko.observableArray([]);
            this.title("Quota - Trend View");
            this._container = container;
            this._dataContext = dataContext;
            this._initFiltersAndButtonsSection(container);
            this.simpleChartVM = new MsPortalFx.ViewModels.Controls.Visualization.SimpleChart.ViewModel(container, {
                series: ko.observableArray([]),
                chartType: ko.observable(0),
                xAxis: {},
                yAxis: {
                    max: ko.observable(100),
                    min: ko.observable(0),
                    unit: ko.observable(MsPortalFx.UnitConversion.Unit.Percentage)
                },
                legendPosition: 3
            });
        }
        UsageAndQuotaTrendBladeViewModel.prototype._initFiltersAndButtonsSection = function (container) {
            var _this = this;
            var userDropDownOptions = {
                label: ko.observable("User"),
                labelPosition: ko.observable(FxForms.LabelPosition.Left),
                infoBalloonContent: ko.observable("Choose a user"),
                options: ko.observableArray([{ text: ko.observable("Loading.."), value: "" }])
            };
            this.usersDropDown = new FxDropDown.ViewModel(container, userDropDownOptions);
            this.usersDropDown.value.subscribe(container, function (newUser) {
                _this.selectedUser(newUser);
                _this._dataContext.usageAndQuotaDataManager.getSubscriptionsForUser(_this.subscriptionIdIn(), newUser)
                    .then(function (subDict) {
                    _this.subscriptionIdList(Object.keys(subDict));
                    var subscriptionDropdownValues = _this.subscriptionIdList().map(function (id) {
                        return {
                            text: ko.observable(subDict[id]),
                            value: id,
                            disabled: ko.observable(false)
                        };
                    });
                    subscriptionDropdownValues.unshift({
                        text: ko.observable("Please select a subscription..."),
                        value: null,
                        disabled: ko.observable(false)
                    });
                    _this.subscriptionsDropDown.options(subscriptionDropdownValues);
                    _this.subscriptionsDropDown.value(_this.subscriptionIdList().first());
                    _this.subscriptionsDropDown.disabled(false);
                });
            });
            var subscriptionsDropDownOptions = {
                label: ko.observable("Subscription"),
                labelPosition: ko.observable(FxForms.LabelPosition.Left),
                infoBalloonContent: ko.observable("Choose a subscription"),
                options: ko.observableArray([{ text: ko.observable("Loading.."), value: "" }])
            };
            this.subscriptionsDropDown = new FxDropDown.ViewModel(container, subscriptionsDropDownOptions);
            this.subscriptionsDropDown.value.subscribe(container, function (newSubscriptionId) {
                _this.selectedSubscriptionId(newSubscriptionId);
            });
            var providerDropDownOptions = {
                label: ko.observable("Providers"),
                labelPosition: ko.observable(FxForms.LabelPosition.Left),
                infoBalloonContent: ko.observable("Choose the providers"),
                options: ko.observableArray([{ text: ko.observable("Loading.."), value: "" }])
            };
            this.providersDropDown = new FxDropDown.ViewModel(container, providerDropDownOptions);
            this.providersDropDown.value.subscribe(container, function (resource) {
                _this.selectedProvider(resource);
            });
            var fromDatePicker = {
                label: ko.observable("From"),
                infoBalloonContent: ko.observable("Choose a start date"),
                labelPosition: ko.observable(FxForms.LabelPosition.Left)
            };
            this.fromDatePicker = new DatePicker.ViewModel(this._container, fromDatePicker);
            var toDatePicker = {
                label: ko.observable("To"),
                infoBalloonContent: ko.observable("Choose an end date"),
                labelPosition: ko.observable(FxForms.LabelPosition.Left)
            };
            this.toDatePicker = new DatePicker.ViewModel(this._container, toDatePicker);
            var quotaDropdown = {};
            var quotaResourceDropDownOptions = {
                label: ko.observable("Quota Resource"),
                labelPosition: ko.observable(FxForms.LabelPosition.Left),
                infoBalloonContent: ko.observable("Choose the Resource"),
                options: ko.observableArray([{ text: ko.observable("Loading.."), value: "" }])
            };
            this.resourcesDropDown = new FxDropDown.ViewModel(container, quotaResourceDropDownOptions);
            this.resourcesDropDown.value.subscribe(container, function (resource) {
                _this.selectedResource(resource);
            });
            this.applyFiltersButton = new FxControls.SimpleButton.ViewModel(container, {
                onClick: this._onApplyButtonClicked.bind(this),
                text: "Apply",
                primary: true,
            });
            var column1 = new MsPortalFx.ViewModels.Forms.Section.ViewModel(container, {
                style: ko.observable(0),
                children: ko.observableArray([
                    this.fromDatePicker,
                    this.subscriptionsDropDown
                ])
            });
            var column2 = new MsPortalFx.ViewModels.Forms.Section.ViewModel(container, {
                style: ko.observable(0),
                children: ko.observableArray([
                    this.toDatePicker,
                    this.providersDropDown
                ])
            });
            var column3 = new MsPortalFx.ViewModels.Forms.Section.ViewModel(container, {
                style: ko.observable(0),
                children: ko.observableArray([
                    this.usersDropDown,
                    this.resourcesDropDown
                ])
            });
            this.filtersSection = new MsPortalFx.ViewModels.Forms.Section.ViewModel(container, {
                style: ko.observable(3),
                children: ko.observableArray([
                    column1, column2, column3
                ])
            });
        };
        UsageAndQuotaTrendBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            var _this = this;
            this.subscriptionIdIn(inputs.subscriptionId);
            var q1 = this._dataContext.usageAndQuotaDataManager.getAzSQuotaFilters(this.subscriptionIdIn()).then(function (filters) {
                var resourceList = [];
                var providers = Object.keys(filters.ResourcesDict);
                _this.allProviderList(providers);
                var providerDropdownValues = providers.map(function (provider) {
                    return {
                        text: ko.observable(provider),
                        value: provider,
                        disabled: ko.observable(false)
                    };
                });
                providerDropdownValues.unshift({
                    text: ko.observable("Please select a provider..."),
                    value: "-1",
                    disabled: ko.observable(false)
                });
                _this.providersDropDown.options(providerDropdownValues);
                _this.providersDropDown.value(_this.allProviderList().first());
                _this.providersDropDown.disabled(false);
                Object.keys(filters.ResourcesDict).forEach(function (key) {
                    resourceList = resourceList.concat(filters.ResourcesDict[key]);
                });
                _this.allResourceList(resourceList);
                var resourcesDropdownValues = resourceList.map(function (resource) {
                    return {
                        text: ko.observable(resource),
                        value: resource,
                        disabled: ko.observable(false)
                    };
                });
                resourcesDropdownValues.unshift({
                    text: ko.observable("All Quota Resources"),
                    value: "-1",
                    disabled: ko.observable(false)
                });
                _this.resourcesDropDown.options(resourcesDropdownValues);
                _this.resourcesDropDown.value("-1");
                _this.resourcesDropDown.disabled(false);
                var usersDropdownValues = filters.Users.map(function (user) {
                    return {
                        text: ko.observable(user),
                        value: user,
                        disabled: ko.observable(false)
                    };
                });
                usersDropdownValues.unshift({
                    text: ko.observable("Please select a user..."),
                    value: null,
                    disabled: ko.observable(false)
                });
                _this.usersDropDown.options(usersDropdownValues);
                var currentUserId = filters.Users.first();
                _this.usersDropDown.value(currentUserId);
                _this.usersDropDown.disabled(false);
                _this.subscriptionIdList(Object.keys(filters.SubscriptionsDict));
                var subscriptionDropdownValues = _this.subscriptionIdList().map(function (id) {
                    return {
                        text: ko.observable(filters.SubscriptionsDict[id]),
                        value: id,
                        disabled: ko.observable(false)
                    };
                });
                subscriptionDropdownValues.unshift({
                    text: ko.observable("Please select a subscription..."),
                    value: null,
                    disabled: ko.observable(false)
                });
                _this.subscriptionsDropDown.options(subscriptionDropdownValues);
                _this.subscriptionsDropDown.value(_this.subscriptionIdList().first());
                _this.subscriptionsDropDown.disabled(false);
                filters.BillingCyclePeriods.forEach(function (period) {
                    if (period.IsCurrent) {
                        var date = new Date(period.StartDate);
                        var startDate = new Date(date.getUTCFullYear(), date.getUTCMonth(), date.getUTCDate());
                        _this.fromDatePicker.value(startDate);
                        date = new Date(period.EndDate);
                        var endDate = new Date(date.getUTCFullYear(), date.getUTCMonth(), date.getUTCDate());
                        _this.toDatePicker.value(endDate);
                    }
                });
                _this.providersDropDown.value(providers[0]);
            });
            return Q.all([q1]).then(function () {
                _this._onApplyButtonClicked();
            });
        };
        UsageAndQuotaTrendBladeViewModel.prototype._onApplyButtonClicked = function () {
            var _this = this;
            var subId = this.selectedSubscriptionId();
            var provider;
            var resource = [];
            var subIdList = [];
            if (this.selectedProvider() == "-1") {
                provider = this.allProviderList().first();
            }
            else {
                provider = this.selectedProvider();
            }
            if (this.selectedResource() == "-1") {
                resource = this.allResourceList();
            }
            else {
                resource.push(this.selectedResource());
            }
            subIdList.push(subId);
            var input = {
                SubscriptionIdList: subIdList,
                QuotaProvider: provider,
                QuotaResourceNames: resource,
                StartTime: this.fromDatePicker.value(),
                EndTime: this.toDatePicker.value(),
            };
            this._dataContext.usageAndQuotaDataManager.getAzsTrendView(this.subscriptionIdIn(), input).then(function (quotaRecords) {
                var quota = ko.observableArray(quotaRecords);
                quota.mapInto(_this._container, function (seriesLifetime, dataSeries) {
                    var chartSeries = new SimpleChart.Series();
                    chartSeries.name = dataSeries.QuotaResourceName;
                    chartSeries.viewOptions = {
                        displayName: ko.observable(dataSeries.QuotaResourceName),
                    };
                    var data = ko.observableArray(dataSeries.AzureStackQuotaTrendData);
                    data.mapInto(_this._container, function (seriesLifetime, dataPoint) {
                        var date = new Date(dataPoint.DateTime);
                        return new Chart.ChartItem(date, dataPoint.ConsumptionPercentage);
                    }, chartSeries.values);
                    return chartSeries;
                }, _this.simpleChartVM.series);
            });
        };
        return UsageAndQuotaTrendBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.UsageAndQuotaTrendBladeViewModel = UsageAndQuotaTrendBladeViewModel;
});
