var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "../../Shared/Helpers"], function (require, exports, Helpers) {
    "use strict";
    var FxGrid = MsPortalFx.ViewModels.Controls.Lists.Grid;
    var FxGridExtensions = FxGrid.Extensions;
    "use strict";
    var UsageProcessingStatusViewModel = (function (_super) {
        __extends(UsageProcessingStatusViewModel, _super);
        function UsageProcessingStatusViewModel(container, initialState, dataContext) {
            var _this = this;
            _super.call(this);
            this.subscriptionId = ko.observable();
            this.location = ko.observable();
            this._userOverview = ko.observable();
            this.title("Agent Servivce Status");
            this._container = container;
            this._dataContext = dataContext;
            this._dataEntityView = dataContext.usageAggregationStatusDataManager.getUsageAggregationStatusEntity.createView(container, {
                interceptNotFound: false
            });
            ko.reactor(container, function () {
            });
            var gridExtensions = FxGridExtensions.SelectableRow;
            var gridExtensionOptions = {
                selectableRow: {
                    selectionMode: 1,
                    activateOnSelected: ko.observable(false)
                }
            };
            this.usageProcessingStatusGrid = new FxGrid.ViewModel(container, ko.observableArray([]), gridExtensions, gridExtensionOptions);
            this.recordsCountGrid = new FxGrid.ViewModel(container, ko.observableArray([]), gridExtensions, gridExtensionOptions);
            var dateTimeFormat = Helpers.getTimeFormat(false, true);
            var basicColumns = [
                {
                    itemKey: "StateName",
                    name: ko.observable("Aggregator Name"),
                    width: ko.observable("120px"),
                    activatable: ko.observable(true),
                },
                {
                    itemKey: "LastProcessedTime",
                    name: ko.observable("Last Processed Time"),
                    width: ko.observable("50px"),
                    activatable: ko.observable(true),
                    format: MsPortalFx.ViewModels.Controls.Lists.Grid.Format.CustomDate,
                    formatOptions: {
                        dateFormat: dateTimeFormat
                    }
                },
                {
                    itemKey: "LastSeenTime",
                    name: ko.observable("Last Seen Time"),
                    width: ko.observable("50px"),
                    format: MsPortalFx.ViewModels.Controls.Lists.Grid.Format.CustomDate,
                    formatOptions: {
                        dateFormat: dateTimeFormat
                    }
                },
            ];
            this.usageProcessingStatusGrid.columns = ko.observableArray(basicColumns);
            this.usageProcessingStatusGrid.showHeader = true;
            this.usageProcessingStatusGrid.summary = ko.observable("Summary");
            this.usageProcessingStatusGrid.noRowsMessage("No items found");
            var recordCountColumns = [
                {
                    itemKey: "RecordType",
                    name: ko.observable("Record Type"),
                    width: ko.observable("120px"),
                    activatable: ko.observable(true),
                },
                {
                    itemKey: "Count",
                    name: ko.observable("Count"),
                    width: ko.observable("50px"),
                    activatable: ko.observable(true),
                },
            ];
            this.recordsCountGrid.columns = ko.observableArray(recordCountColumns);
            this.recordsCountGrid.showHeader = true;
            this.recordsCountGrid.summary = ko.observable("Summary");
            this.recordsCountGrid.noRowsMessage("No items found");
            this._dataEntityView.item.subscribe(container, function (usageProcessingStatus) {
                _this.usageProcessingStatusGrid.items(usageProcessingStatus.States());
                _this.recordsCountGrid.items(usageProcessingStatus.RecordCount());
            });
            this._dataEntityView.loading.subscribe(container, function (isLoading) {
                _this.usageProcessingStatusGrid.loading(isLoading);
                _this.recordsCountGrid.loading(isLoading);
            });
        }
        UsageProcessingStatusViewModel.prototype.onInputsSet = function (inputs, settings) {
            this.subscriptionId(inputs.subscriptionId);
            this.location(inputs.location);
            return this._dataEntityView.fetch({
                subscriptionId: this.subscriptionId(),
                location: this.location(),
            });
        };
        return UsageProcessingStatusViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.UsageProcessingStatusViewModel = UsageProcessingStatusViewModel;
});
