var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports"], function (require, exports) {
    "use strict";
    var FxToolbars = MsPortalFx.ViewModels.Toolbars;
    var Dialogs = MsPortalFx.ViewModels.Dialogs;
    var Images = MsPortalFx.Base.Images;
    var FxForms = MsPortalFx.ViewModels.Forms;
    var UserCreditsDetailsBladeViewModel = (function (_super) {
        __extends(UserCreditsDetailsBladeViewModel, _super);
        function UserCreditsDetailsBladeViewModel(container, initialState, dataContext) {
            _super.call(this);
            this.subscriptionId = ko.observable("");
            this.selectedUserId = ko.observable("");
            this.selectedUserCredits = ko.observable();
            this.selectedCurrency = ko.observable("");
            this.location = ko.observable("");
            this.icon(Images.Customize());
            this._container = container;
            this._dataContext = dataContext;
            this._userCreditEntityView = dataContext.userCreditsManager.userCreditEntity.createView(container);
            this._initializeFormFields(container);
            this.commandBar = new MsPortalFx.ViewModels.Toolbars.Toolbar(container);
            this._setupCommandBar();
        }
        UserCreditsDetailsBladeViewModel.prototype._setupCommandBar = function () {
            this._saveButton = this._createSaveButton();
            this.commandBar = new MsPortalFx.ViewModels.Toolbars.Toolbar(this._container);
            this.commandBar.setItems([
                this._saveButton,
            ]);
        };
        UserCreditsDetailsBladeViewModel.prototype._createSaveButton = function () {
            var _this = this;
            var saveButton = new FxToolbars.DialogButton({
                label: "Save",
                icon: MsPortalFx.Base.Images.Save(),
                dialogOptions: new Dialogs.MessageBox("", "Are you sure you want to save ?", 4),
            });
            saveButton.command = {
                canExecute: ko.computed(this._container, function () {
                    return true;
                }),
                execute: function (result) {
                    if (result === 6) {
                        var userCreditsInfo = {
                            UserId: _this.selectedUserId(),
                            CreditBalance: _this.creditAmountTxField.value(),
                            IsLowCreditsCheckerEnabled: _this.isLowCreditsCheckerEnabledOptionField.value(),
                            ISOCurrencySymbol: _this.selectedCurrency(),
                        };
                        _this._dataContext.userCreditsManager.updateUserCreditsQuery(_this.subscriptionId(), _this.location(), userCreditsInfo)
                            .finally(function () {
                            _this._container.closeCurrentBlade();
                        });
                    }
                    return null;
                }
            };
            return saveButton;
        };
        UserCreditsDetailsBladeViewModel.prototype._initializeFormFields = function (container) {
            var creditAmountTxFieldOptions = {
                min: ko.observable(0),
                max: ko.observable(999999999),
            };
            this.creditAmountTxField = new MsPortalFx.ViewModels.Forms.NumericTextBox.ViewModel(container, creditAmountTxFieldOptions);
            var isLowCreditsCheckerEnabledOptions = {
                label: ko.observable("Is Low Credits Checker Enabled ?"),
                options: ko.observableArray([
                    { text: ko.observable("Yes"), value: true },
                    { text: ko.observable("No"), value: false }
                ]),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RequiredValidation("Required"),
                ]),
            };
            this.isLowCreditsCheckerEnabledOptionField = new FxForms.OptionsGroup.ViewModel(container, isLowCreditsCheckerEnabledOptions);
            this.formSection = new FxForms.Section.ViewModel(container, {
                children: ko.observableArray([
                    this.creditAmountTxField,
                ])
            });
        };
        UserCreditsDetailsBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            var _this = this;
            this.subscriptionId(inputs.subscriptionId);
            this.location(inputs.location);
            this.selectedUserId(inputs.selectedUserId);
            this.selectedCurrency(inputs.selectedCurrency);
            this.selectedUserCredits(inputs.selectedUserCredits);
            var title = "User Credits Details";
            this.title(title);
            this.description(title);
            this.creditAmountTxField.label("Credit Amount" + " ({0})".format(this.selectedCurrency()));
            this.creditAmountTxField.value(this.selectedUserCredits());
            var args = {
                subscriptionId: this.subscriptionId(),
                userId: this.selectedUserId(),
                locationName: this.location(),
                isoCurrencySymbol: this.selectedCurrency(),
            };
            return this._userCreditEntityView.fetch(args).then(function () {
                var dataEntity = _this._userCreditEntityView.item();
                _this.isLowCreditsCheckerEnabledOptionField.value(dataEntity.IsLowCreditsCheckerEnabled());
            });
        };
        return UserCreditsDetailsBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.UserCreditsDetailsBladeViewModel = UserCreditsDetailsBladeViewModel;
});
