var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "../../Shared/Helpers"], function (require, exports, Helpers) {
    "use strict";
    var UserProfileDetailsPartViewModel = (function (_super) {
        __extends(UserProfileDetailsPartViewModel, _super);
        function UserProfileDetailsPartViewModel(container, initialState, dataContext) {
            var _this = this;
            _super.call(this);
            this.detailsSection = ko.observableArray();
            this.userProfileId = ko.observable();
            this.selectedUserProfile = ko.observable();
            this.container = container;
            ko.reactor(container, function () {
                if (_this.selectedUserProfile()) {
                    _this.detailsSection([]);
                    var items = [];
                    var paymentType = Helpers.getPaymentType(_this.selectedUserProfile().IsInvoiceManual.toString());
                    var country = void 0;
                    country = _this.selectedUserProfile().BillingCountry;
                    items.push({ label: "User Login Id", value: _this.selectedUserProfile().UserId });
                    items.push({ label: "Address", value: _this.selectedUserProfile().BillingAddress1 });
                    items.push({ label: "City", value: _this.selectedUserProfile().BillingCity });
                    items.push({ label: "Zip", value: _this.selectedUserProfile().BillingPostalCode });
                    items.push({ label: "Country", value: _this.selectedUserProfile().BillingState + ", " + country.Name });
                    items.push({ label: "Contact Number", value: _this.selectedUserProfile().BillingPhoneNumber });
                    items.push({ label: "Email Id", value: _this.selectedUserProfile().BillingEmailAddress });
                    items.push({ label: "Payment Type", value: paymentType });
                    items.push({ label: "Currency Code", value: _this.selectedUserProfile().CurrencyCode });
                    var section = {
                        title: ko.observable(_this.selectedUserProfile().BillingFirstName + " " + _this.selectedUserProfile().BillingLastName),
                        items: ko.observableArray(items)
                    };
                    _this.detailsSection.push(section);
                }
            });
        }
        UserProfileDetailsPartViewModel.prototype.onInputsSet = function (inputs) {
            this.userProfileId(inputs.userProfileId);
            this.selectedUserProfile(inputs.selectedUserProfile);
            return Q();
        };
        return UserProfileDetailsPartViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.UserProfileDetailsPartViewModel = UserProfileDetailsPartViewModel;
});
