var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "ClientResources", "../../_generated/ExtensionDefinition"], function (require, exports, ClientResources, ExtensionDefinition) {
    "use strict";
    var ArmHelpers = Common.Helpers;
    "use strict";
    var UserProfileListBladeViewModel = (function (_super) {
        __extends(UserProfileListBladeViewModel, _super);
        function UserProfileListBladeViewModel(container, initialState, dataContext) {
            _super.call(this);
            this.subscriptionId = ko.observable("");
            this.location = ko.observable("");
            this.title(ClientResources.Assets.Billing.lowerPlural);
        }
        UserProfileListBladeViewModel.prototype.onInputsSet = function (inputs) {
            this.subtitle("");
            this.subscriptionId(inputs.parameters.subscriptionId);
            this.location(inputs.parameters.location);
            return null;
        };
        return UserProfileListBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.UserProfileListBladeViewModel = UserProfileListBladeViewModel;
    var UserProfileListPartViewModel = (function (_super) {
        __extends(UserProfileListPartViewModel, _super);
        function UserProfileListPartViewModel(container, initialState, dataContext) {
            var userRequestsBladeInputs = ko.observable();
            _super.call(this, container, initialState, UserProfileListPartViewModel._getUserProfileBlades(container, userRequestsBladeInputs));
            this.subscriptionId = ko.observable("");
            this.location = ko.observable("");
            this._dataContext = dataContext;
            this._userRequestsBladeInputs = userRequestsBladeInputs;
        }
        UserProfileListPartViewModel._getUserProfileBlades = function (lifetimeManager, userRequestsBladeInputs) {
            var userRequests = new MsPortalFx.ViewModels.Parts.SettingList.Setting("userRequests", ExtensionDefinition.BladeNames.userRequestsBlade, userRequestsBladeInputs);
            userRequests.displayText("User Requests");
            userRequests.icon(MsPortalFx.Base.Images.Polychromatic.Cubes());
            userRequests.group("");
            return [userRequests];
        };
        UserProfileListPartViewModel.prototype.onInputsSet = function (inputs) {
            this._userRequestsBladeInputs({ subscriptionId: inputs.parameters.subscriptionId, location: inputs.parameters.location });
            this.subscriptionId(inputs.parameters.subscriptionId);
            this.location(inputs.parameters.location);
            return Q();
        };
        return UserProfileListPartViewModel;
    }(MsPortalFx.ViewModels.Parts.SettingList.ViewModelV2));
    exports.UserProfileListPartViewModel = UserProfileListPartViewModel;
});
