define(["require", "exports", "../Blades/AdminBillingStyles.css", "../Blades/QuotaStyles.css", "../../ResourceProvider/ViewModels/ResourceProviderOverviewBladeViewModel", "../../ResourceProvider/ViewModels/SelectedIsoCurrencySymbolPartViewModel", "../../ResourceProvider/ViewModels/CostComparisonTrendViewModel", "../../ResourceProvider/ViewModels/CostPerServiceTypeDonutPartViewModel", "../../ResourceProvider/ViewModels/TopUsersByCostChartPartViewModel", "../../ResourceProvider/ViewModels/CostPerResourceChartPartViewModel", "../../ResourceProvider/ViewModels/ResourceCountPerSubscriptionChartPartViewModel", "../../ResourceProvider/ViewModels/ResourceProviderResourceSummaryPartViewModel"], function (require, exports, BladesAdminBillingStylescss, BladesQuotaStylescss) {
    "use strict";
    var Main;
    (function (Main) {
        "use strict";
        Main.blade = {
            "name": "ResourceProviderOverviewBlade",
            "inputs": [
                "resourceProviderAssetId"
            ],
            "templateKeyInputs": [
                "resourceProviderAssetId"
            ],
            "viewModelName": "ResourceProvider$ResourceProviderOverviewBladeViewModel",
            "lenses": [
                {
                    "name": "IsoCurrencySymbolLens",
                    "partInstances": [
                        {
                            "name": "SelectedIsoCurrencySymbolPart",
                            "inline": {
                                "styleSheets": [
                                    {
                                        "file": "Blades/QuotaStyles.css",
                                        "content": BladesQuotaStylescss
                                    },
                                    {
                                        "file": "Blades/AdminBillingStyles.css",
                                        "content": BladesAdminBillingStylescss
                                    }
                                ],
                                "viewModel": "ResourceProvider$SelectedIsoCurrencySymbolPartViewModel",
                                "partKind": 0,
                                "inputs": [],
                                "bindings": [],
                                "details": [],
                                "initialSize": 8,
                                "supportedSizes": [
                                    8
                                ],
                                "htmlTemplateInline": {
                                    "file": "SelectedIsoCurrencySymbolPart.html",
                                    "content": "<div data-bind=\"pcControl: formSection\" style=\"width: 250px\"></div> <!--<div style=\"height: 50px\">\r\n    <div style=\"display: inline-block; padding-bottom: 4px;\" >Billing Period: </div>\r\n    <div style=\"display: inline-block;\" data-bind=\"pcControl: billingPeriodsDropdown\"></div>\r\n</div>--> "
                                }
                            }
                        }
                    ]
                },
                {
                    "name": "CostComparisonTrendLens",
                    "partInstances": [
                        {
                            "name": "CostComparisonTrendPart",
                            "inline": {
                                "styleSheets": [
                                    {
                                        "file": "Blades/QuotaStyles.css",
                                        "content": BladesQuotaStylescss
                                    },
                                    {
                                        "file": "Blades/AdminBillingStyles.css",
                                        "content": BladesAdminBillingStylescss
                                    }
                                ],
                                "viewModel": "ResourceProvider$CostComparisonTrendViewModel",
                                "partKind": 0,
                                "inputs": [],
                                "bindings": [],
                                "details": [],
                                "initialSize": 8,
                                "supportedSizes": [
                                    8
                                ],
                                "htmlTemplateInline": {
                                    "file": "CostComparisonTrendPart.html",
                                    "content": "<div data-bind=\"pcControl: trendChartCost\" style=\"height: 300px\"></div>"
                                }
                            }
                        }
                    ]
                },
                {
                    "name": "OverviewChartBladeLens",
                    "partInstances": [
                        {
                            "name": "CostPerServiceTypeDonutPart",
                            "inline": {
                                "styleSheets": [],
                                "viewModel": "ResourceProvider$CostPerServiceTypeDonutPartViewModel",
                                "partKind": 28,
                                "inputs": [],
                                "bindings": [],
                                "details": [],
                                "initialSize": 5
                            }
                        }
                    ]
                },
                {
                    "name": "TopUsersByCostChartLens",
                    "partInstances": [
                        {
                            "name": "TopUsersByCostChartPart",
                            "inline": {
                                "styleSheets": [
                                    {
                                        "file": "Blades/QuotaStyles.css",
                                        "content": BladesQuotaStylescss
                                    },
                                    {
                                        "file": "Blades/AdminBillingStyles.css",
                                        "content": BladesAdminBillingStylescss
                                    }
                                ],
                                "viewModel": "ResourceProvider$TopUsersByCostChartPartViewModel",
                                "partKind": 0,
                                "inputs": [],
                                "bindings": [],
                                "details": [],
                                "initialSize": 5,
                                "supportedSizes": [
                                    5
                                ],
                                "htmlTemplateInline": {
                                    "file": "TopUsersByCostChartPart.html",
                                    "content": "<div data-bind=\"pcControl: barChartUser\" style=\"height: 300px\"></div>"
                                }
                            }
                        }
                    ]
                },
                {
                    "name": "OverviewResourceWiseCostChartBladeLens",
                    "partInstances": [
                        {
                            "name": "CostPerResourceChartPart",
                            "inline": {
                                "styleSheets": [
                                    {
                                        "file": "Blades/QuotaStyles.css",
                                        "content": BladesQuotaStylescss
                                    },
                                    {
                                        "file": "Blades/AdminBillingStyles.css",
                                        "content": BladesAdminBillingStylescss
                                    }
                                ],
                                "viewModel": "ResourceProvider$CostPerResourceChartPartViewModel",
                                "partKind": 0,
                                "inputs": [],
                                "bindings": [],
                                "details": [],
                                "initialSize": 8,
                                "supportedSizes": [
                                    8
                                ],
                                "htmlTemplateInline": {
                                    "file": "CostPerResourceChartPart.html",
                                    "content": "<div data-bind=\"pcControl: barChartResource\" style=\"height: 300px\"></div> "
                                }
                            }
                        }
                    ]
                },
                {
                    "name": "OverviewResourceCountPerSubscriptionsChartBladeLens",
                    "partInstances": [
                        {
                            "name": "ResourceCountPerSubscriptionChartPart",
                            "inline": {
                                "styleSheets": [
                                    {
                                        "file": "Blades/QuotaStyles.css",
                                        "content": BladesQuotaStylescss
                                    },
                                    {
                                        "file": "Blades/AdminBillingStyles.css",
                                        "content": BladesAdminBillingStylescss
                                    }
                                ],
                                "viewModel": "ResourceProvider$ResourceCountPerSubscriptionChartPartViewModel",
                                "partKind": 0,
                                "inputs": [],
                                "bindings": [],
                                "details": [],
                                "initialSize": 8,
                                "supportedSizes": [
                                    8
                                ],
                                "htmlTemplateInline": {
                                    "file": "ResourceCountPerSubscriptionChartPart.html",
                                    "content": "<div data-bind=\"pcControl: barChartResource\" style=\"height: 400px\"></div> "
                                }
                            }
                        }
                    ]
                },
                {
                    "isSummary": true,
                    "name": "ResourceProviderResourceSummary",
                    "partInstances": [
                        {
                            "name": "ResourceSummaryPart",
                            "inline": {
                                "styleSheets": [],
                                "viewModel": "ResourceProvider$ResourceProviderResourceSummaryPartViewModel",
                                "partKind": 30,
                                "inputs": [
                                    "resourceId"
                                ],
                                "bindings": [
                                    {
                                        "property": "resourceId",
                                        "valuesFrom": [
                                            {
                                                "referenceType": 3,
                                                "property": "content.id"
                                            }
                                        ]
                                    }
                                ],
                                "details": [
                                    {
                                        "invocationInputArguments": [
                                            {
                                                "valuesFrom": [
                                                    {
                                                        "referenceType": 0,
                                                        "property": "content.selection"
                                                    }
                                                ]
                                            }
                                        ]
                                    },
                                    {
                                        "invocationInputArguments": [
                                            {
                                                "valuesFrom": [
                                                    {
                                                        "referenceType": 0,
                                                        "property": "content.asyncSelection"
                                                    }
                                                ]
                                            }
                                        ]
                                    },
                                    {
                                        "invocationInputArguments": [
                                            {
                                                "valuesFrom": [
                                                    {
                                                        "referenceType": 0,
                                                        "property": "content.tagsSelectable"
                                                    }
                                                ]
                                            }
                                        ]
                                    },
                                    {
                                        "invocationInputArguments": [
                                            {
                                                "valuesFrom": [
                                                    {
                                                        "referenceType": 0,
                                                        "property": "content.accessSelectable"
                                                    }
                                                ]
                                            }
                                        ]
                                    },
                                    {
                                        "invocationInputArguments": [
                                            {
                                                "valuesFrom": [
                                                    {
                                                        "referenceType": 0,
                                                        "property": "content.settingsSelectable"
                                                    }
                                                ]
                                            }
                                        ]
                                    },
                                    {
                                        "invocationInputArguments": [
                                            {
                                                "valuesFrom": [
                                                    {
                                                        "referenceType": 0,
                                                        "property": "content.quickStartSelectable"
                                                    }
                                                ]
                                            }
                                        ]
                                    },
                                    {
                                        "invocationInputArguments": [
                                            {
                                                "valuesFrom": [
                                                    {
                                                        "referenceType": 0,
                                                        "property": "content.keysSelectable"
                                                    }
                                                ]
                                            }
                                        ]
                                    },
                                    {
                                        "invocationInputArguments": [
                                            {
                                                "valuesFrom": [
                                                    {
                                                        "referenceType": 0,
                                                        "property": "content.moveResourceSelection"
                                                    }
                                                ]
                                            }
                                        ],
                                        "outputArguments": [
                                            {
                                                "property": "actionBarOutput",
                                                "valuesFrom": [
                                                    {
                                                        "referenceType": 1,
                                                        "property": "actionBarOutput"
                                                    }
                                                ]
                                            }
                                        ]
                                    }
                                ],
                                "initialSize": 4,
                                "partState": {
                                    "inputIdentityProperties": [
                                        "content.collapsed"
                                    ]
                                }
                            }
                        }
                    ]
                }
            ],
            "viewModelInputs": [
                {
                    "property": "resourceProviderAssetId",
                    "valuesFrom": [
                        {
                            "referenceType": 1,
                            "property": "resourceProviderAssetId"
                        }
                    ]
                }
            ],
            "width": 2,
            "attributes": 0
        };
    })(Main || (Main = {}));
    return Main;
});
