define(["require", "exports", "../Blades/AdminBillingStyles.css", "../Blades/QuotaStyles.css", "../../UserCredits/ViewModels/UserCreditsCollectionBladeViewModel"], function (require, exports, BladesAdminBillingStylescss, BladesQuotaStylescss) {
    "use strict";
    var Main;
    (function (Main) {
        "use strict";
        Main.blade = {
            "name": "UserCreditsCollectionBlade",
            "inputs": [
                "adminSubscriptionId",
                "location"
            ],
            "templateKeyInputs": [
                "adminSubscriptionId"
            ],
            "viewModelName": "UserCredits$UserCreditsCollectionBladeViewModel",
            "lenses": [],
            "width": 1,
            "pinnable": false,
            "templateBlade": {
                "htmlTemplate": null,
                "details": [
                    {
                        "selectablePath": "content.userCreditsGrid.selectableData",
                        "blade": "UserCreditsDetailsBlade",
                        "selectableBindings": [
                            {
                                "property": "subscriptionId",
                                "valuesFrom": [
                                    {
                                        "referenceType": 1,
                                        "property": "adminSubscriptionId"
                                    }
                                ]
                            },
                            {
                                "property": "location",
                                "valuesFrom": [
                                    {
                                        "referenceType": 1,
                                        "property": "location"
                                    }
                                ]
                            },
                            {
                                "property": "selectedUserId",
                                "valuesFrom": [
                                    {
                                        "referenceType": 6,
                                        "property": "UserId"
                                    }
                                ]
                            },
                            {
                                "property": "selectedUserCredits",
                                "valuesFrom": [
                                    {
                                        "referenceType": 6,
                                        "property": "CreditBalance"
                                    }
                                ]
                            },
                            {
                                "property": "selectedCurrency",
                                "valuesFrom": [
                                    {
                                        "referenceType": 6,
                                        "property": "ISOCurrencySymbol"
                                    }
                                ]
                            }
                        ]
                    }
                ],
                "partSize": 0,
                "htmlTemplateInline": {
                    "file": "UserCreditsCollectionBlade.html",
                    "content": "<div data-bind='pcControl: userCreditsGrid'></div>"
                },
                "styleSheets": [
                    {
                        "file": "Blades/QuotaStyles.css",
                        "content": BladesQuotaStylescss
                    },
                    {
                        "file": "Blades/AdminBillingStyles.css",
                        "content": BladesAdminBillingStylescss
                    }
                ]
            },
            "attributes": 0
        };
    })(Main || (Main = {}));
    return Main;
});
